package bar.stundenplan;

import java.util.LinkedList;

/**
 * @author Benjamin A. Bartsch
 */
public class ConfigHTML {

    static final String[] WOCHENTAG = new String[]{"Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag"};

    static void toHtmlTable(int MAX_S, int MAX_T, int MAX_W, String[][][] planS, LinkedList<String> html) {
        String styleTable = "style=\"width: 100%; table-layout:fixed; border: 1px solid black; border-collapse: collapse;\"";
        String sStyle1 = "style=\"width:9%; border: 1px solid black;border-collapse: collapse;\"";
        String sStyle2 = "style=\"width:18%; border: 1px solid black;border-collapse: collapse;\" colspan=\"2\"";

        String sTD1 = "<td " + sStyle1 + ">";
        String sTD2 = "<td " + sStyle2 + ">";

        String sTH1 = "<th " + sStyle1 + ">";
        String sTH2 = "<th " + sStyle2 + ">";
        String sTR = "<tr>";

        html.addLast("<table " + styleTable + ">");

        // table header
        html.addLast(sTR);
        String header = sTH1 + "Stunde</th>";
        for (int i = 0; i < MAX_T; i++) {
            header += sTH2 + WOCHENTAG[i] + "</th>";
        }
        html.addLast(header);
        html.addLast("</tr>");

        // rows
        for (int s = 0; s < MAX_S; s++) {
            html.addLast(sTR);
            html.addLast(sTD1 + (s + 1) + ". </td>");
            for (int t = 0; t < MAX_T; t++) {
                if (planS[s][t][0].equals(planS[s][t][1])) {
                    html.addLast(sTD2 + planS[s][t][0] + "</td>");
                } else {
                    if (planS[s][t][0].trim().isEmpty()) {
                        planS[s][t][0] = "-----";
                    }
                    if (planS[s][t][1].trim().isEmpty()) {
                        planS[s][t][1] = "-----";
                    }
                    html.addLast(sTD1 + planS[s][t][0] + "</td>");
                    html.addLast(sTD1 + planS[s][t][1] + "</td>");
                }
            }
            html.addLast("</tr>");
        }

        html.addLast("</table>");
    }

    static String millisToString(long millis) {
        long iSek = (millis / 1000) % 60;
        long iMin = ((millis / 1000) / 60) % 60;
        long iStd = ((millis / 1000) / 60) / 60;
        String sStd = iStd == 0 ? " " : iStd == 1 ? " 1 std" : " " + iStd + " std";
        String sMin = iMin == 0 ? " " : iMin == 1 ? " 1 min" : " " + iMin + " min";
        String sSek = iSek == 0 ? " " : iSek == 1 ? " 1 sek" : " " + iSek + " sek";
        String sMillis = sStd + sMin + sSek;
        if (sMillis.isBlank()) {
            sMillis = " 0 sek";
        }
        return sMillis.trim();
    }

}
