package bar.stundenplan;

/**
 * @author Benjamin A. Bartsch
 */
public final class D_Berechnung {

    final int id;
    final int status;
    final long millis;
    final int max_t;
    final int max_s;

    D_Berechnung(int id, int p_status, long p_millis, int p_max_t, int p_max_s) {
        this.id = id;
        this.status = p_status;
        this.millis = p_millis;
        this.max_t = p_max_t;
        this.max_s = p_max_s;
    }

    @Override
    public String toString() {
        String sStatus = " (...)";
        
        if (status == 1) {
            sStatus = " (SAT)";
        }
        
        if (status == -1) {
            sStatus = " (UNSAT)";
        }

        String sTime = "";
        if (status != 0) {
            sTime = " (" + ConfigHTML.millisToString(millis) + ")";
        }

        return "Nr." + id + sStatus + sTime;
    }

    @Override
    public int hashCode() {
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final D_Berechnung other = (D_Berechnung) obj;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }

}
