package bar.stundenplan;

import java.util.HashMap;
import java.util.LinkedList;

/**
 * @author Benjamin A. Bartsch
 */
public final class D_Kurs {

    final int id;
    final String ergaenzung;
    final LinkedList<D_Lehrkraft> le_list;
    final LinkedList<D_Lehrkraft> le_list_hosp;
    final LinkedList<D_Klasse> kl_list;
    final LinkedList<D_Fach> fa_list;
    final LinkedList<D_Raum> ra_list;
    final LinkedList<D_Kopplung> ko_list;
    final HashMap<Integer, D_Kurs> nicht_gleicher_tag_wie;
    final RowMap<D_Stunde> st_map = new RowMap<>();
    int stunden;
    final String plan;
    final int vertretungsreserven;
    final int nicht_aufeinanderfolgend;

    public D_Kurs(int p_id, String p_ergaenzung, String plan, int vertretungsreserven, int nicht_aufeinanderfolgend) {
        this.id = p_id;
        this.ergaenzung = p_ergaenzung;
        this.le_list = new LinkedList<>();
        this.le_list_hosp = new LinkedList<>();
        this.kl_list = new LinkedList<>();
        this.fa_list = new LinkedList<>();
        this.ra_list = new LinkedList<>();
        this.ko_list = new LinkedList<>();
        this.nicht_gleicher_tag_wie = new HashMap<>();
        this.stunden = 0;
        this.plan = plan;
        this.vertretungsreserven = vertretungsreserven;
        this.nicht_aufeinanderfolgend = nicht_aufeinanderfolgend;
    }

    @Override
    public String toString() {
        String sLe = "";
        for (D_Lehrkraft le : le_list) {
            sLe += (sLe.isEmpty() ? "" : ",") + le.kuerzel;
        }

        String sKl = "";
        for (D_Klasse kl : kl_list) {
            sKl += (sKl.isEmpty() ? "" : ",") + kl.kuerzel;
        }

        String sFa = "";
        for (D_Fach fa : fa_list) {
            sFa += (sFa.isEmpty() ? "" : ",") + fa.kuerzel;
        }

        String sRa = "";
        for (D_Raum ra : ra_list) {
            sRa += (sRa.isEmpty() ? "" : ",") + ra.kuerzel;
        }

        String sKo = "";
        for (D_Kopplung ko : ko_list) {
            sKo += (sKo.isEmpty() ? "" : ",") + ko.kuerzel;
        }

        return "|" + sKl + (sKo.isEmpty() ? "" : "|" + sKo) + "|" + sLe + "|" + sFa + "|×" + stunden + "|" + sRa + "|" + ergaenzung;
    }

    @Override
    public int hashCode() {
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final D_Kurs other = (D_Kurs) obj;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }

}
