package bar.stundenplan;

import java.util.LinkedList;

/**
 * @author Benjamin A. Bartsch
 */
public class D_Kurs_SOL {

    final int id;
    final String ergaenzung;
    final int vertretungsreserven;
    final LinkedList<D_Stunde_SOL> mySt = new LinkedList<>();
    final LinkedList<D_Lehrkraft_SOL> myLe = new LinkedList<>();
    final LinkedList<D_Lehrkraft_SOL> myLeHosp = new LinkedList<>();
    final LinkedList<D_Klasse_SOL> myKl = new LinkedList<>();
    final LinkedList<D_Fach_SOL> myFa = new LinkedList<>();
    final LinkedList<D_Raum_SOL> myRa = new LinkedList<>();
    final LinkedList<D_Kopplung_SOL> myKo = new LinkedList<>();

    public D_Kurs_SOL(int id, String ergaenzung, int vertretungsreserven) {
        this.id = id;
        this.ergaenzung = ergaenzung;
        this.vertretungsreserven = vertretungsreserven;
    }

    String get_zelle_all(int w, int t, int s) {
        String text = "";
        for (D_Stunde_SOL plan : mySt) {
            if ((plan.w == w) && (plan.t == t) && (plan.s == s)) {
                text += get_string_kl()  + get_string_le()  + get_string_fa()  + get_string_ra();

            }
        }
        return text;
    }

    String get_zelle_le(int w, int t, int s, D_Lehrkraft_SOL le_sol) {
        String text = "";
        for (D_Stunde_SOL plan : mySt) {
            if ((plan.w == w) && (plan.t == t) && (plan.s == s)) {
                if (myLeHosp.contains(le_sol)) {
                    text += get_string_kl() + get_string_ko()  + get_string_fa()  + get_string_ra() + "***";
                } else {
                    text += get_string_kl() + get_string_ko()  + get_string_fa()  + get_string_ra() + "";
                }
            }
        }
        return text;
    }

    String get_zelle_kl(int w, int t, int s) {
        String text = "";
        for (D_Stunde_SOL plan : mySt) {
            if ((plan.w == w) && (plan.t == t) && (plan.s == s)) {
                text += get_string_le()  + get_string_fa()  + get_string_ra();
            }
        }
        return text;
    }

    String get_zelle_ra(int w, int t, int s) {
        String text = "";
        for (D_Stunde_SOL st_sol : mySt) {
            if ((st_sol.w == w) && (st_sol.t == t) && (st_sol.s == s)) {
                text += get_string_le()  + get_string_kl()  + get_string_fa();
            }
        }
        return text;
    }

    private String get_string_kl() {
        String s = "";
        for (D_Klasse_SOL kl_er : myKl) {
            s += (s.isEmpty() ? " " : ", ") + kl_er.kuerzel;
        }
        return s;
    }

    private String get_string_le() {
        String s = "";
        for (D_Lehrkraft_SOL le_er : myLe) {
            s += (s.isEmpty() ? " " : ", ") + le_er.kuerzel;
        }
        return s;
    }

    private String get_string_ra() {
        String s = "";
        for (D_Raum_SOL ra_sol : myRa) {
            s += (s.isEmpty() ? " " : ", ") + ra_sol.kuerzel;
        }
        return s;
    }

    private String get_string_fa() {
        String s = "";
        for (D_Fach_SOL fa_sol : myFa) {
            s += (s.isEmpty() ? " " : ", ") + fa_sol.kuerzel;
        }
        return s;
    }

    private String get_string_ko() {
        String s = "";
        for (D_Kopplung_SOL ko_sol : myKo) {
            s += (s.isEmpty() ? " " : ", ") + ko_sol.kuerzel;
        }
        return s;
    }

    int get_vertretungsreserven(int w, int s, int t) {
        for (D_Stunde_SOL plan : mySt) {
            if ((plan.w == w) && (plan.t == t) && (plan.s == s)) {
                return vertretungsreserven;
            }
        }
        return 0;
    }

    boolean hat_unterricht(int w, int t, int s) {
        for (D_Stunde_SOL st_sol : mySt) {
            if ((st_sol.w == w) && (st_sol.t == t) && (st_sol.s == s)) {
                return true;
            }
        }
        return false;
    }

    boolean hat_unterricht_am(int w, int t, int max_s) {
        for (int s = 0; s < max_s; s++) {
            if (hat_unterricht(w, t, s)) {
                return true;
            }
        }
        return false;
    }

    boolean ist_aufeinanderfolgend(int max_w, int max_t, int max_s, int taegig) {
        int tage = 0;
        for (int t = 0; t < max_t; t++) {
            int summe = 0;
            for (int w = 0; w < max_w; w++) {
                if (hat_unterricht_am(w, t, max_s)) {
                    summe++;
                }
            }
            if (summe > 0) {
                tage++;
            }
        }

        if (tage != taegig) {
            return false;
        }

        boolean last = hat_unterricht_am(max_w - 1, max_t - 1, max_s); // letzter tag
        for (int w = 0; w < max_w; w++) {
            for (int t = 0; t < max_t; t++) {
                boolean current = hat_unterricht_am(w, t, max_s); // jetziger tag
                if (last && current) {
                    return true;
                }
                last = current;
            }
        }
        return false;
    }

    String get_name_all() {
        return get_string_kl()  + get_string_le()  + get_string_fa()  + get_string_ra();
    }

}
