package bar.stundenplan;

import java.util.LinkedList;

/**
 * @author Benjamin A. Bartsch
 */
public class D_Lehrkraefte_SAT {

    final int id;
    final int MAX_T;
    final int MAX_S;

    final String plan;

    final int[][][] planWTS;

    final LinkedList<D_Lehrkraft_SAT> myLe = new LinkedList<>();

    public D_Lehrkraefte_SAT(int MAX_T, int MAX_S, D_Lehrkraefte lea) {
        this.id = lea.id;
        this.MAX_T = MAX_T;
        this.MAX_S = MAX_S;
        this.plan = lea.plan;
        this.planWTS = new int[2][MAX_T][MAX_S];
    }

    void cnf_pre(SatWrapper sw) {
        // this
        sw.c_fill_var(planWTS);
    }

    void cnf_post(SatWrapper sw) throws Exception {
        // this: planWTS
        for (int w = 0; w < 2; w++) {
            for (int t = 0; t < MAX_T; t++) {
                for (int s = 0; s < MAX_S; s++) {
                    // planWTS
                    LinkedList<Integer> list = new LinkedList<>();
                    for (D_Lehrkraft_SAT le_sat : myLe) {
                        list.addLast(le_sat.planWTS[w][t][s]);
                    }
                    int root = sw.c_OR_tree(list);
                    sw.c_equal(root, planWTS[w][t][s]);
                }
            }
        }
        // plan
        sw.c_plan(plan, planWTS, MAX_T, MAX_S, false, false, false, false, false, false, false);
    }

    @Override
    public int hashCode() {
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final D_Lehrkraefte_SAT other = (D_Lehrkraefte_SAT) obj;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }
    
    
    
}
