package bar.stundenplan;

import java.util.HashMap;

/**
 * @author Benjamin A. Bartsch
 */
public final class D_Lehrkraft {

    final int id;
    final String kuerzel;
    final String anzeigename;
    final String bemerkung;
    final int darf_vertreten;
    final int freie_tage;
    final int mind_x_ab_stunde;
    final int mind_y_ab_stunde;
    final int mind_x_bis_stunde;
    final int mind_y_bis_stunde;
    final int spring_pro_tag_check;
    final int spring_pro_tag_wert;
    final int spring_pro_woche_check;
    final int spring_pro_woche_wert;
    final int tagesstunden_check;
    final int tagesstunden_wert;
    final String plan;
    final int min_stunden_check;
    final int min_stunden_wert;
    final int max_stunden_folge_check;
    final int max_stunden_folge_wert;

    final HashMap<Integer, D_Kurs> mapKu2 = new HashMap<>();
    final HashMap<Integer, D_Kurs> mapKuHosp2 = new HashMap<>();

    int stunden;

    public D_Lehrkraft(
            int id,
            String kuerzel,
            String anzeigename,
            String bemerkung,
            int darf_vertreten,
            int freie_tage,
            int mind_x_ab_stunde,
            int mind_y_ab_stunde,
            int mind_x_bis_stunde,
            int mind_y_bis_stunde,
            int spring_pro_tag_check,
            int spring_pro_tag_wert,
            int spring_pro_woche_check,
            int spring_pro_woche_wert,
            int tagesstunden_check,
            int tagesstunden_wert,
            String plan,
            int min_stunden_check,
            int min_stunden_wert,
            int max_stunden_folge_check,
            int max_stunden_folge_wert
    ) {
        this.id = id;
        this.kuerzel = kuerzel;
        this.anzeigename = anzeigename;
        this.bemerkung = bemerkung;
        this.darf_vertreten = darf_vertreten;
        this.freie_tage = freie_tage;
        this.mind_x_ab_stunde = mind_x_ab_stunde;
        this.mind_y_ab_stunde = mind_y_ab_stunde;
        this.mind_x_bis_stunde = mind_x_bis_stunde;
        this.mind_y_bis_stunde = mind_y_bis_stunde;
        this.spring_pro_tag_check = spring_pro_tag_check;
        this.spring_pro_tag_wert = spring_pro_tag_wert;
        this.spring_pro_woche_check = spring_pro_woche_check;
        this.spring_pro_woche_wert = spring_pro_woche_wert;
        this.tagesstunden_check = tagesstunden_check;
        this.tagesstunden_wert = tagesstunden_wert;
        this.plan = plan;
        this.min_stunden_check = min_stunden_check;
        this.min_stunden_wert = min_stunden_wert;
        this.max_stunden_folge_check = max_stunden_folge_check;
        this.max_stunden_folge_wert = max_stunden_folge_wert;
        this.stunden = 0;
    }

    @Override
    public String toString() {
        return kuerzel + " (" + stunden + " ws)";
    }

    @Override
    public int hashCode() {
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final D_Lehrkraft other = (D_Lehrkraft) obj;
        return this.id == other.id;
    }

}
