package bar.stundenplan;

import java.util.LinkedList;

/**
 * @author Benjamin A. Bartsch
 */
public class D_Lehrkraft_SOL {

    final int id;
    final String kuerzel;
    final String anzeigename;
    final LinkedList<D_Kurs_SOL> myKu = new LinkedList<>();
    final LinkedList<D_Kurs_SOL> myKuHosp = new LinkedList<>();
    final boolean darf_vertreten;

    public D_Lehrkraft_SOL(int id, String kuerzel, String anzeigename, int darf_vertreten) {
        this.id = id;
        this.kuerzel = kuerzel;
        this.anzeigename = anzeigename;
        this.darf_vertreten = darf_vertreten == 1;
    }

    int get_vertretungsoption(int w, int t, int s, int max_s) {
        if (!darf_vertreten) {
            return 0;
        }
        if (hat_unterricht(w, t, s, max_s)) {
            return 0;
        }
        if (!hat_unterricht(w, t, s - 1, max_s) && !hat_unterricht(w, t, s - 2, max_s)) {
            return 0;
        }
        if (!hat_unterricht(w, t, s + 1, max_s) && !hat_unterricht(w, t, s + 2, max_s)) {
            return 0;
        }
        if (gib_gesamt_stunden_am(w, t, max_s) > 6) {
            return 0;
        }
        return 1;
    }

    private boolean hat_unterricht(int w, int t, int s, int max_s) {
        if (s < 0) {
            return true;
        }
        if (s >= max_s) {
            return true;
        }
        for (D_Kurs_SOL ku : myKu) {
            if (ku.hat_unterricht(w, t, s)) {
                return true;
            }
        }
        return false;
    }

    int gib_einzelstunden(int max_w, int max_t, int max_s) {
        int summe = 0;
        for (int w = 0; w < max_w; w++) {
            for (int t = 0; t < max_t; t++) {
                if (gib_gesamt_stunden_am(w, t, max_s) == 1) {
                    summe++;
                }
            }
        }
        return summe;
    }

    int gib_gesamt_stunden_am(int w, int t, int max_s) {
        int summe = 0;
        for (int s = 0; s < max_s; s++) {
            if (hat_unterricht(w, t, s, max_s)) {
                summe++;
            }
        }
        return summe;
    }

    int gib_groesste_folge_am(int w, int t, int max_s) {
        int max = 0;
        int current = 0;
        for (int s = 0; s < max_s; s++) {

            if (hat_unterricht(w, t, s, max_s)) {
                current++;
            } else {
                max = Math.max(max, current);
                current = 0;
            }
        }
        max = Math.max(max, current);
        return max;
    }

    int gib_groesste_praesenz_am(int w, int t, int max_s) {
        for (int s1 = 0; s1 < max_s; s1++) {
            if (hat_unterricht(w, t, s1, max_s)) {
                for (int s2 = max_s - 1; s2 >= s1; s2--) {
                    if (hat_unterricht(w, t, s2, max_s)) {
                        return s2 - s1 + 1;
                    }
                }
            }
        }
        return 0;
    }

    int gib_groesste_stunden_folge(int max_w, int max_t, int max_s) {
        int max = 0;
        for (int w = 0; w < max_w; w++) {
            for (int t = 0; t < max_t; t++) {
                max = Math.max(max, gib_groesste_folge_am(w, t, max_s));
            }
        }
        return max;
    }

    int gib_groesste_praesenz_folge(int max_w, int max_t, int max_s) {
        int max = 0;
        for (int w = 0; w < max_w; w++) {
            for (int t = 0; t < max_t; t++) {
                max = Math.max(max, gib_groesste_praesenz_am(w, t, max_s));
            }
        }
        return max;
    }

    int gib_groesste_springstunden_tag(int max_w, int max_t, int max_s) {
        int max = 0;
        for (int w = 0; w < max_w; w++) {
            for (int t = 0; t < max_t; t++) {
                max = Math.max(max, gib_springstunden_am(w, t, max_s));
            }
        }
        return max;
    }

    int gib_springstunden_am(int w, int t, int max_s) {
        for (int s1 = 0; s1 < max_s; s1++) {
            if (hat_unterricht(w, t, s1, max_s)) {
                for (int s2 = max_s - 1; s2 >= s1; s2--) {
                    if (hat_unterricht(w, t, s2, max_s)) {
                        int summe = 0;
                        for (int s = s1; s <= s2; s++) {
                            if (!hat_unterricht(w, t, s, max_s)) {
                                summe++;
                            }
                        }
                        return summe;
                    }
                }
            }
        }
        return 0;
    }

    int gib_groesste_springstunden_woche(int max_w, int max_t, int max_s) {
        int sum = 0;
        for (int w = 0; w < max_w; w++) {
            for (int t = 0; t < max_t; t++) {
                sum += gib_springstunden_am(w, t, max_s);
            }
        }
        return sum;
    }

    void erzeuge_ausgabe(LinkedList<String> html, int MAX_W, int MAX_T, int MAX_S) {
        html.addLast("<h2>Lehrkraft: " + kuerzel + "</h2>");

        String[][][] planS = new String[MAX_S][MAX_T][MAX_W];
        for (int w = 0; w < MAX_W; w++) {
            for (int t = 0; t < MAX_T; t++) {
                for (int s = 0; s < MAX_S; s++) {
                    planS[s][t][w] = "";
                    for (D_Kurs_SOL ku_sol : myKu) {
                        planS[s][t][w] += ku_sol.get_zelle_le(w, t, s, this);
                    }
                    for (D_Kurs_SOL ku_sol : myKuHosp) {
                        planS[s][t][w] += ku_sol.get_zelle_le(w, t, s, this);
                    }
                }
            }
        }

        ConfigHTML.toHtmlTable(MAX_S, MAX_T, MAX_W, planS, html);
    }

}
