package bar.stundenplan;

import java.util.LinkedList;

/**
 * @author Benjamin A. Bartsch
 */
public class D_Raum_SAT {

    final int MAX_T;
    final int MAX_S;

    final int id;
    final String kuerzel;
    final String plan;

    final int[][][] planWTS; // Woche, Tag, Stunde
    final int[][] planWT_ist_am; // Unterricht ist am Tag ...

    final LinkedList<D_Kurs_SAT> myKu = new LinkedList<>();

    public D_Raum_SAT(int MAX_TAGE, int MAX_STUNDEN, D_Raum ra) {
        this.MAX_T = MAX_TAGE;
        this.MAX_S = MAX_STUNDEN;

        this.id = ra.id;
        this.kuerzel = ra.kuerzel;
        this.plan = ra.plan;
        
        this.planWTS = new int[2][MAX_TAGE][MAX_STUNDEN];
        this.planWT_ist_am = new int[2][MAX_TAGE];
    }

    void cnf_pre(SatWrapper sw) {
        // this
        sw.c_fill_var(planWTS);
        sw.c_fill_var(planWT_ist_am);
    }

    void cnf_post(SatWrapper sw) throws Exception {
        // this: Maximal ein Kurs pro Zelle, FALLS Kurs im Raum!
        for (int w = 0; w < 2; w++) {
            for (int t = 0; t < MAX_T; t++) {
                for (int s = 0; s < MAX_S; s++) {
                    LinkedList<Integer> list = new LinkedList<>();
                    for (D_Kurs_SAT ku_sat : myKu) {
                        int x = ku_sat.planWTS[w][t][s];
                        int y = ku_sat.planR.get(this);
                        int z = sw.c_new_var_AND(x, y);
                        list.addLast(z);
                    }
                    int root = sw.c_at_most_one_tree(list);
                    sw.c_equal(root, planWTS[w][t][s]);
                }
            }
        }

        // plan
        sw.c_plan(plan, planWTS, MAX_T, MAX_S, false, false, false, false, false, false, false);
    }

    @Override
    public int hashCode() {
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final D_Raum_SAT other = (D_Raum_SAT) obj;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }
    
    
}
