package bar.stundenplan;

import java.util.LinkedList;

/**
 * @author Benjamin A. Bartsch
 */
public class D_Schule_SAT {

    final int id;
    final int MAX_W;
    final int MAX_S;
    final int MAX_T;
    final int[][][] planWTS; // Woche, Tag, Stunde
    final RowMap<D_Lehrkraft_SAT> myLe = new RowMap<>();
    final RowMap<D_Klasse_SAT> myKl = new RowMap<>();
    final RowMap<D_Kurs_SAT> myKu = new RowMap<>();
    final RowMap<D_Fach_SAT> myFa = new RowMap<>();
    final RowMap<D_Raum_SAT> myRa = new RowMap<>();
    final RowMap<D_Kopplung_SAT> myKo = new RowMap<>();
    final D_Lehrkraefte_SAT myLea;
    final D_Klassen_SAT myKla;
    final D_Raeume_SAT myRaa;
    final D_Kopplungen_SAT myKoa;
    final D_Kurse_SAT myKua;
    final D_Berechnungen_SAT myBea;
    final String plan;
    final boolean keine_einzelstunde_in_1;
    final boolean keine_einzelstunde_in_2;
    final boolean keine_einzelstunde_in_3;
    final boolean keine_einzelstunde_in_4;
    final boolean keine_einzelstunde_in_5;
    final boolean keine_einzelstunde_in_6;
    final String planV;
    final boolean keinen_uebergang_1_2;
    final boolean keinen_uebergang_2_3;
    final boolean keinen_uebergang_3_4;
    final boolean keinen_uebergang_4_5;
    final boolean keinen_uebergang_5_6;
    final boolean keinen_uebergang_6_7;
    final boolean keinen_uebergang_7_8;
    final String planO;
    final int min_stunden_le;
    final int min_aufeinanderfolgend;

    public D_Schule_SAT(D_Schule sc, D_Lehrkraefte lea, D_Klassen kla, D_Raeume raa, D_Kopplungen koa, D_Kurse kua, D_Berechnungen bea, RowMap<D_Kurs> map_ku, RowMap<D_Lehrkraft> map_le, RowMap<D_Klasse> map_kl, RowMap<D_Fach> map_fa, RowMap<D_Raum> map_ra, RowMap<D_Kopplung> map_ko) throws Exception {
        id = sc.id;
        MAX_S = sc.max_s;
        MAX_T = sc.max_t;
        MAX_W = 2;
        planWTS = new int[MAX_W][MAX_T][MAX_S];
        plan = sc.plan;
        keine_einzelstunde_in_1 = sc.keine_einzelstunde_in_1;
        keine_einzelstunde_in_2 = sc.keine_einzelstunde_in_2;
        keine_einzelstunde_in_3 = sc.keine_einzelstunde_in_3;
        keine_einzelstunde_in_4 = sc.keine_einzelstunde_in_4;
        keine_einzelstunde_in_5 = sc.keine_einzelstunde_in_5;
        keine_einzelstunde_in_6 = sc.keine_einzelstunde_in_6;
        planV = sc.planV;
        keinen_uebergang_1_2 = sc.keinen_uebergang_1_2;
        keinen_uebergang_2_3 = sc.keinen_uebergang_2_3;
        keinen_uebergang_3_4 = sc.keinen_uebergang_3_4;
        keinen_uebergang_4_5 = sc.keinen_uebergang_4_5;
        keinen_uebergang_5_6 = sc.keinen_uebergang_5_6;
        keinen_uebergang_6_7 = sc.keinen_uebergang_6_7;
        keinen_uebergang_7_8 = sc.keinen_uebergang_7_8;
        planO = sc.planO;
        min_stunden_le = sc.min_stunden_le;
        min_aufeinanderfolgend = sc.min_aufeinanderfolgend;

        myLea = new D_Lehrkraefte_SAT(MAX_T, MAX_S, lea);
        myKla = new D_Klassen_SAT(MAX_T, MAX_S, kla);
        myRaa = new D_Raeume_SAT(MAX_T, MAX_S, raa);
        myKoa = new D_Kopplungen_SAT(MAX_T, MAX_S, koa);
        myKua = new D_Kurse_SAT(MAX_T, MAX_S, kua);
        myBea = new D_Berechnungen_SAT(id, bea);

        // Lehrkräfte kopieren
        for (int row = 0; row < map_le.size(); row++) {
            D_Lehrkraft le = map_le.get_obj_with_row(row);
            D_Lehrkraft_SAT le_sat = new D_Lehrkraft_SAT(MAX_T, MAX_S, le, sc);
            myLe.put(le.id, le_sat);
            myLea.myLe.addLast(le_sat);
        }

        // Klassen kopieren
        for (int row = 0; row < map_kl.size(); row++) {
            D_Klasse kl = map_kl.get_obj_with_row(row);
            D_Klasse_SAT kl_sat = new D_Klasse_SAT(MAX_T, MAX_S, kl);
            myKl.put(kl.id, kl_sat);
            myKla.myKl.addLast(kl_sat);
        }

        // Fächer kopieren
        for (int row = 0; row < map_fa.size(); row++) {
            D_Fach fa = map_fa.get_obj_with_row(row);
            D_Fach_SAT fa_sat = new D_Fach_SAT(MAX_T, MAX_S, fa);
            myFa.put(fa.id, fa_sat);
        }

        // Räume kopieren
        for (int row = 0; row < map_ra.size(); row++) {
            D_Raum ra = map_ra.get_obj_with_row(row);
            D_Raum_SAT ra_sat = new D_Raum_SAT(MAX_T, MAX_S, ra);
            myRa.put(ra.id, ra_sat);
            myRaa.myRa.addLast(ra_sat);
        }

        // Kopplungen kopieren
        for (int row = 0; row < map_ko.size(); row++) {
            D_Kopplung ko = map_ko.get_obj_with_row(row);
            D_Kopplung_SAT ko_sat = new D_Kopplung_SAT(MAX_T, MAX_S, ko);
            myKo.put(ko.id, ko_sat);
            myKoa.myKo.addLast(ko_sat);
        }

        // Kurse kopieren
        for (int row = 0; row < map_ku.size(); row++) {
            // Kurs-Kopie erzeugt Stunden-Kopie
            D_Kurs ku = map_ku.get_obj_with_row(row);
            D_Kurs_SAT ku_sat = new D_Kurs_SAT(MAX_T, MAX_S, ku);
            myKu.put(ku.id, ku_sat);
            // Kurs vs. Lehrkraft
            for (D_Lehrkraft le : ku.le_list) {
                D_Lehrkraft_SAT le_sat = myLe.get_obj_with_id(le.id);
                le_sat.myKu.addLast(ku_sat);
            }
            // Kurs vs. Hosp
            for (D_Lehrkraft le : ku.le_list_hosp) {
                D_Lehrkraft_SAT le_sat = myLe.get_obj_with_id(le.id);
                le_sat.myKuHosp.addLast(ku_sat);
            }
            // Kurs vs. Klasse
            for (D_Klasse kl : ku.kl_list) {
                D_Klasse_SAT kl_sat = myKl.get_obj_with_id(kl.id);
                kl_sat.myKu.addLast(ku_sat);
            }
            // Kurs vs. Fach
            for (D_Fach fa : ku.fa_list) {
                D_Fach_SAT fa_sat = myFa.get_obj_with_id(fa.id);
                fa_sat.myKu.addLast(ku_sat);
            }
            // Kurs vs. Raum
            for (D_Raum ra : ku.ra_list) {
                D_Raum_SAT ra_sat = myRa.get_obj_with_id(ra.id);
                ra_sat.myKu.addLast(ku_sat);
                ku_sat.planR.put(ra_sat, -1);
            }
            // Kurs vs. Kopplung
            for (D_Kopplung ko : ku.ko_list) {
                D_Kopplung_SAT ko_sat = myKo.get_obj_with_id(ko.id);
                ko_sat.myKu.addLast(ku_sat);
                ku_sat.myKo = ko_sat;
            }
            // Kurs --> Kurse
            myKua.myKu.addLast(ku_sat);
        }

        // Kurs-Kurs-Referenzen kopieren
        for (D_Kurs ku_1 : map_ku.rows()) {
            for (D_Kurs ku_2 : ku_1.nicht_gleicher_tag_wie.values()) {
                D_Kurs_SAT ku_sat_1 = myKu.get_obj_with_id(ku_1.id);
                D_Kurs_SAT ku_sat_2 = myKu.get_obj_with_id(ku_2.id);
                ku_sat_1.nicht_gleicher_tag_wie.addLast(ku_sat_2);
            }
        }

    }

    
    @Override
    public int hashCode() {
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final D_Schule_SAT other = (D_Schule_SAT) obj;
        if (this.id != other.id) {
            return false;
        }
        return true;
    }
    
    void cnf_pre(SatWrapper sw) {
        // this
        for (int w = 0; w < MAX_W; w++) {
            for (int t = 0; t < MAX_T; t++) {
                for (int s = 0; s < MAX_S; s++) {
                    planWTS[w][t][s] = sw.c_new_var();
                }
            }
        }

        // Kurse alle
        myKua.cnf_pre(sw);

        // Kurse 
        for (int row = 0; row < myKu.size(); row++) {
            D_Kurs_SAT ku = myKu.get_obj_with_row(row);
            ku.cnf_pre(sw);
        }

        // Lehrkräfte alle
        myLea.cnf_pre(sw);

        // Lehrkräfte
        for (int row = 0; row < myLe.size(); row++) {
            D_Lehrkraft_SAT le = myLe.get_obj_with_row(row);
            le.cnf_pre(sw);
        }

        // Klassen alle
        myKla.cnf_pre(sw);

        // Klassen
        for (int row = 0; row < myKl.size(); row++) {
            D_Klasse_SAT kl = myKl.get_obj_with_row(row);
            kl.cnf_pre(sw);
        }

        // Fächer
        for (int row = 0; row < myFa.size(); row++) {
            D_Fach_SAT fa = myFa.get_obj_with_row(row);
            fa.cnf_pre(sw);
        }

        // Räume alle
        myRaa.cnf_pre(sw);

        // Räume
        for (int row = 0; row < myRa.size(); row++) {
            D_Raum_SAT ra = myRa.get_obj_with_row(row);
            ra.cnf_pre(sw);
        }

        // Kopplungen alle
        myKoa.cnf_pre(sw);

        // Kopplungen
        for (int row = 0; row < myKo.size(); row++) {
            D_Kopplung_SAT ko = myKo.get_obj_with_row(row);
            ko.cnf_pre(sw);
        }

    }

    void cnf_post(SatWrapper sw) throws Exception {
        // this: OR of Kurse
        for (int w = 0; w < MAX_W; w++) {
            for (int t = 0; t < MAX_T; t++) {
                for (int s = 0; s < MAX_S; s++) {
                    LinkedList<Integer> list = new LinkedList<>();
                    for (int row = 0; row < myKu.size(); row++) {
                        D_Kurs_SAT ku = myKu.get_obj_with_row(row);
                        list.addLast(ku.planWTS[w][t][s]);
                    }
                    int root = sw.c_OR_tree(list);
                    sw.c_equal(root, planWTS[w][t][s]);
                }
            }
        }

        // Kurse alle
        myKua.cnf_post(sw);

        // Kurse 
        for (int row = 0; row < myKu.size(); row++) {
            D_Kurs_SAT ku = myKu.get_obj_with_row(row);
            ku.cnf_post(sw, this);
        }

        // Lehrkräfte alle
        myLea.cnf_post(sw);

        // Lehrkräfte
        for (int row = 0; row < myLe.size(); row++) {
            D_Lehrkraft_SAT le = myLe.get_obj_with_row(row);
            le.cnf_post(sw, myBea);
        }

        // Klassen alle
        myKla.cnf_post(sw);

        // Klassen
        for (int row = 0; row < myKl.size(); row++) {
            D_Klasse_SAT kl = myKl.get_obj_with_row(row);
            kl.cnf_post(sw);
        }

        // Fächer
        for (int row = 0; row < myFa.size(); row++) {
            D_Fach_SAT fa = myFa.get_obj_with_row(row);
            fa.cnf_post(sw);
        }

        // Räume alle
        myRaa.cnf_post(sw);

        // Räume
        for (int row = 0; row < myRa.size(); row++) {
            D_Raum_SAT ra = myRa.get_obj_with_row(row);
            ra.cnf_post(sw);
        }

        // Kopplungen alle
        myKoa.cnf_post(sw);

        // Kopplungen
        for (int row = 0; row < myKo.size(); row++) {
            D_Kopplung_SAT ko = myKo.get_obj_with_row(row);
            ko.cnf_post(sw, this);
        }

        // plan
        sw.c_plan(plan, planWTS, MAX_T, MAX_S, false, false, false, false, false, false, false);

        // planV
        
        LinkedList<Integer>[][][] planWTS_listV = new LinkedList[MAX_W][MAX_T][MAX_S];
        for (int w = 0; w < MAX_W; w++) {
            for (int t = 0; t < MAX_T; t++) {
                for (int s = 0; s < MAX_S; s++) {
                    LinkedList<Integer> list = new LinkedList<>();
                    for (int row = 0; row < myKu.size(); row++) {
                        D_Kurs_SAT ku = myKu.get_obj_with_row(row);
                        for (int i = 0; i < ku.vertretungsreserven; i++) {
                            list.addLast(ku.planWTS[w][t][s]);
                        }
                    }
                    planWTS_listV[w][t][s] = list;
                }
            }
        }
        sw.c_planV(planV, planWTS_listV, MAX_T, MAX_S);


        // planO (Vertretungsoptionen)
         
        LinkedList<Integer>[][][] planWTS_listO = new LinkedList[MAX_W][MAX_T][MAX_S];
        for (int w = 0; w < MAX_W; w++) {
            for (int t = 0; t < MAX_T; t++) {
                for (int s = 0; s < MAX_S; s++) {
                    LinkedList<Integer> list = new LinkedList<>();
                    for (int row = 0; row < myLe.size(); row++) {
                        D_Lehrkraft_SAT le = myLe.get_obj_with_row(row);
                        if (le.darf_vertreten) {
                            list.addLast(le.planWTS_vertretungsoption[w][t][s]);
                        }
                    }
                    planWTS_listO[w][t][s] = list;
                }
            }
        }
        sw.c_planV(planO, planWTS_listO, MAX_T, MAX_S);

         
        // min_aufeinanderfolgend
        
        if (min_aufeinanderfolgend > 0) {
            LinkedList listMindestens = new LinkedList();

            for (int row = 0; row < myKu.size(); row++) {
                D_Kurs_SAT ku = myKu.get_obj_with_row(row);
                if (ku.mySt.size() == 2) {
                    LinkedList listAufeinanderfolgend = new LinkedList(); // enthählt TRUE, falls aufeinanderfolgend

                    LinkedList<Integer> listWT = new LinkedList<>(); // list of wochentage
                    for (int w = 0; w < MAX_W; w++) {
                        for (int t = 0; t < MAX_T; t++) {
                            listWT.addLast(ku.planWT_ist_am[w][t]);
                        }
                    }
                    for (int i = 0; i < listWT.size(); i++) {
                        listAufeinanderfolgend.addLast(sw.c_new_var_AND(listWT.get(0), listWT.get(1)));
                        listWT.addLast(listWT.pollFirst());
                    }

                    listMindestens.addLast(-sw.c_OR_tree(listAufeinanderfolgend)); // anzahl nicht aufeinanderfolgend
                }
            }

            sw.c_at_least_generic(listMindestens, min_aufeinanderfolgend);
        }

    }


}
