package bar.stundenplan;

/**
 * Ein Stundenblock (1,2,3) an einem bestimmten Tag. <br>
 * Typ n = In beiden Wochen gleich. <br>
 *
 * @author Benjamin A. Bartsch
 */
public class D_Stunde_SAT_n extends D_Stunde_SAT {

    public D_Stunde_SAT_n(int MAX_TAGE, int MAX_STUNDEN, int id, int wochenstunden, String plan, int lage_kl, int lage_le) {
        super(MAX_TAGE, MAX_STUNDEN, id, wochenstunden, plan, lage_kl, lage_le);
    }

    @Override
    void cnf_post(SatWrapper sw, D_Schule_SAT sc) throws Exception {
        // planWT_ist_am (Typ n): In beiden Wochen der gleiche Tag
        sw.c_exactly_generic(planWT_ist_am[0], 1);
        sw.c_equal(planWT_ist_am[0], planWT_ist_am[1]);

        // planS_beginnt
        // planS_ist     
        cnf_post_planS(sw, stunden);

        // planWTS
        cnf_post_planWTS(sw);

        // Verbot der Einzelstunden
        if (stunden == 1) {
            if ((sc.keine_einzelstunde_in_1) && (planS_beginnt.length >= 1)) {
                sw.c_1(-planS_beginnt[0]);
            }
            if ((sc.keine_einzelstunde_in_2) && (planS_beginnt.length >= 2)) {
                sw.c_1(-planS_beginnt[1]);
            }
            if ((sc.keine_einzelstunde_in_3) && (planS_beginnt.length >= 3)) {
                sw.c_1(-planS_beginnt[2]);
            }
            if ((sc.keine_einzelstunde_in_4) && (planS_beginnt.length >= 4)) {
                sw.c_1(-planS_beginnt[3]);
            }
            if ((sc.keine_einzelstunde_in_5) && (planS_beginnt.length >= 5)) {
                sw.c_1(-planS_beginnt[4]);
            }
            if ((sc.keine_einzelstunde_in_6) && (planS_beginnt.length >= 6)) {
                sw.c_1(-planS_beginnt[5]);
            }
        }
        
        // Verbiete Übergänge
        cnf_post_planS_verbiete_uebergang(sw, sc);
        
    }

}
