package bar.stundenplan;

import java.awt.CardLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Enumeration;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.text.DefaultCaret;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

/**
 * @author Benjamin A. Bartsch
 */
public final class Gui extends javax.swing.JFrame {

    static final int ACTION_SPECIAL_VIEW_SHOW_PLAN = 1;

    static final int ACTION_LEA_ERZEUGE_NEUE_LEHRKRAFT = 50;
    static final int ACTION_LEA_ALLE_LOESCHEN = 51;

    static final int ACTION_BEA_STARTE_BERECHNUNG = 750;
    static final int ACTION_BEA_ALLE_BERECHNUNGEN_BEENDEN_UND_LOESCHEN = 751;
    static final int ACTION_BEA_CHECKBOX_LE_FREIE_TAGE = 752;
    static final int ACTION_BEA_CHECKBOX_LE_ERST_AB_STUNDE = 753;
    static final int ACTION_BEA_CHECKBOX_LE_NUR_BIS_STUNDE = 754;
    static final int ACTION_BEA_CHECKBOX_LE_SPRINGSTUNDEN_TAG = 755;
    static final int ACTION_BEA_CHECKBOX_LE_SPRINGSTUNDEN_WOCHE = 756;
    static final int ACTION_BEA_CHECKBOX_LE_TAGESSTUNDENPRAESENZ = 757;
    static final int ACTION_BEA_CHECKBOX_LE_MIN_STUNDEN_PRO_TAG = 758;
    static final int ACTION_BEA_CHECKBOX_LE_MAX_STUNDEN_IN_FOLGE = 759;
    static final int ACTION_BEA_CHECKBOX_LE_PLAN_SPALTE_MIN = 760;
    static final int ACTION_BEA_CHECKBOX_LE_PLAN_SPALTE_MAX = 761;
    static final int ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MIN = 762;
    static final int ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MAX = 763;
    static final int ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MIN_AB = 764;
    static final int ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MAX_AB = 765;
    static final int ACTION_BEA_CHECKBOX_LE_PLAN_ZELLEN = 766;

    private static final int VIEW_ATTRIBUTES = 0;
    private static final int VIEW_PLAN = 1;
    private static final int VIEW_VERTRETUNGSRESERVEN = 2;
    private static final int VIEW_VERTRETUNGSOPTIONEN = 3;

    private final JFileChooser fcCrypto = new JFileChooser();
    private final JFileChooser fcSaveOpen = new JFileChooser();
    private boolean card_wechsel_erlaubt = true;
    private Enumeration<TreePath> expanded_paths = null;
    private TreePath select_same_path = null;

    private int VIEW = VIEW_ATTRIBUTES;
    private String plan_table = "";
    private String plan_data_column = "";
    private String plan_id_column = "";
    private int plan_id = 0;

    private final JTable[] jTables;
    private final JComboBox<String>[] plan_tag_min;
    private final JComboBox<String>[] plan_tag_max;
    private final JComboBox<String>[][] plan_stunde_tag;
    private final JComboBox<String>[] plan_stunde_min;
    private final JComboBox<String>[] plan_stunde_max;
    private final JComboBox<String>[] plan_stunde_ab_max;
    private final JComboBox<String>[] plan_stunde_ab_min;
    private final JLabel[] plan_tag_lab;

    private final Model model = new Model(this);

    /**
     * Creates new form Gui
     */
    public Gui() {
        initComponents();

        jTables = new JTable[]{
            jTable1, jTable2, jTable3, jTable4, jTable5, jTable6, jTable7
        };
        plan_tag_min = new JComboBox[]{
            pl_mo_min, pl_di_min, pl_mi_min, pl_do_min, pl_fr_min, pl_sa_min, pl_so_min
        };
        plan_tag_max = new JComboBox[]{
            pl_mo_max, pl_di_max, pl_mi_max, pl_do_max, pl_fr_max, pl_sa_max, pl_so_max
        };
        plan_tag_lab = new JLabel[]{
            pl_mo_lab, pl_di_lab, pl_mi_lab, pl_do_lab, pl_fr_lab, pl_sa_lab, pl_so_lab
        };
        plan_stunde_min = new JComboBox[]{
            pl_std_1_min, pl_std_2_min, pl_std_3_min, pl_std_4_min, pl_std_5_min, pl_std_6_min, pl_std_7_min, pl_std_8_min,
            pl_std_9_min, pl_std_10_min, pl_std_11_min, pl_std_12_min, pl_std_13_min, pl_std_14_min, pl_std_15_min, pl_std_16_min
        };
        plan_stunde_max = new JComboBox[]{
            pl_std_1_max, pl_std_2_max, pl_std_3_max, pl_std_4_max, pl_std_5_max, pl_std_6_max, pl_std_7_max, pl_std_8_max,
            pl_std_9_max, pl_std_10_max, pl_std_11_max, pl_std_12_max, pl_std_13_max, pl_std_14_max, pl_std_15_max, pl_std_16_max
        };
        plan_stunde_ab_max = new JComboBox[]{
            pl_std_1_ab_max, pl_std_2_ab_max, pl_std_3_ab_max, pl_std_4_ab_max, pl_std_5_ab_max, pl_std_6_ab_max, pl_std_7_ab_max, pl_std_8_ab_max,
            pl_std_9_ab_max, pl_std_10_ab_max, pl_std_11_ab_max, pl_std_12_ab_max, pl_std_13_ab_max, pl_std_14_ab_max, pl_std_15_ab_max, pl_std_16_ab_max,};
        plan_stunde_ab_min = new JComboBox[]{
            pl_std_1_ab_min, pl_std_2_ab_min, pl_std_3_ab_min, pl_std_4_ab_min, pl_std_5_ab_min, pl_std_6_ab_min, pl_std_7_ab_min, pl_std_8_ab_min,
            pl_std_9_ab_min, pl_std_10_ab_min, pl_std_11_ab_min, pl_std_12_ab_min, pl_std_13_ab_min, pl_std_14_ab_min, pl_std_15_ab_min, pl_std_16_ab_min,};
        plan_stunde_tag = new JComboBox[][]{
            {pl_std_1_mo, pl_std_1_di, pl_std_1_mi, pl_std_1_do, pl_std_1_fr, pl_std_1_sa, pl_std_1_so},
            {pl_std_2_mo, pl_std_2_di, pl_std_2_mi, pl_std_2_do, pl_std_2_fr, pl_std_2_sa, pl_std_2_so},
            {pl_std_3_mo, pl_std_3_di, pl_std_3_mi, pl_std_3_do, pl_std_3_fr, pl_std_3_sa, pl_std_3_so},
            {pl_std_4_mo, pl_std_4_di, pl_std_4_mi, pl_std_4_do, pl_std_4_fr, pl_std_4_sa, pl_std_4_so},
            {pl_std_5_mo, pl_std_5_di, pl_std_5_mi, pl_std_5_do, pl_std_5_fr, pl_std_5_sa, pl_std_5_so},
            {pl_std_6_mo, pl_std_6_di, pl_std_6_mi, pl_std_6_do, pl_std_6_fr, pl_std_6_sa, pl_std_6_so},
            {pl_std_7_mo, pl_std_7_di, pl_std_7_mi, pl_std_7_do, pl_std_7_fr, pl_std_7_sa, pl_std_7_so},
            {pl_std_8_mo, pl_std_8_di, pl_std_8_mi, pl_std_8_do, pl_std_8_fr, pl_std_8_sa, pl_std_8_so},
            {pl_std_9_mo, pl_std_9_di, pl_std_9_mi, pl_std_9_do, pl_std_9_fr, pl_std_9_sa, pl_std_9_so},
            {pl_std_10_mo, pl_std_10_di, pl_std_10_mi, pl_std_10_do, pl_std_10_fr, pl_std_10_sa, pl_std_10_so},
            {pl_std_11_mo, pl_std_11_di, pl_std_11_mi, pl_std_11_do, pl_std_11_fr, pl_std_11_sa, pl_std_11_so},
            {pl_std_12_mo, pl_std_12_di, pl_std_12_mi, pl_std_12_do, pl_std_12_fr, pl_std_12_sa, pl_std_12_so},
            {pl_std_13_mo, pl_std_13_di, pl_std_13_mi, pl_std_13_do, pl_std_13_fr, pl_std_13_sa, pl_std_13_so},
            {pl_std_14_mo, pl_std_14_di, pl_std_14_mi, pl_std_14_do, pl_std_14_fr, pl_std_14_sa, pl_std_14_so},
            {pl_std_15_mo, pl_std_15_di, pl_std_15_mi, pl_std_15_do, pl_std_15_fr, pl_std_15_sa, pl_std_15_so},
            {pl_std_16_mo, pl_std_16_di, pl_std_16_mi, pl_std_16_do, pl_std_16_fr, pl_std_16_sa, pl_std_16_so},};

        try {

            this.setPreferredSize(new Dimension(1024, 768));

            model.db_connect_and_create();
            //schule.db_connect_and_create();
            // Konfiguration des Haupt-Baumes
            //jTree1.setCellRenderer(new Gui_TreeCellRenderer());
            jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
            jTree1.setRootVisible(false);
            jTree1.setModel(model);
            gui_standardauswahl();

            // Konfiguration der Tabellen
            for (JTable jTableKurs : jTables) {
                ((DefaultTableCellRenderer) jTableKurs.getTableHeader().getDefaultRenderer()).setHorizontalAlignment(SwingConstants.CENTER);
                jTableKurs.getTableHeader().setFont(Config.FONT_NORMAL_HEADER);
                jTableKurs.getTableHeader().setReorderingAllowed(false);
                jTableKurs.getColumnModel().getColumn(1).setMaxWidth(50);
                jTableKurs.removeColumn(jTableKurs.getColumnModel().getColumn(2));
            }

            // Ausgabe - No Caret Update
            jTabbedPane1.setFont(Config.FONT_NORMAL_HEADER);
            ((DefaultCaret) beTextPaneStatistik.getCaret()).setUpdatePolicy(DefaultCaret.NEVER_UPDATE);
            ((DefaultCaret) beTextPaneLehrkraefte.getCaret()).setUpdatePolicy(DefaultCaret.NEVER_UPDATE);
            ((DefaultCaret) beTextPaneKlassen.getCaret()).setUpdatePolicy(DefaultCaret.NEVER_UPDATE);
            ((DefaultCaret) beTextPaneRaeume.getCaret()).setUpdatePolicy(DefaultCaret.NEVER_UPDATE);
            ((DefaultCaret) beTextPaneVertretungsreserven.getCaret()).setUpdatePolicy(DefaultCaret.NEVER_UPDATE);
            ((DefaultCaret) beTextPaneVertretungsoptionen.getCaret()).setUpdatePolicy(DefaultCaret.NEVER_UPDATE);
            ((DefaultCaret) beTextPaneAlles.getCaret()).setUpdatePolicy(DefaultCaret.NEVER_UPDATE);

            // Zentrieren und relativ zum Bildschirm skalieren (75%)
            //Config.screen_center(this, 0.75);

        } catch (Exception ex) {
            handle_exception(ex);
        }

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        buttonGroup4 = new javax.swing.ButtonGroup();
        buttonGroup5 = new javax.swing.ButtonGroup();
        temp = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanelWest = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanelCard = new javax.swing.JPanel();
        pLeer = new javax.swing.JPanel();
        pMulti = new javax.swing.JPanel();
        jPanel383 = new javax.swing.JPanel();
        jPanel384 = new javax.swing.JPanel();
        jButton15 = new javax.swing.JButton();
        pEinstellungen = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jButton6 = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jButton4 = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jButton5 = new javax.swing.JButton();
        jTextField2 = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jPanel11 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        pSchule = new javax.swing.JPanel();
        jPanel319 = new javax.swing.JPanel();
        jPanel133 = new javax.swing.JPanel();
        jButton7 = new javax.swing.JButton();
        jPanel327 = new javax.swing.JPanel();
        sc_plan_laden = new javax.swing.JButton();
        sc_planVR_laden = new javax.swing.JButton();
        sc_planVO_laden = new javax.swing.JButton();
        jPanel14 = new javax.swing.JPanel();
        jButtonSave = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        jPanel16 = new javax.swing.JPanel();
        jButtonOpen = new javax.swing.JButton();
        jLabel10 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jPanel18 = new javax.swing.JPanel();
        pColumn1a = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        sc_WochenTage = new javax.swing.JSpinner();
        pColumn2a = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        sc_StundenProTag = new javax.swing.JSpinner();
        jLabel21 = new javax.swing.JLabel();
        jPanel121 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        pColumn1b = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        sc_le_MaxSpringstundenProTag = new javax.swing.JSpinner();
        pColumn2b = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        sc_le_MaxSpringstundenProWoche = new javax.swing.JSpinner();
        pColumn2b1 = new javax.swing.JPanel();
        jLabel25 = new javax.swing.JLabel();
        sc_le_MaxTagesstundenpraesenz = new javax.swing.JSpinner();
        jPanel7 = new javax.swing.JPanel();
        pColumn2b2 = new javax.swing.JPanel();
        jLabel29 = new javax.swing.JLabel();
        sc_le_MinStundenProTag = new javax.swing.JSpinner();
        pColumn2b3 = new javax.swing.JPanel();
        jLabel34 = new javax.swing.JLabel();
        sc_le_Max_Stunden_in_Folge = new javax.swing.JSpinner();
        jLabel22 = new javax.swing.JLabel();
        jPanel338 = new javax.swing.JPanel();
        sc_keine_einzelstunde_in_1 = new javax.swing.JCheckBox();
        sc_keine_einzelstunde_in_2 = new javax.swing.JCheckBox();
        sc_keine_einzelstunde_in_3 = new javax.swing.JCheckBox();
        sc_keine_einzelstunde_in_4 = new javax.swing.JCheckBox();
        sc_keine_einzelstunde_in_5 = new javax.swing.JCheckBox();
        sc_keine_einzelstunde_in_6 = new javax.swing.JCheckBox();
        jLabel23 = new javax.swing.JLabel();
        jPanel364 = new javax.swing.JPanel();
        sc_keinen_uebergang_1_2 = new javax.swing.JCheckBox();
        sc_keinen_uebergang_2_3 = new javax.swing.JCheckBox();
        sc_keinen_uebergang_3_4 = new javax.swing.JCheckBox();
        sc_keinen_uebergang_4_5 = new javax.swing.JCheckBox();
        sc_keinen_uebergang_5_6 = new javax.swing.JCheckBox();
        sc_keinen_uebergang_6_7 = new javax.swing.JCheckBox();
        sc_keinen_uebergang_7_8 = new javax.swing.JCheckBox();
        jLabel24 = new javax.swing.JLabel();
        jPanel378 = new javax.swing.JPanel();
        jLabel32 = new javax.swing.JLabel();
        sc_min_aufeinanderfolgend = new javax.swing.JSpinner();
        jLabel33 = new javax.swing.JLabel();
        sc_label_min_aufeinander_von = new javax.swing.JLabel();
        jLabel31 = new javax.swing.JLabel();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 0));
        pLehrkraefte = new javax.swing.JPanel();
        jPanel12 = new javax.swing.JPanel();
        jPanel28 = new javax.swing.JPanel();
        jButton13 = new javax.swing.JButton();
        jPanel326 = new javax.swing.JPanel();
        lea_plan_laden = new javax.swing.JButton();
        jPanel29 = new javax.swing.JPanel();
        jPanel30 = new javax.swing.JPanel();
        jButton14 = new javax.swing.JButton();
        jLabel12 = new javax.swing.JLabel();
        jPanel31 = new javax.swing.JPanel();
        jPanel32 = new javax.swing.JPanel();
        jPanel33 = new javax.swing.JPanel();
        jPanel34 = new javax.swing.JPanel();
        jPanel35 = new javax.swing.JPanel();
        pLehrkraft = new javax.swing.JPanel();
        jPanel117 = new javax.swing.JPanel();
        jPanel36 = new javax.swing.JPanel();
        le_diese_loeschen = new javax.swing.JButton();
        jPanel330 = new javax.swing.JPanel();
        le_plan_laden = new javax.swing.JButton();
        jPanel37 = new javax.swing.JPanel();
        jPanel38 = new javax.swing.JPanel();
        le_kuerzel = new javax.swing.JTextField();
        jPanel44 = new javax.swing.JPanel();
        le_anzeigename = new javax.swing.JTextField();
        jPanel132 = new javax.swing.JPanel();
        le_darf_vertreten = new javax.swing.JCheckBox();
        jPanel131 = new javax.swing.JPanel();
        jPanel66 = new javax.swing.JPanel();
        le_bemerkung = new javax.swing.JTextField();
        jPanel39 = new javax.swing.JPanel();
        jPanel53 = new javax.swing.JPanel();
        le_freie_tage = new javax.swing.JSpinner();
        jPanel118 = new javax.swing.JPanel();
        jPanel120 = new javax.swing.JPanel();
        le_ab_stunde_x = new javax.swing.JSpinner();
        le_ab_stunde_y = new javax.swing.JSpinner();
        jPanel119 = new javax.swing.JPanel();
        jPanel124 = new javax.swing.JPanel();
        le_bis_stunde_x = new javax.swing.JSpinner();
        le_bis_stunde_y = new javax.swing.JSpinner();
        jPanel125 = new javax.swing.JPanel();
        jPanel126 = new javax.swing.JPanel();
        le_spring_pro_tag_check = new javax.swing.JCheckBox();
        le_spring_pro_tag_wert = new javax.swing.JSpinner();
        jPanel128 = new javax.swing.JPanel();
        le_spring_pro_woche_check = new javax.swing.JCheckBox();
        le_spring_pro_woche_wert = new javax.swing.JSpinner();
        jPanel130 = new javax.swing.JPanel();
        le_tagesstunden_check = new javax.swing.JCheckBox();
        le_tagesstunden_wert = new javax.swing.JSpinner();
        jPanel363 = new javax.swing.JPanel();
        jPanel365 = new javax.swing.JPanel();
        le_min_std_pro_tag_check = new javax.swing.JCheckBox();
        le_min_std_pro_tag_spinner = new javax.swing.JSpinner();
        jPanel380 = new javax.swing.JPanel();
        le_max_stunden_in_folge_check = new javax.swing.JCheckBox();
        le_max_stunden_in_folge_spinner = new javax.swing.JSpinner();
        jPanel376 = new javax.swing.JPanel();
        pKlassen = new javax.swing.JPanel();
        jPanel328 = new javax.swing.JPanel();
        jPanel40 = new javax.swing.JPanel();
        jButton16 = new javax.swing.JButton();
        jPanel329 = new javax.swing.JPanel();
        kla_plan_laden = new javax.swing.JButton();
        jPanel41 = new javax.swing.JPanel();
        jPanel42 = new javax.swing.JPanel();
        jButton17 = new javax.swing.JButton();
        jLabel13 = new javax.swing.JLabel();
        jPanel43 = new javax.swing.JPanel();
        jPanel46 = new javax.swing.JPanel();
        jPanel47 = new javax.swing.JPanel();
        jPanel48 = new javax.swing.JPanel();
        jPanel54 = new javax.swing.JPanel();
        jButton19 = new javax.swing.JButton();
        jLabel14 = new javax.swing.JLabel();
        pKlasse = new javax.swing.JPanel();
        jPanel49 = new javax.swing.JPanel();
        jPanel19 = new javax.swing.JPanel();
        jButton18 = new javax.swing.JButton();
        jPanel13 = new javax.swing.JPanel();
        kl_plan_laden = new javax.swing.JButton();
        jPanel51 = new javax.swing.JPanel();
        tf_klasse_kuerzel = new javax.swing.JTextField();
        pFaecher = new javax.swing.JPanel();
        jPanel20 = new javax.swing.JPanel();
        jButton10 = new javax.swing.JButton();
        jPanel21 = new javax.swing.JPanel();
        jPanel22 = new javax.swing.JPanel();
        jButton11 = new javax.swing.JButton();
        jLabel9 = new javax.swing.JLabel();
        jPanel23 = new javax.swing.JPanel();
        jPanel24 = new javax.swing.JPanel();
        jButton12 = new javax.swing.JButton();
        jLabel11 = new javax.swing.JLabel();
        jPanel25 = new javax.swing.JPanel();
        jPanel26 = new javax.swing.JPanel();
        jPanel27 = new javax.swing.JPanel();
        pFach = new javax.swing.JPanel();
        jPanel67 = new javax.swing.JPanel();
        jButton23 = new javax.swing.JButton();
        jPanel68 = new javax.swing.JPanel();
        jPanel69 = new javax.swing.JPanel();
        tf_fach_kuerzel = new javax.swing.JTextField();
        jPanel70 = new javax.swing.JPanel();
        jPanel71 = new javax.swing.JPanel();
        tf_fach_anzeigename = new javax.swing.JTextField();
        pRaeume = new javax.swing.JPanel();
        jPanel320 = new javax.swing.JPanel();
        jPanel45 = new javax.swing.JPanel();
        jButton20 = new javax.swing.JButton();
        jPanel15 = new javax.swing.JPanel();
        raa_plan_laden = new javax.swing.JButton();
        jPanel55 = new javax.swing.JPanel();
        jPanel56 = new javax.swing.JPanel();
        jButton21 = new javax.swing.JButton();
        jLabel15 = new javax.swing.JLabel();
        jPanel57 = new javax.swing.JPanel();
        jPanel58 = new javax.swing.JPanel();
        jPanel59 = new javax.swing.JPanel();
        jPanel60 = new javax.swing.JPanel();
        jPanel61 = new javax.swing.JPanel();
        pRaum = new javax.swing.JPanel();
        jPanel321 = new javax.swing.JPanel();
        jPanel62 = new javax.swing.JPanel();
        ra_diesen_loeschen = new javax.swing.JButton();
        jPanel17 = new javax.swing.JPanel();
        ra_plan_laden = new javax.swing.JButton();
        jPanel63 = new javax.swing.JPanel();
        jPanel64 = new javax.swing.JPanel();
        tf_raum_kuerzel = new javax.swing.JTextField();
        jPanel65 = new javax.swing.JPanel();
        pKopplungen = new javax.swing.JPanel();
        jPanel322 = new javax.swing.JPanel();
        jPanel72 = new javax.swing.JPanel();
        koa_alle_loeschen = new javax.swing.JButton();
        jPanel331 = new javax.swing.JPanel();
        koa_plan_laden = new javax.swing.JButton();
        jPanel73 = new javax.swing.JPanel();
        jPanel74 = new javax.swing.JPanel();
        jButton25 = new javax.swing.JButton();
        jLabel16 = new javax.swing.JLabel();
        jPanel75 = new javax.swing.JPanel();
        jPanel76 = new javax.swing.JPanel();
        jPanel77 = new javax.swing.JPanel();
        jPanel78 = new javax.swing.JPanel();
        jPanel79 = new javax.swing.JPanel();
        pKopplung = new javax.swing.JPanel();
        jPanel323 = new javax.swing.JPanel();
        jPanel80 = new javax.swing.JPanel();
        ko_diese_loeschen = new javax.swing.JButton();
        jPanel332 = new javax.swing.JPanel();
        ko_plan_laden = new javax.swing.JButton();
        jPanel333 = new javax.swing.JPanel();
        ko_stunde_add = new javax.swing.JButton();
        jPanel82 = new javax.swing.JPanel();
        tf_kopplung_kuerzel = new javax.swing.JTextField();
        jPanel84 = new javax.swing.JPanel();
        tf_kopplung_anzeigename = new javax.swing.JTextField();
        pKurse = new javax.swing.JPanel();
        jPanel324 = new javax.swing.JPanel();
        jPanel85 = new javax.swing.JPanel();
        jButton27 = new javax.swing.JButton();
        jPanel325 = new javax.swing.JPanel();
        kua_plan_laden = new javax.swing.JButton();
        jPanel86 = new javax.swing.JPanel();
        jPanel87 = new javax.swing.JPanel();
        jButton28 = new javax.swing.JButton();
        jLabel17 = new javax.swing.JLabel();
        jPanel88 = new javax.swing.JPanel();
        jPanel89 = new javax.swing.JPanel();
        jPanel90 = new javax.swing.JPanel();
        jPanel91 = new javax.swing.JPanel();
        jPanel92 = new javax.swing.JPanel();
        jLabel28 = new javax.swing.JLabel();
        jPanel369 = new javax.swing.JPanel();
        jRadio_ku_sort_kl_fa_le = new javax.swing.JRadioButton();
        jRadio_ku_sort_kl_le_fa = new javax.swing.JRadioButton();
        jRadio_ku_sort_le_kl_fa = new javax.swing.JRadioButton();
        jRadio_ku_sort_le_fa_kl = new javax.swing.JRadioButton();
        jRadio_ku_sort_fa_kl_le = new javax.swing.JRadioButton();
        jRadio_ku_sort_fa_le_kl = new javax.swing.JRadioButton();
        pKurs = new javax.swing.JPanel();
        jPanel81 = new javax.swing.JPanel();
        jPanel83 = new javax.swing.JPanel();
        jButton29 = new javax.swing.JButton();
        jPanel334 = new javax.swing.JPanel();
        kua_plan_laden1 = new javax.swing.JButton();
        jPanel93 = new javax.swing.JPanel();
        jButton30 = new javax.swing.JButton();
        jPanel95 = new javax.swing.JPanel();
        jPanel98 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel101 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jPanel99 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jPanel100 = new javax.swing.JPanel();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTable4 = new javax.swing.JTable();
        jPanel102 = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTable5 = new javax.swing.JTable();
        jPanel122 = new javax.swing.JPanel();
        jPanel123 = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jTable6 = new javax.swing.JTable();
        jPanel381 = new javax.swing.JPanel();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTable7 = new javax.swing.JTable();
        jPanel379 = new javax.swing.JPanel();
        jPanel96 = new javax.swing.JPanel();
        jPanel97 = new javax.swing.JPanel();
        tf_kurs_ergaenzung = new javax.swing.JTextField();
        jPanel337 = new javax.swing.JPanel();
        ku_vertretungsreserven = new javax.swing.JSpinner();
        jLabel7 = new javax.swing.JLabel();
        jPanel377 = new javax.swing.JPanel();
        ku_nicht_aufeinanderfolgend = new javax.swing.JCheckBox();
        pStunde = new javax.swing.JPanel();
        jPanel94 = new javax.swing.JPanel();
        jPanel103 = new javax.swing.JPanel();
        jButton31 = new javax.swing.JButton();
        jPanel335 = new javax.swing.JPanel();
        st_plan_laden = new javax.swing.JButton();
        jPanel105 = new javax.swing.JPanel();
        jRadioWochenstunden1 = new javax.swing.JRadioButton();
        jRadioWochenstunden2 = new javax.swing.JRadioButton();
        jRadioWochenstunden3 = new javax.swing.JRadioButton();
        jPanel106 = new javax.swing.JPanel();
        jPanel107 = new javax.swing.JPanel();
        jRadioStundenTyp1 = new javax.swing.JRadioButton();
        jRadioStundenTyp2 = new javax.swing.JRadioButton();
        jRadioStundenTyp3 = new javax.swing.JRadioButton();
        jPanel366 = new javax.swing.JPanel();
        jRadio_kl_Lage_Egal = new javax.swing.JRadioButton();
        jRadio_kl_Lage_Anfang = new javax.swing.JRadioButton();
        jRadio_kl_Lage_Nicht_Anfang = new javax.swing.JRadioButton();
        jRadio_kl_Lage_Ende = new javax.swing.JRadioButton();
        jRadio_kl_Lage_Nicht_Ende = new javax.swing.JRadioButton();
        jRadio_kl_Lage_Rand = new javax.swing.JRadioButton();
        jRadio_kl_Lage_Nicht_Rand = new javax.swing.JRadioButton();
        jPanel367 = new javax.swing.JPanel();
        jRadio_le2_Lage_Egal = new javax.swing.JRadioButton();
        jRadio_le_Lage_Anfang = new javax.swing.JRadioButton();
        jRadio_le_Lage_Nicht_Anfang = new javax.swing.JRadioButton();
        jRadio_le_Lage_Ende = new javax.swing.JRadioButton();
        jRadio_le_Lage_Nicht_Ende = new javax.swing.JRadioButton();
        jRadio_le_Lage_Rand = new javax.swing.JRadioButton();
        jRadio_le_Lage_Nicht_Rand = new javax.swing.JRadioButton();
        pBerechnungen = new javax.swing.JPanel();
        jPanel382 = new javax.swing.JPanel();
        jPanel108 = new javax.swing.JPanel();
        jButton32 = new javax.swing.JButton();
        jPanel109 = new javax.swing.JPanel();
        jPanel110 = new javax.swing.JPanel();
        jButton33 = new javax.swing.JButton();
        jLabel18 = new javax.swing.JLabel();
        jPanel111 = new javax.swing.JPanel();
        jPanel112 = new javax.swing.JPanel();
        jPanel113 = new javax.swing.JPanel();
        jPanel114 = new javax.swing.JPanel();
        jPanel115 = new javax.swing.JPanel();
        jPanel385 = new javax.swing.JPanel();
        jLabel35 = new javax.swing.JLabel();
        jPanel387 = new javax.swing.JPanel();
        jLabel36 = new javax.swing.JLabel();
        jPanel386 = new javax.swing.JPanel();
        bea_1 = new javax.swing.JCheckBox();
        bea_2 = new javax.swing.JCheckBox();
        bea_3 = new javax.swing.JCheckBox();
        bea_4 = new javax.swing.JCheckBox();
        bea_5 = new javax.swing.JCheckBox();
        bea_6 = new javax.swing.JCheckBox();
        bea_7 = new javax.swing.JCheckBox();
        bea_8 = new javax.swing.JCheckBox();
        bea_9 = new javax.swing.JCheckBox();
        bea_10 = new javax.swing.JCheckBox();
        bea_11 = new javax.swing.JCheckBox();
        bea_12 = new javax.swing.JCheckBox();
        bea_13 = new javax.swing.JCheckBox();
        bea_14 = new javax.swing.JCheckBox();
        bea_15 = new javax.swing.JCheckBox();
        pBerechnung = new javax.swing.JPanel();
        jPanel116 = new javax.swing.JPanel();
        jButton34 = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel374 = new javax.swing.JPanel();
        scrollTextPaneAlles = new javax.swing.JScrollPane();
        beTextPaneAlles = new javax.swing.JTextPane();
        jPanel370 = new javax.swing.JPanel();
        jScrollPane15 = new javax.swing.JScrollPane();
        beTextPaneStatistik = new javax.swing.JTextPane();
        jPanel52 = new javax.swing.JPanel();
        scrollTextPaneLehrkraefte = new javax.swing.JScrollPane();
        beTextPaneLehrkraefte = new javax.swing.JTextPane();
        jPanel368 = new javax.swing.JPanel();
        scrollTextPaneKlassen = new javax.swing.JScrollPane();
        beTextPaneKlassen = new javax.swing.JTextPane();
        jPanel371 = new javax.swing.JPanel();
        scrollTextPaneRaeume = new javax.swing.JScrollPane();
        beTextPaneRaeume = new javax.swing.JTextPane();
        jPanel372 = new javax.swing.JPanel();
        scrollTextPaneVertretungsreserven = new javax.swing.JScrollPane();
        beTextPaneVertretungsreserven = new javax.swing.JTextPane();
        jPanel373 = new javax.swing.JPanel();
        scrollTextPaneVertretungsoptionen = new javax.swing.JScrollPane();
        beTextPaneVertretungsoptionen = new javax.swing.JTextPane();
        pPlan = new javax.swing.JPanel();
        jPanel104 = new javax.swing.JPanel();
        jPanel50 = new javax.swing.JPanel();
        pl_button_zurueck = new javax.swing.JButton();
        jPanel336 = new javax.swing.JPanel();
        plan_diesen_loeschen = new javax.swing.JButton();
        jPanel375 = new javax.swing.JPanel();
        plan_alle_loeschen = new javax.swing.JButton();
        panel_h_header1a = new javax.swing.JPanel();
        panelDummy1 = new javax.swing.JPanel();
        panelDummy2 = new javax.swing.JPanel();
        panelDummy3 = new javax.swing.JPanel();
        panelDummy4 = new javax.swing.JPanel();
        panelDummy5 = new javax.swing.JPanel();
        panelDummy6 = new javax.swing.JPanel();
        panelDummy7 = new javax.swing.JPanel();
        panelDummy8 = new javax.swing.JPanel();
        panelDummy9 = new javax.swing.JPanel();
        panelDummy10 = new javax.swing.JPanel();
        panelDummy11 = new javax.swing.JPanel();
        panelDummy12 = new javax.swing.JPanel();
        jPanel139 = new javax.swing.JPanel();
        jPanel301 = new javax.swing.JPanel();
        jLabel26 = new javax.swing.JLabel();
        jPanel359 = new javax.swing.JPanel();
        panel_h_min = new javax.swing.JPanel();
        jPanel291 = new javax.swing.JPanel();
        jLabel30 = new javax.swing.JLabel();
        jPanel127 = new javax.swing.JPanel();
        pl_mo_min = new javax.swing.JComboBox<>();
        jPanel129 = new javax.swing.JPanel();
        pl_di_min = new javax.swing.JComboBox<>();
        jPanel134 = new javax.swing.JPanel();
        pl_mi_min = new javax.swing.JComboBox<>();
        jPanel135 = new javax.swing.JPanel();
        pl_do_min = new javax.swing.JComboBox<>();
        jPanel136 = new javax.swing.JPanel();
        pl_fr_min = new javax.swing.JComboBox<>();
        jPanel137 = new javax.swing.JPanel();
        pl_sa_min = new javax.swing.JComboBox<>();
        jPanel138 = new javax.swing.JPanel();
        pl_so_min = new javax.swing.JComboBox<>();
        jPanel293 = new javax.swing.JPanel();
        jPanel294 = new javax.swing.JPanel();
        jPanel295 = new javax.swing.JPanel();
        jPanel342 = new javax.swing.JPanel();
        panel_h_max = new javax.swing.JPanel();
        jPanel292 = new javax.swing.JPanel();
        jLabel_max = new javax.swing.JLabel();
        jPanel140 = new javax.swing.JPanel();
        pl_mo_max = new javax.swing.JComboBox<>();
        jPanel141 = new javax.swing.JPanel();
        pl_di_max = new javax.swing.JComboBox<>();
        jPanel142 = new javax.swing.JPanel();
        pl_mi_max = new javax.swing.JComboBox<>();
        jPanel143 = new javax.swing.JPanel();
        pl_do_max = new javax.swing.JComboBox<>();
        jPanel144 = new javax.swing.JPanel();
        pl_fr_max = new javax.swing.JComboBox<>();
        jPanel145 = new javax.swing.JPanel();
        pl_sa_max = new javax.swing.JComboBox<>();
        jPanel146 = new javax.swing.JPanel();
        pl_so_max = new javax.swing.JComboBox<>();
        jPanel298 = new javax.swing.JPanel();
        jPanel297 = new javax.swing.JPanel();
        jPanel296 = new javax.swing.JPanel();
        jPanel341 = new javax.swing.JPanel();
        panel_h_header1b = new javax.swing.JPanel();
        panelDummy13 = new javax.swing.JPanel();
        panelDummy14 = new javax.swing.JPanel();
        panelDummy15 = new javax.swing.JPanel();
        panelDummy16 = new javax.swing.JPanel();
        panelDummy17 = new javax.swing.JPanel();
        panelDummy18 = new javax.swing.JPanel();
        panelDummy19 = new javax.swing.JPanel();
        panelDummy20 = new javax.swing.JPanel();
        panelDummy21 = new javax.swing.JPanel();
        panelDummy22 = new javax.swing.JPanel();
        panelDummy23 = new javax.swing.JPanel();
        panelDummy24 = new javax.swing.JPanel();
        jPanel360 = new javax.swing.JPanel();
        jPanel361 = new javax.swing.JPanel();
        jPanel362 = new javax.swing.JPanel();
        jLabel27 = new javax.swing.JLabel();
        panel_h_header2 = new javax.swing.JPanel();
        jLabel54 = new javax.swing.JLabel();
        pl_mo_lab = new javax.swing.JLabel();
        pl_di_lab = new javax.swing.JLabel();
        pl_mi_lab = new javax.swing.JLabel();
        pl_do_lab = new javax.swing.JLabel();
        pl_fr_lab = new javax.swing.JLabel();
        pl_sa_lab = new javax.swing.JLabel();
        pl_so_lab = new javax.swing.JLabel();
        jPanel299 = new javax.swing.JPanel();
        jLabel62 = new javax.swing.JLabel();
        jPanel300 = new javax.swing.JPanel();
        jLabel_max_s = new javax.swing.JLabel();
        jPanel340 = new javax.swing.JPanel();
        jLabel74 = new javax.swing.JLabel();
        jPanel343 = new javax.swing.JPanel();
        jLabel_max_s_ab = new javax.swing.JLabel();
        panel_h1_s1 = new javax.swing.JPanel();
        jLabel65 = new javax.swing.JLabel();
        jPanel147 = new javax.swing.JPanel();
        pl_std_1_mo = new javax.swing.JComboBox<>();
        jPanel148 = new javax.swing.JPanel();
        pl_std_1_di = new javax.swing.JComboBox<>();
        jPanel149 = new javax.swing.JPanel();
        pl_std_1_mi = new javax.swing.JComboBox<>();
        jPanel150 = new javax.swing.JPanel();
        pl_std_1_do = new javax.swing.JComboBox<>();
        jPanel151 = new javax.swing.JPanel();
        pl_std_1_fr = new javax.swing.JComboBox<>();
        jPanel152 = new javax.swing.JPanel();
        pl_std_1_sa = new javax.swing.JComboBox<>();
        jPanel153 = new javax.swing.JPanel();
        pl_std_1_so = new javax.swing.JComboBox<>();
        jPanel154 = new javax.swing.JPanel();
        pl_std_1_min = new javax.swing.JComboBox<>();
        jPanel155 = new javax.swing.JPanel();
        pl_std_1_max = new javax.swing.JComboBox<>();
        jPanel339 = new javax.swing.JPanel();
        pl_std_1_ab_min = new javax.swing.JComboBox<>();
        jPanel302 = new javax.swing.JPanel();
        pl_std_1_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s2 = new javax.swing.JPanel();
        jLabel66 = new javax.swing.JLabel();
        jPanel156 = new javax.swing.JPanel();
        pl_std_2_mo = new javax.swing.JComboBox<>();
        jPanel157 = new javax.swing.JPanel();
        pl_std_2_di = new javax.swing.JComboBox<>();
        jPanel158 = new javax.swing.JPanel();
        pl_std_2_mi = new javax.swing.JComboBox<>();
        jPanel159 = new javax.swing.JPanel();
        pl_std_2_do = new javax.swing.JComboBox<>();
        jPanel160 = new javax.swing.JPanel();
        pl_std_2_fr = new javax.swing.JComboBox<>();
        jPanel161 = new javax.swing.JPanel();
        pl_std_2_sa = new javax.swing.JComboBox<>();
        jPanel162 = new javax.swing.JPanel();
        pl_std_2_so = new javax.swing.JComboBox<>();
        jPanel163 = new javax.swing.JPanel();
        pl_std_2_min = new javax.swing.JComboBox<>();
        jPanel164 = new javax.swing.JPanel();
        pl_std_2_max = new javax.swing.JComboBox<>();
        jPanel344 = new javax.swing.JPanel();
        pl_std_2_ab_min = new javax.swing.JComboBox<>();
        jPanel303 = new javax.swing.JPanel();
        pl_std_2_ab_max = new javax.swing.JComboBox<>();
        jLabel37 = new javax.swing.JLabel();
        panel_h1_s3 = new javax.swing.JPanel();
        jLabel67 = new javax.swing.JLabel();
        jPanel165 = new javax.swing.JPanel();
        pl_std_3_mo = new javax.swing.JComboBox<>();
        jPanel166 = new javax.swing.JPanel();
        pl_std_3_di = new javax.swing.JComboBox<>();
        jPanel167 = new javax.swing.JPanel();
        pl_std_3_mi = new javax.swing.JComboBox<>();
        jPanel168 = new javax.swing.JPanel();
        pl_std_3_do = new javax.swing.JComboBox<>();
        jPanel169 = new javax.swing.JPanel();
        pl_std_3_fr = new javax.swing.JComboBox<>();
        jPanel170 = new javax.swing.JPanel();
        pl_std_3_sa = new javax.swing.JComboBox<>();
        jPanel171 = new javax.swing.JPanel();
        pl_std_3_so = new javax.swing.JComboBox<>();
        jPanel172 = new javax.swing.JPanel();
        pl_std_3_min = new javax.swing.JComboBox<>();
        jPanel173 = new javax.swing.JPanel();
        pl_std_3_max = new javax.swing.JComboBox<>();
        jPanel345 = new javax.swing.JPanel();
        pl_std_3_ab_min = new javax.swing.JComboBox<>();
        jPanel304 = new javax.swing.JPanel();
        pl_std_3_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s4 = new javax.swing.JPanel();
        jLabel68 = new javax.swing.JLabel();
        jPanel174 = new javax.swing.JPanel();
        pl_std_4_mo = new javax.swing.JComboBox<>();
        jPanel175 = new javax.swing.JPanel();
        pl_std_4_di = new javax.swing.JComboBox<>();
        jPanel176 = new javax.swing.JPanel();
        pl_std_4_mi = new javax.swing.JComboBox<>();
        jPanel177 = new javax.swing.JPanel();
        pl_std_4_do = new javax.swing.JComboBox<>();
        jPanel178 = new javax.swing.JPanel();
        pl_std_4_fr = new javax.swing.JComboBox<>();
        jPanel179 = new javax.swing.JPanel();
        pl_std_4_sa = new javax.swing.JComboBox<>();
        jPanel180 = new javax.swing.JPanel();
        pl_std_4_so = new javax.swing.JComboBox<>();
        jPanel181 = new javax.swing.JPanel();
        pl_std_4_min = new javax.swing.JComboBox<>();
        jPanel182 = new javax.swing.JPanel();
        pl_std_4_max = new javax.swing.JComboBox<>();
        jPanel346 = new javax.swing.JPanel();
        pl_std_4_ab_min = new javax.swing.JComboBox<>();
        jPanel305 = new javax.swing.JPanel();
        pl_std_4_ab_max = new javax.swing.JComboBox<>();
        jLabel38 = new javax.swing.JLabel();
        panel_h1_s5 = new javax.swing.JPanel();
        jLabel69 = new javax.swing.JLabel();
        jPanel183 = new javax.swing.JPanel();
        pl_std_5_mo = new javax.swing.JComboBox<>();
        jPanel184 = new javax.swing.JPanel();
        pl_std_5_di = new javax.swing.JComboBox<>();
        jPanel185 = new javax.swing.JPanel();
        pl_std_5_mi = new javax.swing.JComboBox<>();
        jPanel186 = new javax.swing.JPanel();
        pl_std_5_do = new javax.swing.JComboBox<>();
        jPanel187 = new javax.swing.JPanel();
        pl_std_5_fr = new javax.swing.JComboBox<>();
        jPanel188 = new javax.swing.JPanel();
        pl_std_5_sa = new javax.swing.JComboBox<>();
        jPanel189 = new javax.swing.JPanel();
        pl_std_5_so = new javax.swing.JComboBox<>();
        jPanel190 = new javax.swing.JPanel();
        pl_std_5_min = new javax.swing.JComboBox<>();
        jPanel191 = new javax.swing.JPanel();
        pl_std_5_max = new javax.swing.JComboBox<>();
        jPanel347 = new javax.swing.JPanel();
        pl_std_5_ab_min = new javax.swing.JComboBox<>();
        jPanel306 = new javax.swing.JPanel();
        pl_std_5_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s6 = new javax.swing.JPanel();
        jLabel70 = new javax.swing.JLabel();
        jPanel192 = new javax.swing.JPanel();
        pl_std_6_mo = new javax.swing.JComboBox<>();
        jPanel193 = new javax.swing.JPanel();
        pl_std_6_di = new javax.swing.JComboBox<>();
        jPanel194 = new javax.swing.JPanel();
        pl_std_6_mi = new javax.swing.JComboBox<>();
        jPanel195 = new javax.swing.JPanel();
        pl_std_6_do = new javax.swing.JComboBox<>();
        jPanel196 = new javax.swing.JPanel();
        pl_std_6_fr = new javax.swing.JComboBox<>();
        jPanel197 = new javax.swing.JPanel();
        pl_std_6_sa = new javax.swing.JComboBox<>();
        jPanel198 = new javax.swing.JPanel();
        pl_std_6_so = new javax.swing.JComboBox<>();
        jPanel199 = new javax.swing.JPanel();
        pl_std_6_min = new javax.swing.JComboBox<>();
        jPanel200 = new javax.swing.JPanel();
        pl_std_6_max = new javax.swing.JComboBox<>();
        jPanel348 = new javax.swing.JPanel();
        pl_std_6_ab_min = new javax.swing.JComboBox<>();
        jPanel307 = new javax.swing.JPanel();
        pl_std_6_ab_max = new javax.swing.JComboBox<>();
        jLabel39 = new javax.swing.JLabel();
        panel_h1_s7 = new javax.swing.JPanel();
        jLabel71 = new javax.swing.JLabel();
        jPanel201 = new javax.swing.JPanel();
        pl_std_7_mo = new javax.swing.JComboBox<>();
        jPanel202 = new javax.swing.JPanel();
        pl_std_7_di = new javax.swing.JComboBox<>();
        jPanel203 = new javax.swing.JPanel();
        pl_std_7_mi = new javax.swing.JComboBox<>();
        jPanel204 = new javax.swing.JPanel();
        pl_std_7_do = new javax.swing.JComboBox<>();
        jPanel205 = new javax.swing.JPanel();
        pl_std_7_fr = new javax.swing.JComboBox<>();
        jPanel206 = new javax.swing.JPanel();
        pl_std_7_sa = new javax.swing.JComboBox<>();
        jPanel207 = new javax.swing.JPanel();
        pl_std_7_so = new javax.swing.JComboBox<>();
        jPanel208 = new javax.swing.JPanel();
        pl_std_7_min = new javax.swing.JComboBox<>();
        jPanel209 = new javax.swing.JPanel();
        pl_std_7_max = new javax.swing.JComboBox<>();
        jPanel349 = new javax.swing.JPanel();
        pl_std_7_ab_min = new javax.swing.JComboBox<>();
        jPanel308 = new javax.swing.JPanel();
        pl_std_7_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s8 = new javax.swing.JPanel();
        jLabel72 = new javax.swing.JLabel();
        jPanel210 = new javax.swing.JPanel();
        pl_std_8_mo = new javax.swing.JComboBox<>();
        jPanel211 = new javax.swing.JPanel();
        pl_std_8_di = new javax.swing.JComboBox<>();
        jPanel212 = new javax.swing.JPanel();
        pl_std_8_mi = new javax.swing.JComboBox<>();
        jPanel213 = new javax.swing.JPanel();
        pl_std_8_do = new javax.swing.JComboBox<>();
        jPanel214 = new javax.swing.JPanel();
        pl_std_8_fr = new javax.swing.JComboBox<>();
        jPanel215 = new javax.swing.JPanel();
        pl_std_8_sa = new javax.swing.JComboBox<>();
        jPanel216 = new javax.swing.JPanel();
        pl_std_8_so = new javax.swing.JComboBox<>();
        jPanel217 = new javax.swing.JPanel();
        pl_std_8_min = new javax.swing.JComboBox<>();
        jPanel218 = new javax.swing.JPanel();
        pl_std_8_max = new javax.swing.JComboBox<>();
        jPanel350 = new javax.swing.JPanel();
        pl_std_8_ab_min = new javax.swing.JComboBox<>();
        jPanel309 = new javax.swing.JPanel();
        pl_std_8_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s9 = new javax.swing.JPanel();
        jLabel73 = new javax.swing.JLabel();
        jPanel219 = new javax.swing.JPanel();
        pl_std_9_mo = new javax.swing.JComboBox<>();
        jPanel220 = new javax.swing.JPanel();
        pl_std_9_di = new javax.swing.JComboBox<>();
        jPanel221 = new javax.swing.JPanel();
        pl_std_9_mi = new javax.swing.JComboBox<>();
        jPanel222 = new javax.swing.JPanel();
        pl_std_9_do = new javax.swing.JComboBox<>();
        jPanel223 = new javax.swing.JPanel();
        pl_std_9_fr = new javax.swing.JComboBox<>();
        jPanel224 = new javax.swing.JPanel();
        pl_std_9_sa = new javax.swing.JComboBox<>();
        jPanel225 = new javax.swing.JPanel();
        pl_std_9_so = new javax.swing.JComboBox<>();
        jPanel226 = new javax.swing.JPanel();
        pl_std_9_min = new javax.swing.JComboBox<>();
        jPanel227 = new javax.swing.JPanel();
        pl_std_9_max = new javax.swing.JComboBox<>();
        jPanel351 = new javax.swing.JPanel();
        pl_std_9_ab_min = new javax.swing.JComboBox<>();
        jPanel310 = new javax.swing.JPanel();
        pl_std_9_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s10 = new javax.swing.JPanel();
        jLabel83 = new javax.swing.JLabel();
        jPanel228 = new javax.swing.JPanel();
        pl_std_10_mo = new javax.swing.JComboBox<>();
        jPanel229 = new javax.swing.JPanel();
        pl_std_10_di = new javax.swing.JComboBox<>();
        jPanel230 = new javax.swing.JPanel();
        pl_std_10_mi = new javax.swing.JComboBox<>();
        jPanel231 = new javax.swing.JPanel();
        pl_std_10_do = new javax.swing.JComboBox<>();
        jPanel232 = new javax.swing.JPanel();
        pl_std_10_fr = new javax.swing.JComboBox<>();
        jPanel233 = new javax.swing.JPanel();
        pl_std_10_sa = new javax.swing.JComboBox<>();
        jPanel234 = new javax.swing.JPanel();
        pl_std_10_so = new javax.swing.JComboBox<>();
        jPanel235 = new javax.swing.JPanel();
        pl_std_10_min = new javax.swing.JComboBox<>();
        jPanel236 = new javax.swing.JPanel();
        pl_std_10_max = new javax.swing.JComboBox<>();
        jPanel352 = new javax.swing.JPanel();
        pl_std_10_ab_min = new javax.swing.JComboBox<>();
        jPanel311 = new javax.swing.JPanel();
        pl_std_10_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s11 = new javax.swing.JPanel();
        jLabel85 = new javax.swing.JLabel();
        jPanel237 = new javax.swing.JPanel();
        pl_std_11_mo = new javax.swing.JComboBox<>();
        jPanel238 = new javax.swing.JPanel();
        pl_std_11_di = new javax.swing.JComboBox<>();
        jPanel239 = new javax.swing.JPanel();
        pl_std_11_mi = new javax.swing.JComboBox<>();
        jPanel240 = new javax.swing.JPanel();
        pl_std_11_do = new javax.swing.JComboBox<>();
        jPanel241 = new javax.swing.JPanel();
        pl_std_11_fr = new javax.swing.JComboBox<>();
        jPanel242 = new javax.swing.JPanel();
        pl_std_11_sa = new javax.swing.JComboBox<>();
        jPanel243 = new javax.swing.JPanel();
        pl_std_11_so = new javax.swing.JComboBox<>();
        jPanel244 = new javax.swing.JPanel();
        pl_std_11_min = new javax.swing.JComboBox<>();
        jPanel245 = new javax.swing.JPanel();
        pl_std_11_max = new javax.swing.JComboBox<>();
        jPanel353 = new javax.swing.JPanel();
        pl_std_11_ab_min = new javax.swing.JComboBox<>();
        jPanel312 = new javax.swing.JPanel();
        pl_std_11_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s12 = new javax.swing.JPanel();
        jLabel87 = new javax.swing.JLabel();
        jPanel246 = new javax.swing.JPanel();
        pl_std_12_mo = new javax.swing.JComboBox<>();
        jPanel247 = new javax.swing.JPanel();
        pl_std_12_di = new javax.swing.JComboBox<>();
        jPanel248 = new javax.swing.JPanel();
        pl_std_12_mi = new javax.swing.JComboBox<>();
        jPanel249 = new javax.swing.JPanel();
        pl_std_12_do = new javax.swing.JComboBox<>();
        jPanel250 = new javax.swing.JPanel();
        pl_std_12_fr = new javax.swing.JComboBox<>();
        jPanel251 = new javax.swing.JPanel();
        pl_std_12_sa = new javax.swing.JComboBox<>();
        jPanel252 = new javax.swing.JPanel();
        pl_std_12_so = new javax.swing.JComboBox<>();
        jPanel253 = new javax.swing.JPanel();
        pl_std_12_min = new javax.swing.JComboBox<>();
        jPanel254 = new javax.swing.JPanel();
        pl_std_12_max = new javax.swing.JComboBox<>();
        jPanel354 = new javax.swing.JPanel();
        pl_std_12_ab_min = new javax.swing.JComboBox<>();
        jPanel313 = new javax.swing.JPanel();
        pl_std_12_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s13 = new javax.swing.JPanel();
        jLabel89 = new javax.swing.JLabel();
        jPanel255 = new javax.swing.JPanel();
        pl_std_13_mo = new javax.swing.JComboBox<>();
        jPanel256 = new javax.swing.JPanel();
        pl_std_13_di = new javax.swing.JComboBox<>();
        jPanel257 = new javax.swing.JPanel();
        pl_std_13_mi = new javax.swing.JComboBox<>();
        jPanel258 = new javax.swing.JPanel();
        pl_std_13_do = new javax.swing.JComboBox<>();
        jPanel259 = new javax.swing.JPanel();
        pl_std_13_fr = new javax.swing.JComboBox<>();
        jPanel260 = new javax.swing.JPanel();
        pl_std_13_sa = new javax.swing.JComboBox<>();
        jPanel261 = new javax.swing.JPanel();
        pl_std_13_so = new javax.swing.JComboBox<>();
        jPanel262 = new javax.swing.JPanel();
        pl_std_13_min = new javax.swing.JComboBox<>();
        jPanel263 = new javax.swing.JPanel();
        pl_std_13_max = new javax.swing.JComboBox<>();
        jPanel355 = new javax.swing.JPanel();
        pl_std_13_ab_min = new javax.swing.JComboBox<>();
        jPanel314 = new javax.swing.JPanel();
        pl_std_13_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s14 = new javax.swing.JPanel();
        jLabel91 = new javax.swing.JLabel();
        jPanel264 = new javax.swing.JPanel();
        pl_std_14_mo = new javax.swing.JComboBox<>();
        jPanel265 = new javax.swing.JPanel();
        pl_std_14_di = new javax.swing.JComboBox<>();
        jPanel266 = new javax.swing.JPanel();
        pl_std_14_mi = new javax.swing.JComboBox<>();
        jPanel267 = new javax.swing.JPanel();
        pl_std_14_do = new javax.swing.JComboBox<>();
        jPanel268 = new javax.swing.JPanel();
        pl_std_14_fr = new javax.swing.JComboBox<>();
        jPanel269 = new javax.swing.JPanel();
        pl_std_14_sa = new javax.swing.JComboBox<>();
        jPanel270 = new javax.swing.JPanel();
        pl_std_14_so = new javax.swing.JComboBox<>();
        jPanel271 = new javax.swing.JPanel();
        pl_std_14_min = new javax.swing.JComboBox<>();
        jPanel272 = new javax.swing.JPanel();
        pl_std_14_max = new javax.swing.JComboBox<>();
        jPanel356 = new javax.swing.JPanel();
        pl_std_14_ab_min = new javax.swing.JComboBox<>();
        jPanel315 = new javax.swing.JPanel();
        pl_std_14_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s15 = new javax.swing.JPanel();
        jLabel93 = new javax.swing.JLabel();
        jPanel273 = new javax.swing.JPanel();
        pl_std_15_mo = new javax.swing.JComboBox<>();
        jPanel274 = new javax.swing.JPanel();
        pl_std_15_di = new javax.swing.JComboBox<>();
        jPanel275 = new javax.swing.JPanel();
        pl_std_15_mi = new javax.swing.JComboBox<>();
        jPanel276 = new javax.swing.JPanel();
        pl_std_15_do = new javax.swing.JComboBox<>();
        jPanel277 = new javax.swing.JPanel();
        pl_std_15_fr = new javax.swing.JComboBox<>();
        jPanel278 = new javax.swing.JPanel();
        pl_std_15_sa = new javax.swing.JComboBox<>();
        jPanel279 = new javax.swing.JPanel();
        pl_std_15_so = new javax.swing.JComboBox<>();
        jPanel280 = new javax.swing.JPanel();
        pl_std_15_min = new javax.swing.JComboBox<>();
        jPanel281 = new javax.swing.JPanel();
        pl_std_15_max = new javax.swing.JComboBox<>();
        jPanel357 = new javax.swing.JPanel();
        pl_std_15_ab_min = new javax.swing.JComboBox<>();
        jPanel316 = new javax.swing.JPanel();
        pl_std_15_ab_max = new javax.swing.JComboBox<>();
        panel_h1_s16 = new javax.swing.JPanel();
        jLabel95 = new javax.swing.JLabel();
        jPanel282 = new javax.swing.JPanel();
        pl_std_16_mo = new javax.swing.JComboBox<>();
        jPanel283 = new javax.swing.JPanel();
        pl_std_16_di = new javax.swing.JComboBox<>();
        jPanel284 = new javax.swing.JPanel();
        pl_std_16_mi = new javax.swing.JComboBox<>();
        jPanel285 = new javax.swing.JPanel();
        pl_std_16_do = new javax.swing.JComboBox<>();
        jPanel286 = new javax.swing.JPanel();
        pl_std_16_fr = new javax.swing.JComboBox<>();
        jPanel287 = new javax.swing.JPanel();
        pl_std_16_sa = new javax.swing.JComboBox<>();
        jPanel288 = new javax.swing.JPanel();
        pl_std_16_so = new javax.swing.JComboBox<>();
        jPanel289 = new javax.swing.JPanel();
        pl_std_16_min = new javax.swing.JComboBox<>();
        jPanel290 = new javax.swing.JPanel();
        pl_std_16_max = new javax.swing.JComboBox<>();
        jPanel358 = new javax.swing.JPanel();
        pl_std_16_ab_min = new javax.swing.JComboBox<>();
        jPanel317 = new javax.swing.JPanel();
        pl_std_16_ab_max = new javax.swing.JComboBox<>();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();

        javax.swing.GroupLayout tempLayout = new javax.swing.GroupLayout(temp);
        temp.setLayout(tempLayout);
        tempLayout.setHorizontalGroup(
            tempLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        tempLayout.setVerticalGroup(
            tempLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(ConfigS.TITLE);
        setPreferredSize(new java.awt.Dimension(1024, 768));

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanelWest.setPreferredSize(new java.awt.Dimension(250, 322));
        jPanelWest.setLayout(new java.awt.BorderLayout());

        jTree1.setFont(Config.FONT_NORMAL_SANS);
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jTree1);

        jPanelWest.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanel3.add(jPanelWest, java.awt.BorderLayout.WEST);

        jPanelCard.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jPanelCardMouseExited(evt);
            }
        });
        jPanelCard.setLayout(new java.awt.CardLayout());

        javax.swing.GroupLayout pLeerLayout = new javax.swing.GroupLayout(pLeer);
        pLeer.setLayout(pLeerLayout);
        pLeerLayout.setHorizontalGroup(
            pLeerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 897, Short.MAX_VALUE)
        );
        pLeerLayout.setVerticalGroup(
            pLeerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 585, Short.MAX_VALUE)
        );

        jPanelCard.add(pLeer, "D_Empty");

        pMulti.setLayout(new java.awt.BorderLayout());

        jPanel383.setLayout(new javax.swing.BoxLayout(jPanel383, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel384.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton15.setFont(Config.FONT_NORMAL_SANS);
        jButton15.setText(" ✘ Alle ausgewählten Objekte löschen...");
        jButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton15ActionPerformed(evt);
            }
        });
        jPanel384.add(jButton15);

        jPanel383.add(jPanel384);

        pMulti.add(jPanel383, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pMulti, "D_Multi");

        pEinstellungen.setLayout(new java.awt.BorderLayout());

        jPanel8.setLayout(new java.awt.BorderLayout());

        jButton6.setFont(Config.FONT_NORMAL_SANS);
        jButton6.setText("🌐 CryptoMiniSat für Windows herunterladen...");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jPanel8.add(jButton6, java.awt.BorderLayout.WEST);

        jLabel5.setFont(Config.FONT_NORMAL_SANS);
        jLabel5.setText("Hinweis: Wähle das unterste, dann auf 'Artifacts' klicken, die 'cryptominisat5.zip' herunterladen und entpacken.");
        jPanel8.add(jLabel5, java.awt.BorderLayout.CENTER);

        pEinstellungen.add(jPanel8, java.awt.BorderLayout.NORTH);

        jPanel9.setLayout(new java.awt.BorderLayout());

        jPanel2.setLayout(new java.awt.BorderLayout());

        jButton4.setFont(Config.FONT_NORMAL_SANS);
        jButton4.setText("🌐 CryptoMiniSat für Linux herunterladen...");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton4, java.awt.BorderLayout.WEST);

        jLabel4.setFont(Config.FONT_NORMAL_SANS);
        jLabel4.setText("Hinweis: Die Datei ' cryptominisat5_amd64_linux_static.gz' herunterladen und entpacken.");
        jPanel2.add(jLabel4, java.awt.BorderLayout.CENTER);

        jPanel9.add(jPanel2, java.awt.BorderLayout.NORTH);

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel5.setLayout(new java.awt.BorderLayout());

        jButton5.setFont(Config.FONT_NORMAL_SANS);
        jButton5.setText("📂 CryptoMiniSat Pfad auswählen...");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jPanel5.add(jButton5, java.awt.BorderLayout.WEST);

        jTextField2.setFont(Config.FONT_NORMAL_SANS);
        jTextField2.setText(Config.get_solver_crypto_pfad());
        jPanel5.add(jTextField2, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel5, java.awt.BorderLayout.NORTH);

        jPanel6.setLayout(new java.awt.BorderLayout());

        jPanel10.setLayout(new java.awt.BorderLayout());

        jLabel6.setFont(Config.FONT_NORMAL_SANS);
        jLabel6.setText(" Testergebnis:");
        jPanel10.add(jLabel6, java.awt.BorderLayout.CENTER);

        jPanel11.setLayout(new java.awt.BorderLayout());

        jButton1.setFont(Config.FONT_NORMAL_SANS);
        jButton1.setText("☛ CryptoMiniSat testen");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel11.add(jButton1, java.awt.BorderLayout.WEST);

        jPanel10.add(jPanel11, java.awt.BorderLayout.WEST);

        jPanel6.add(jPanel10, java.awt.BorderLayout.NORTH);

        jTextArea1.setColumns(20);
        jTextArea1.setFont(Config.FONT_NORMAL_MONO);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jPanel6.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel6, java.awt.BorderLayout.CENTER);

        jPanel9.add(jPanel4, java.awt.BorderLayout.CENTER);

        pEinstellungen.add(jPanel9, java.awt.BorderLayout.CENTER);

        jPanelCard.add(pEinstellungen, "D_Einstellungen");

        pSchule.setLayout(new java.awt.BorderLayout());

        jPanel319.setLayout(new javax.swing.BoxLayout(jPanel319, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel133.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton7.setFont(Config.FONT_NORMAL_SANS);
        jButton7.setText("✘ ALLE SCHULDATEN KOMPLETT LÖSCHEN...");
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jPanel133.add(jButton7);

        jPanel319.add(jPanel133);

        jPanel327.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 10, 10));

        sc_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        sc_plan_laden.setText("▦ Plan editieren...");
        sc_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_plan_ladenActionPerformed(evt);
            }
        });
        jPanel327.add(sc_plan_laden);

        sc_planVR_laden.setFont(Config.FONT_NORMAL_SANS);
        sc_planVR_laden.setText("▦ Vertretungsreserven editieren...");
        sc_planVR_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_planVR_ladenActionPerformed(evt);
            }
        });
        jPanel327.add(sc_planVR_laden);

        sc_planVO_laden.setFont(Config.FONT_NORMAL_SANS);
        sc_planVO_laden.setText("▦ Vertretungsoptionen editieren...");
        sc_planVO_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_planVO_ladenActionPerformed(evt);
            }
        });
        jPanel327.add(sc_planVO_laden);

        jPanel319.add(jPanel327);

        jPanel14.setLayout(new java.awt.BorderLayout());

        jButtonSave.setFont(Config.FONT_NORMAL_SANS);
        jButtonSave.setText("🖫 Speichern ...");
        jButtonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveActionPerformed(evt);
            }
        });
        jPanel14.add(jButtonSave, java.awt.BorderLayout.WEST);

        jLabel8.setFont(Config.FONT_NORMAL_SANS);
        jLabel8.setText(" Speichert die aktuellen Daten. Es sollten momentan keine Berechnungen laufen.");
        jPanel14.add(jLabel8, java.awt.BorderLayout.CENTER);

        jPanel319.add(jPanel14);

        jPanel16.setLayout(new java.awt.BorderLayout());

        jButtonOpen.setFont(Config.FONT_NORMAL_SANS);
        jButtonOpen.setText("📂 Öffnen...");
        jButtonOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOpenActionPerformed(evt);
            }
        });
        jPanel16.add(jButtonOpen, java.awt.BorderLayout.WEST);

        jLabel10.setFont(Config.FONT_NORMAL_SANS);
        jLabel10.setText(" Öffnet zuvor gespeicherte Daten. Die aktuellen Daten werden gelöscht.");
        jPanel16.add(jLabel10, java.awt.BorderLayout.CENTER);

        jPanel319.add(jPanel16);

        jLabel20.setFont(Config.FONT_NORMAL_SANS);
        jLabel20.setText(" ");
        jPanel319.add(jLabel20);

        jPanel18.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Für den Plan der Schule gilt ...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel18.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 10, 0));

        pColumn1a.setLayout(new java.awt.BorderLayout());

        jLabel1.setFont(Config.FONT_NORMAL_SANS);
        jLabel1.setText("Tage pro Woche: ");
        pColumn1a.add(jLabel1, java.awt.BorderLayout.CENTER);

        sc_WochenTage.setFont(Config.FONT_NORMAL_SANS);
        sc_WochenTage.setModel(new javax.swing.SpinnerNumberModel(5, 5, 7, 1));
        sc_WochenTage.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sc_WochenTageStateChanged(evt);
            }
        });
        pColumn1a.add(sc_WochenTage, java.awt.BorderLayout.EAST);

        jPanel18.add(pColumn1a);

        pColumn2a.setLayout(new java.awt.BorderLayout());

        jLabel2.setFont(Config.FONT_NORMAL_SANS);
        jLabel2.setText("Letzte mögliche Stunde pro Tag: ");
        pColumn2a.add(jLabel2, java.awt.BorderLayout.CENTER);

        sc_StundenProTag.setFont(Config.FONT_NORMAL_SANS);
        sc_StundenProTag.setModel(new javax.swing.SpinnerNumberModel(6, 4, 16, 1));
        sc_StundenProTag.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sc_StundenProTagStateChanged(evt);
            }
        });
        pColumn2a.add(sc_StundenProTag, java.awt.BorderLayout.EAST);

        jPanel18.add(pColumn2a);

        jPanel319.add(jPanel18);

        jLabel21.setFont(Config.FONT_NORMAL_SANS);
        jLabel21.setText(" ");
        jPanel319.add(jLabel21);

        jPanel121.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Für sämtliche Lehrkräfte gilt ... (individuell überschreibbar)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel121.setLayout(new javax.swing.BoxLayout(jPanel121, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        pColumn1b.setLayout(new java.awt.BorderLayout());

        jLabel3.setFont(Config.FONT_NORMAL_SANS);
        jLabel3.setText("Max. Springst. pro Tag: ");
        pColumn1b.add(jLabel3, java.awt.BorderLayout.CENTER);

        sc_le_MaxSpringstundenProTag.setFont(Config.FONT_NORMAL_SANS);
        sc_le_MaxSpringstundenProTag.setModel(new javax.swing.SpinnerNumberModel(2, 0, 16, 1));
        sc_le_MaxSpringstundenProTag.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sc_le_MaxSpringstundenProTagStateChanged(evt);
            }
        });
        pColumn1b.add(sc_le_MaxSpringstundenProTag, java.awt.BorderLayout.EAST);

        jPanel1.add(pColumn1b);

        pColumn2b.setLayout(new java.awt.BorderLayout());

        jLabel19.setFont(Config.FONT_NORMAL_SANS);
        jLabel19.setText("Max. Springst. pro Woche: ");
        pColumn2b.add(jLabel19, java.awt.BorderLayout.CENTER);

        sc_le_MaxSpringstundenProWoche.setFont(Config.FONT_NORMAL_SANS);
        sc_le_MaxSpringstundenProWoche.setModel(new javax.swing.SpinnerNumberModel(4, 0, 16, 1));
        sc_le_MaxSpringstundenProWoche.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sc_le_MaxSpringstundenProWocheStateChanged(evt);
            }
        });
        pColumn2b.add(sc_le_MaxSpringstundenProWoche, java.awt.BorderLayout.EAST);

        jPanel1.add(pColumn2b);

        pColumn2b1.setLayout(new java.awt.BorderLayout());

        jLabel25.setFont(Config.FONT_NORMAL_SANS);
        jLabel25.setText("Max. Präsenz pro Tag: ");
        pColumn2b1.add(jLabel25, java.awt.BorderLayout.CENTER);

        sc_le_MaxTagesstundenpraesenz.setFont(Config.FONT_NORMAL_SANS);
        sc_le_MaxTagesstundenpraesenz.setModel(new javax.swing.SpinnerNumberModel(9, 2, 16, 1));
        sc_le_MaxTagesstundenpraesenz.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sc_le_MaxTagesstundenpraesenzStateChanged(evt);
            }
        });
        pColumn2b1.add(sc_le_MaxTagesstundenpraesenz, java.awt.BorderLayout.EAST);

        jPanel1.add(pColumn2b1);

        jPanel121.add(jPanel1);

        jPanel7.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        pColumn2b2.setLayout(new java.awt.BorderLayout());

        jLabel29.setFont(Config.FONT_NORMAL_SANS);
        jLabel29.setText("Min. Stunden pro Tag, außer frei (1 = deaktiviert): ");
        pColumn2b2.add(jLabel29, java.awt.BorderLayout.CENTER);

        sc_le_MinStundenProTag.setFont(Config.FONT_NORMAL_SANS);
        sc_le_MinStundenProTag.setModel(new javax.swing.SpinnerNumberModel(1, 1, 6, 1));
        sc_le_MinStundenProTag.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sc_le_MinStundenProTagStateChanged(evt);
            }
        });
        pColumn2b2.add(sc_le_MinStundenProTag, java.awt.BorderLayout.EAST);

        jPanel7.add(pColumn2b2);

        pColumn2b3.setLayout(new java.awt.BorderLayout());

        jLabel34.setFont(Config.FONT_NORMAL_SANS);
        jLabel34.setText("Max. Stunden in Folge (16 = deaktiviert) ");
        pColumn2b3.add(jLabel34, java.awt.BorderLayout.CENTER);

        sc_le_Max_Stunden_in_Folge.setFont(Config.FONT_NORMAL_SANS);
        sc_le_Max_Stunden_in_Folge.setModel(new javax.swing.SpinnerNumberModel(8, 1, 16, 1));
        sc_le_Max_Stunden_in_Folge.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sc_le_Max_Stunden_in_FolgeStateChanged(evt);
            }
        });
        pColumn2b3.add(sc_le_Max_Stunden_in_Folge, java.awt.BorderLayout.EAST);

        jPanel7.add(pColumn2b3);

        jPanel121.add(jPanel7);

        jPanel319.add(jPanel121);

        jLabel22.setFont(Config.FONT_NORMAL_SANS);
        jLabel22.setText(" ");
        jPanel319.add(jLabel22);

        jPanel338.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Für alle Kurse gilt: Keine Einzelstunde in der", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel338.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 10, 0));

        sc_keine_einzelstunde_in_1.setFont(Config.FONT_NORMAL_SANS);
        sc_keine_einzelstunde_in_1.setText("1. Stunde");
        sc_keine_einzelstunde_in_1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keine_einzelstunde_in_1ActionPerformed(evt);
            }
        });
        jPanel338.add(sc_keine_einzelstunde_in_1);

        sc_keine_einzelstunde_in_2.setFont(Config.FONT_NORMAL_SANS);
        sc_keine_einzelstunde_in_2.setText("2. Stunde");
        sc_keine_einzelstunde_in_2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keine_einzelstunde_in_2ActionPerformed(evt);
            }
        });
        jPanel338.add(sc_keine_einzelstunde_in_2);

        sc_keine_einzelstunde_in_3.setFont(Config.FONT_NORMAL_SANS);
        sc_keine_einzelstunde_in_3.setText("3. Stunde");
        sc_keine_einzelstunde_in_3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keine_einzelstunde_in_3ActionPerformed(evt);
            }
        });
        jPanel338.add(sc_keine_einzelstunde_in_3);

        sc_keine_einzelstunde_in_4.setFont(Config.FONT_NORMAL_SANS);
        sc_keine_einzelstunde_in_4.setText("4. Stunde");
        sc_keine_einzelstunde_in_4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keine_einzelstunde_in_4ActionPerformed(evt);
            }
        });
        jPanel338.add(sc_keine_einzelstunde_in_4);

        sc_keine_einzelstunde_in_5.setFont(Config.FONT_NORMAL_SANS);
        sc_keine_einzelstunde_in_5.setText("5. Stunde");
        sc_keine_einzelstunde_in_5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keine_einzelstunde_in_5ActionPerformed(evt);
            }
        });
        jPanel338.add(sc_keine_einzelstunde_in_5);

        sc_keine_einzelstunde_in_6.setFont(Config.FONT_NORMAL_SANS);
        sc_keine_einzelstunde_in_6.setText("6. Stunde");
        sc_keine_einzelstunde_in_6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keine_einzelstunde_in_6ActionPerformed(evt);
            }
        });
        jPanel338.add(sc_keine_einzelstunde_in_6);

        jPanel319.add(jPanel338);

        jLabel23.setFont(Config.FONT_NORMAL_SANS);
        jLabel23.setText(" ");
        jPanel319.add(jLabel23);

        jPanel364.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Für alle Kurse gilt: Verbiete Stundenübergänge von ... zu ...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel364.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 10, 0));

        sc_keinen_uebergang_1_2.setFont(Config.FONT_NORMAL_SANS);
        sc_keinen_uebergang_1_2.setText("1./2. Stunde");
        sc_keinen_uebergang_1_2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keinen_uebergang_1_2ActionPerformed(evt);
            }
        });
        jPanel364.add(sc_keinen_uebergang_1_2);

        sc_keinen_uebergang_2_3.setFont(Config.FONT_NORMAL_SANS);
        sc_keinen_uebergang_2_3.setText("2./3. Stunde");
        sc_keinen_uebergang_2_3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keinen_uebergang_2_3ActionPerformed(evt);
            }
        });
        jPanel364.add(sc_keinen_uebergang_2_3);

        sc_keinen_uebergang_3_4.setFont(Config.FONT_NORMAL_SANS);
        sc_keinen_uebergang_3_4.setText("3./4. Stunde");
        sc_keinen_uebergang_3_4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keinen_uebergang_3_4ActionPerformed(evt);
            }
        });
        jPanel364.add(sc_keinen_uebergang_3_4);

        sc_keinen_uebergang_4_5.setFont(Config.FONT_NORMAL_SANS);
        sc_keinen_uebergang_4_5.setText("4./5. Stunde");
        sc_keinen_uebergang_4_5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keinen_uebergang_4_5ActionPerformed(evt);
            }
        });
        jPanel364.add(sc_keinen_uebergang_4_5);

        sc_keinen_uebergang_5_6.setFont(Config.FONT_NORMAL_SANS);
        sc_keinen_uebergang_5_6.setText("5./6. Stunde");
        sc_keinen_uebergang_5_6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keinen_uebergang_5_6ActionPerformed(evt);
            }
        });
        jPanel364.add(sc_keinen_uebergang_5_6);

        sc_keinen_uebergang_6_7.setFont(Config.FONT_NORMAL_SANS);
        sc_keinen_uebergang_6_7.setText("6./.7 Stunde");
        sc_keinen_uebergang_6_7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keinen_uebergang_6_7ActionPerformed(evt);
            }
        });
        jPanel364.add(sc_keinen_uebergang_6_7);

        sc_keinen_uebergang_7_8.setFont(Config.FONT_NORMAL_SANS);
        sc_keinen_uebergang_7_8.setText("7./.8 Stunde");
        sc_keinen_uebergang_7_8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sc_keinen_uebergang_7_8ActionPerformed(evt);
            }
        });
        jPanel364.add(sc_keinen_uebergang_7_8);

        jPanel319.add(jPanel364);

        jLabel24.setFont(Config.FONT_NORMAL_SANS);
        jLabel24.setText(" ");
        jPanel319.add(jLabel24);

        jPanel378.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Optimiere ...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel378.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 0));

        jLabel32.setFont(Config.FONT_NORMAL_SANS);
        jLabel32.setText("Min. ");
        jPanel378.add(jLabel32);

        sc_min_aufeinanderfolgend.setFont(Config.FONT_NORMAL_SANS);
        sc_min_aufeinanderfolgend.setModel(new javax.swing.SpinnerNumberModel(0, 0, 9999, 1));
        sc_min_aufeinanderfolgend.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                sc_min_aufeinanderfolgendStateChanged(evt);
            }
        });
        jPanel378.add(sc_min_aufeinanderfolgend);

        jLabel33.setFont(Config.FONT_NORMAL_SANS);
        jLabel33.setText(" von ");
        jPanel378.add(jLabel33);

        sc_label_min_aufeinander_von.setFont(Config.FONT_NORMAL_SANS);
        sc_label_min_aufeinander_von.setText("0");
        jPanel378.add(sc_label_min_aufeinander_von);

        jLabel31.setFont(Config.FONT_NORMAL_SANS);
        jLabel31.setText(" Kursen nicht an aufeinanderfolgenden Tagen (nur 2-tätige Kurse).");
        jPanel378.add(jLabel31);
        jPanel378.add(filler1);

        jPanel319.add(jPanel378);

        pSchule.add(jPanel319, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pSchule, "D_Schule");

        pLehrkraefte.setLayout(new java.awt.BorderLayout());

        jPanel12.setLayout(new javax.swing.BoxLayout(jPanel12, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel28.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton13.setFont(Config.FONT_NORMAL_SANS);
        jButton13.setText(" ✘ Alle Lehrkräfte löschen...");
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });
        jPanel28.add(jButton13);

        jPanel12.add(jPanel28);

        jPanel326.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        lea_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        lea_plan_laden.setText("▦ Plan editieren...");
        lea_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lea_plan_ladenActionPerformed(evt);
            }
        });
        jPanel326.add(lea_plan_laden);

        jPanel12.add(jPanel326);

        jPanel29.setLayout(new java.awt.BorderLayout());

        jPanel30.setLayout(new java.awt.BorderLayout());

        jButton14.setFont(Config.FONT_NORMAL_SANS);
        jButton14.setText("➕ Neue Lehrkraft hinzufügen");
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton14ActionPerformed(evt);
            }
        });
        jPanel30.add(jButton14, java.awt.BorderLayout.WEST);

        jLabel12.setFont(Config.FONT_NORMAL_SANS);
        jLabel12.setText(" Fügt der Liste aller Lehrkräfte eine neue Lehrkraft hinzu. Das Kürzel sollte eindeutig sein.");
        jPanel30.add(jLabel12, java.awt.BorderLayout.CENTER);

        jPanel29.add(jPanel30, java.awt.BorderLayout.NORTH);

        jPanel31.setLayout(new java.awt.BorderLayout());

        jPanel32.setLayout(new java.awt.BorderLayout());
        jPanel31.add(jPanel32, java.awt.BorderLayout.NORTH);

        jPanel33.setLayout(new java.awt.BorderLayout());

        jPanel34.setLayout(new java.awt.BorderLayout());

        jPanel35.setLayout(new java.awt.BorderLayout());
        jPanel34.add(jPanel35, java.awt.BorderLayout.WEST);

        jPanel33.add(jPanel34, java.awt.BorderLayout.NORTH);

        jPanel31.add(jPanel33, java.awt.BorderLayout.CENTER);

        jPanel29.add(jPanel31, java.awt.BorderLayout.CENTER);

        jPanel12.add(jPanel29);

        pLehrkraefte.add(jPanel12, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pLehrkraefte, "D_Lehrkraefte");

        pLehrkraft.setLayout(new java.awt.BorderLayout());

        jPanel117.setLayout(new javax.swing.BoxLayout(jPanel117, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel36.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        le_diese_loeschen.setFont(Config.FONT_NORMAL_SANS);
        le_diese_loeschen.setText("✘ Diese Lehrkraft löschen...");
        le_diese_loeschen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                le_diese_loeschenActionPerformed(evt);
            }
        });
        jPanel36.add(le_diese_loeschen);

        jPanel117.add(jPanel36);

        jPanel330.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        le_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        le_plan_laden.setText("▦ Plan editieren...");
        le_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                le_plan_ladenActionPerformed(evt);
            }
        });
        jPanel330.add(le_plan_laden);

        jPanel117.add(jPanel330);

        jPanel37.setLayout(new java.awt.GridLayout(1, 0));

        jPanel38.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Kürzel", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel38.setLayout(new java.awt.BorderLayout());

        le_kuerzel.setFont(Config.FONT_NORMAL_SANS);
        le_kuerzel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                le_kuerzelKeyReleased(evt);
            }
        });
        jPanel38.add(le_kuerzel, java.awt.BorderLayout.CENTER);

        jPanel37.add(jPanel38);

        jPanel44.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Anzeigename", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel44.setLayout(new java.awt.BorderLayout());

        le_anzeigename.setFont(Config.FONT_NORMAL_SANS);
        le_anzeigename.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                le_anzeigenameKeyReleased(evt);
            }
        });
        jPanel44.add(le_anzeigename, java.awt.BorderLayout.CENTER);

        jPanel37.add(jPanel44);

        jPanel132.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Darf vertreten? (Vertretungsoption)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel132.setLayout(new java.awt.BorderLayout());

        le_darf_vertreten.setFont(Config.FONT_NORMAL_SANS);
        le_darf_vertreten.setText("Ja");
        le_darf_vertreten.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                le_darf_vertretenActionPerformed(evt);
            }
        });
        jPanel132.add(le_darf_vertreten, java.awt.BorderLayout.CENTER);

        jPanel37.add(jPanel132);

        jPanel117.add(jPanel37);

        jPanel131.setLayout(new java.awt.GridLayout(1, 0));

        jPanel66.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Bemerkungen", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel66.setLayout(new java.awt.BorderLayout());

        le_bemerkung.setFont(Config.FONT_NORMAL_SANS);
        le_bemerkung.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                le_bemerkungKeyReleased(evt);
            }
        });
        jPanel66.add(le_bemerkung, java.awt.BorderLayout.CENTER);

        jPanel131.add(jPanel66);

        jPanel117.add(jPanel131);

        jPanel39.setLayout(new java.awt.GridLayout(1, 0));

        jPanel53.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Freie Tage (mindestens)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel53.setLayout(new java.awt.BorderLayout());

        le_freie_tage.setFont(Config.FONT_NORMAL_SANS);
        le_freie_tage.setModel(new javax.swing.SpinnerNumberModel(0, 0, 4, 1));
        le_freie_tage.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_freie_tageStateChanged(evt);
            }
        });
        jPanel53.add(le_freie_tage, java.awt.BorderLayout.CENTER);

        jPanel39.add(jPanel53);

        jPanel118.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Mind. ___ mal erst ab der ___ Stunde", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel118.setLayout(new java.awt.BorderLayout());

        jPanel120.setLayout(new java.awt.GridLayout(1, 0));

        le_ab_stunde_x.setFont(Config.FONT_NORMAL_SANS);
        le_ab_stunde_x.setModel(new javax.swing.SpinnerNumberModel(0, 0, 5, 1));
        le_ab_stunde_x.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_ab_stunde_xStateChanged(evt);
            }
        });
        jPanel120.add(le_ab_stunde_x);

        le_ab_stunde_y.setFont(Config.FONT_NORMAL_SANS);
        le_ab_stunde_y.setModel(new javax.swing.SpinnerNumberModel(0, 0, 16, 1));
        le_ab_stunde_y.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_ab_stunde_yStateChanged(evt);
            }
        });
        jPanel120.add(le_ab_stunde_y);

        jPanel118.add(jPanel120, java.awt.BorderLayout.CENTER);

        jPanel39.add(jPanel118);

        jPanel119.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Mind. ___ mal nur bis zu ___ Stunde", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel119.setLayout(new java.awt.BorderLayout());

        jPanel124.setLayout(new java.awt.GridLayout(1, 0));

        le_bis_stunde_x.setFont(Config.FONT_NORMAL_SANS);
        le_bis_stunde_x.setModel(new javax.swing.SpinnerNumberModel(0, 0, 5, 1));
        le_bis_stunde_x.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_bis_stunde_xStateChanged(evt);
            }
        });
        jPanel124.add(le_bis_stunde_x);

        le_bis_stunde_y.setFont(Config.FONT_NORMAL_SANS);
        le_bis_stunde_y.setModel(new javax.swing.SpinnerNumberModel(0, 0, 16, 1));
        le_bis_stunde_y.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_bis_stunde_yStateChanged(evt);
            }
        });
        jPanel124.add(le_bis_stunde_y);

        jPanel119.add(jPanel124, java.awt.BorderLayout.CENTER);

        jPanel39.add(jPanel119);

        jPanel117.add(jPanel39);

        jPanel125.setLayout(new java.awt.GridLayout(1, 0));

        jPanel126.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Springstunden pro Tag (maximal)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel126.setLayout(new java.awt.GridLayout(1, 0));

        le_spring_pro_tag_check.setFont(Config.FONT_NORMAL_SANS);
        le_spring_pro_tag_check.setText("Standard nehmen");
        le_spring_pro_tag_check.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                le_spring_pro_tag_checkActionPerformed(evt);
            }
        });
        jPanel126.add(le_spring_pro_tag_check);

        le_spring_pro_tag_wert.setFont(Config.FONT_NORMAL_SANS);
        le_spring_pro_tag_wert.setModel(new javax.swing.SpinnerNumberModel(4, 0, 16, 1));
        le_spring_pro_tag_wert.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_spring_pro_tag_wertStateChanged(evt);
            }
        });
        jPanel126.add(le_spring_pro_tag_wert);

        jPanel125.add(jPanel126);

        jPanel128.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Springstunden pro Woche (maximal)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel128.setLayout(new java.awt.GridLayout(1, 0));

        le_spring_pro_woche_check.setFont(Config.FONT_NORMAL_SANS);
        le_spring_pro_woche_check.setText("Standard nehmen");
        le_spring_pro_woche_check.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                le_spring_pro_woche_checkActionPerformed(evt);
            }
        });
        jPanel128.add(le_spring_pro_woche_check);

        le_spring_pro_woche_wert.setFont(Config.FONT_NORMAL_SANS);
        le_spring_pro_woche_wert.setModel(new javax.swing.SpinnerNumberModel(8, 0, 16, 1));
        le_spring_pro_woche_wert.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_spring_pro_woche_wertStateChanged(evt);
            }
        });
        jPanel128.add(le_spring_pro_woche_wert);

        jPanel125.add(jPanel128);

        jPanel130.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Tagesstundenpräsenz (maximal)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel130.setLayout(new java.awt.GridLayout(1, 0));

        le_tagesstunden_check.setFont(Config.FONT_NORMAL_SANS);
        le_tagesstunden_check.setText("Standard nehmen");
        le_tagesstunden_check.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                le_tagesstunden_checkActionPerformed(evt);
            }
        });
        jPanel130.add(le_tagesstunden_check);

        le_tagesstunden_wert.setFont(Config.FONT_NORMAL_SANS);
        le_tagesstunden_wert.setModel(new javax.swing.SpinnerNumberModel(9, 0, 16, 1));
        le_tagesstunden_wert.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_tagesstunden_wertStateChanged(evt);
            }
        });
        jPanel130.add(le_tagesstunden_wert);

        jPanel125.add(jPanel130);

        jPanel117.add(jPanel125);

        jPanel363.setLayout(new java.awt.GridLayout(1, 0));

        jPanel365.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Min. Stunden pro Tag (1 = deaktiviert)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel365.setLayout(new java.awt.GridLayout(1, 0));

        le_min_std_pro_tag_check.setFont(Config.FONT_NORMAL_SANS);
        le_min_std_pro_tag_check.setText("Standard nehmen");
        le_min_std_pro_tag_check.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                le_min_std_pro_tag_checkActionPerformed(evt);
            }
        });
        jPanel365.add(le_min_std_pro_tag_check);

        le_min_std_pro_tag_spinner.setFont(Config.FONT_NORMAL_SANS);
        le_min_std_pro_tag_spinner.setModel(new javax.swing.SpinnerNumberModel(1, 1, 6, 1));
        le_min_std_pro_tag_spinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_min_std_pro_tag_spinnerStateChanged(evt);
            }
        });
        jPanel365.add(le_min_std_pro_tag_spinner);

        jPanel363.add(jPanel365);

        jPanel380.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Max. Stunden in Folge pro Tag", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel380.setLayout(new java.awt.GridLayout(1, 0));

        le_max_stunden_in_folge_check.setFont(Config.FONT_NORMAL_SANS);
        le_max_stunden_in_folge_check.setText("Standard nehmen");
        le_max_stunden_in_folge_check.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                le_max_stunden_in_folge_checkActionPerformed(evt);
            }
        });
        jPanel380.add(le_max_stunden_in_folge_check);

        le_max_stunden_in_folge_spinner.setFont(Config.FONT_NORMAL_SANS);
        le_max_stunden_in_folge_spinner.setModel(new javax.swing.SpinnerNumberModel(1, 1, 12, 1));
        le_max_stunden_in_folge_spinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                le_max_stunden_in_folge_spinnerStateChanged(evt);
            }
        });
        jPanel380.add(le_max_stunden_in_folge_spinner);

        jPanel363.add(jPanel380);

        jPanel376.setLayout(new java.awt.GridLayout(1, 0));
        jPanel363.add(jPanel376);

        jPanel117.add(jPanel363);

        pLehrkraft.add(jPanel117, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pLehrkraft, "D_Lehrkraft");

        pKlassen.setLayout(new java.awt.BorderLayout());

        jPanel328.setLayout(new javax.swing.BoxLayout(jPanel328, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel40.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton16.setFont(Config.FONT_NORMAL_SANS);
        jButton16.setText(" ✘ Alle Klassen löschen...");
        jButton16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton16ActionPerformed(evt);
            }
        });
        jPanel40.add(jButton16);

        jPanel328.add(jPanel40);

        jPanel329.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        kla_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        kla_plan_laden.setText("▦ Plan editieren...");
        kla_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kla_plan_ladenActionPerformed(evt);
            }
        });
        jPanel329.add(kla_plan_laden);

        jPanel328.add(jPanel329);

        jPanel41.setLayout(new java.awt.BorderLayout());

        jPanel42.setLayout(new java.awt.BorderLayout());

        jButton17.setFont(Config.FONT_NORMAL_SANS);
        jButton17.setText("➕ Neue Klasse hinzufügen");
        jButton17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton17ActionPerformed(evt);
            }
        });
        jPanel42.add(jButton17, java.awt.BorderLayout.WEST);

        jLabel13.setFont(Config.FONT_NORMAL_SANS);
        jLabel13.setText(" Fügt der Liste aller Klassen eine neue Klasse hinzu. Das Kürzel sollte eindeutig sein.");
        jPanel42.add(jLabel13, java.awt.BorderLayout.CENTER);

        jPanel41.add(jPanel42, java.awt.BorderLayout.NORTH);

        jPanel43.setLayout(new java.awt.BorderLayout());

        jPanel46.setLayout(new java.awt.BorderLayout());

        jPanel47.setLayout(new java.awt.BorderLayout());

        jPanel48.setLayout(new java.awt.BorderLayout());
        jPanel47.add(jPanel48, java.awt.BorderLayout.WEST);

        jPanel46.add(jPanel47, java.awt.BorderLayout.NORTH);

        jPanel43.add(jPanel46, java.awt.BorderLayout.CENTER);

        jPanel54.setLayout(new java.awt.BorderLayout());

        jButton19.setFont(Config.FONT_NORMAL_SANS);
        jButton19.setText("✘➕ Standardklassen (Grundschule, 2-zügig) laden...");
        jButton19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton19ActionPerformed(evt);
            }
        });
        jPanel54.add(jButton19, java.awt.BorderLayout.WEST);

        jLabel14.setFont(Config.FONT_NORMAL_SANS);
        jLabel14.setText(" Löscht alle Klassen und fügt die Klassen 1-4 mit den Kürzeln a-b hinzu.");
        jPanel54.add(jLabel14, java.awt.BorderLayout.CENTER);

        jPanel43.add(jPanel54, java.awt.BorderLayout.NORTH);

        jPanel41.add(jPanel43, java.awt.BorderLayout.CENTER);

        jPanel328.add(jPanel41);

        pKlassen.add(jPanel328, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pKlassen, "D_Klassen");

        pKlasse.setLayout(new java.awt.BorderLayout());

        jPanel49.setLayout(new javax.swing.BoxLayout(jPanel49, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel19.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton18.setFont(Config.FONT_NORMAL_SANS);
        jButton18.setText(" ✘ Diese Klasse löschen...");
        jButton18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton18ActionPerformed(evt);
            }
        });
        jPanel19.add(jButton18);

        jPanel49.add(jPanel19);

        jPanel13.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        kl_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        kl_plan_laden.setText("▦ Plan editieren...");
        kl_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kl_plan_ladenActionPerformed(evt);
            }
        });
        jPanel13.add(kl_plan_laden);

        jPanel49.add(jPanel13);

        jPanel51.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Kürzel", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel51.setLayout(new java.awt.BorderLayout());

        tf_klasse_kuerzel.setFont(Config.FONT_NORMAL_SANS);
        tf_klasse_kuerzel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tf_klasse_kuerzelKeyReleased(evt);
            }
        });
        jPanel51.add(tf_klasse_kuerzel, java.awt.BorderLayout.CENTER);

        jPanel49.add(jPanel51);

        pKlasse.add(jPanel49, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pKlasse, "D_Klasse");

        pFaecher.setLayout(new java.awt.BorderLayout());

        jPanel20.setLayout(new java.awt.BorderLayout());

        jButton10.setFont(Config.FONT_NORMAL_SANS);
        jButton10.setText(" ✘ Alle Fächer löschen...");
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });
        jPanel20.add(jButton10, java.awt.BorderLayout.EAST);

        pFaecher.add(jPanel20, java.awt.BorderLayout.NORTH);

        jPanel21.setLayout(new java.awt.BorderLayout());

        jPanel22.setLayout(new java.awt.BorderLayout());

        jButton11.setFont(Config.FONT_NORMAL_SANS);
        jButton11.setText("➕ Neues Fach hinzufügen");
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });
        jPanel22.add(jButton11, java.awt.BorderLayout.WEST);

        jLabel9.setFont(Config.FONT_NORMAL_SANS);
        jLabel9.setText(" Fügt der Liste aller Fächer ein neues Fach hinzu. Das Kürzel sollte eindeutig sein.");
        jPanel22.add(jLabel9, java.awt.BorderLayout.CENTER);

        jPanel21.add(jPanel22, java.awt.BorderLayout.NORTH);

        jPanel23.setLayout(new java.awt.BorderLayout());

        jPanel24.setLayout(new java.awt.BorderLayout());

        jButton12.setFont(Config.FONT_NORMAL_SANS);
        jButton12.setText("✘➕ Standardfächer (Grundschule) laden...");
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton12ActionPerformed(evt);
            }
        });
        jPanel24.add(jButton12, java.awt.BorderLayout.WEST);

        jLabel11.setFont(Config.FONT_NORMAL_SANS);
        jLabel11.setText(" Löscht alle Fächer und fügt eine Menge von Standardfächern hinzu.");
        jPanel24.add(jLabel11, java.awt.BorderLayout.CENTER);

        jPanel23.add(jPanel24, java.awt.BorderLayout.NORTH);

        jPanel25.setLayout(new java.awt.BorderLayout());

        jPanel26.setLayout(new java.awt.BorderLayout());

        jPanel27.setLayout(new java.awt.BorderLayout());
        jPanel26.add(jPanel27, java.awt.BorderLayout.WEST);

        jPanel25.add(jPanel26, java.awt.BorderLayout.NORTH);

        jPanel23.add(jPanel25, java.awt.BorderLayout.CENTER);

        jPanel21.add(jPanel23, java.awt.BorderLayout.CENTER);

        pFaecher.add(jPanel21, java.awt.BorderLayout.CENTER);

        jPanelCard.add(pFaecher, "D_Faecher");

        pFach.setLayout(new java.awt.BorderLayout());

        jPanel67.setLayout(new java.awt.BorderLayout());

        jButton23.setFont(Config.FONT_NORMAL_SANS);
        jButton23.setText(" ✘ Dieses Fach löschen...");
        jButton23.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton23ActionPerformed(evt);
            }
        });
        jPanel67.add(jButton23, java.awt.BorderLayout.EAST);

        pFach.add(jPanel67, java.awt.BorderLayout.NORTH);

        jPanel68.setLayout(new java.awt.BorderLayout());

        jPanel69.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Kürzel", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel69.setLayout(new java.awt.BorderLayout());

        tf_fach_kuerzel.setFont(Config.FONT_NORMAL_SANS);
        tf_fach_kuerzel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tf_fach_kuerzelKeyReleased(evt);
            }
        });
        jPanel69.add(tf_fach_kuerzel, java.awt.BorderLayout.CENTER);

        jPanel68.add(jPanel69, java.awt.BorderLayout.NORTH);

        jPanel70.setLayout(new java.awt.BorderLayout());

        jPanel71.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Anzeigename", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel71.setLayout(new java.awt.BorderLayout());

        tf_fach_anzeigename.setFont(Config.FONT_NORMAL_SANS);
        tf_fach_anzeigename.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tf_fach_anzeigenameKeyReleased(evt);
            }
        });
        jPanel71.add(tf_fach_anzeigename, java.awt.BorderLayout.CENTER);

        jPanel70.add(jPanel71, java.awt.BorderLayout.NORTH);

        jPanel68.add(jPanel70, java.awt.BorderLayout.CENTER);

        pFach.add(jPanel68, java.awt.BorderLayout.CENTER);

        jPanelCard.add(pFach, "D_Fach");

        pRaeume.setLayout(new java.awt.BorderLayout());

        jPanel320.setLayout(new javax.swing.BoxLayout(jPanel320, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel45.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton20.setFont(Config.FONT_NORMAL_SANS);
        jButton20.setText(" ✘ Alle Räume löschen...");
        jButton20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton20ActionPerformed(evt);
            }
        });
        jPanel45.add(jButton20);

        jPanel320.add(jPanel45);

        jPanel15.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        raa_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        raa_plan_laden.setText("▦ Plan editieren...");
        raa_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                raa_plan_ladenActionPerformed(evt);
            }
        });
        jPanel15.add(raa_plan_laden);

        jPanel320.add(jPanel15);

        jPanel55.setLayout(new java.awt.BorderLayout());

        jPanel56.setLayout(new java.awt.BorderLayout());

        jButton21.setFont(Config.FONT_NORMAL_SANS);
        jButton21.setText("➕ Neuen Raum hinzufügen");
        jButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton21ActionPerformed(evt);
            }
        });
        jPanel56.add(jButton21, java.awt.BorderLayout.WEST);

        jLabel15.setFont(Config.FONT_NORMAL_SANS);
        jLabel15.setText(" Fügt einen neuen Raum hinzu. Das Kürzel sollte eindeutig sein.");
        jPanel56.add(jLabel15, java.awt.BorderLayout.CENTER);

        jPanel55.add(jPanel56, java.awt.BorderLayout.NORTH);

        jPanel57.setLayout(new java.awt.BorderLayout());

        jPanel58.setLayout(new java.awt.BorderLayout());
        jPanel57.add(jPanel58, java.awt.BorderLayout.NORTH);

        jPanel59.setLayout(new java.awt.BorderLayout());

        jPanel60.setLayout(new java.awt.BorderLayout());

        jPanel61.setLayout(new java.awt.BorderLayout());
        jPanel60.add(jPanel61, java.awt.BorderLayout.WEST);

        jPanel59.add(jPanel60, java.awt.BorderLayout.NORTH);

        jPanel57.add(jPanel59, java.awt.BorderLayout.CENTER);

        jPanel55.add(jPanel57, java.awt.BorderLayout.CENTER);

        jPanel320.add(jPanel55);

        pRaeume.add(jPanel320, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pRaeume, "D_Raeume");

        pRaum.setLayout(new java.awt.BorderLayout());

        jPanel321.setLayout(new javax.swing.BoxLayout(jPanel321, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel62.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        ra_diesen_loeschen.setFont(Config.FONT_NORMAL_SANS);
        ra_diesen_loeschen.setText(" ✘ Diesen Raum löschen...");
        ra_diesen_loeschen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ra_diesen_loeschenActionPerformed(evt);
            }
        });
        jPanel62.add(ra_diesen_loeschen);

        jPanel321.add(jPanel62);

        jPanel17.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        ra_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        ra_plan_laden.setText("▦ Plan editieren...");
        ra_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ra_plan_ladenActionPerformed(evt);
            }
        });
        jPanel17.add(ra_plan_laden);

        jPanel321.add(jPanel17);

        jPanel63.setLayout(new java.awt.BorderLayout());

        jPanel64.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Kürzel", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel64.setLayout(new java.awt.BorderLayout());

        tf_raum_kuerzel.setFont(Config.FONT_NORMAL_SANS);
        tf_raum_kuerzel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tf_raum_kuerzelKeyReleased(evt);
            }
        });
        jPanel64.add(tf_raum_kuerzel, java.awt.BorderLayout.CENTER);

        jPanel63.add(jPanel64, java.awt.BorderLayout.NORTH);

        jPanel65.setLayout(new java.awt.BorderLayout());
        jPanel63.add(jPanel65, java.awt.BorderLayout.CENTER);

        jPanel321.add(jPanel63);

        pRaum.add(jPanel321, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pRaum, "D_Raum");

        pKopplungen.setLayout(new java.awt.BorderLayout());

        jPanel322.setLayout(new javax.swing.BoxLayout(jPanel322, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel72.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        koa_alle_loeschen.setFont(Config.FONT_NORMAL_SANS);
        koa_alle_loeschen.setText(" ✘ Alle Kopplungen löschen...");
        koa_alle_loeschen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                koa_alle_loeschenActionPerformed(evt);
            }
        });
        jPanel72.add(koa_alle_loeschen);

        jPanel322.add(jPanel72);

        jPanel331.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        koa_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        koa_plan_laden.setText("▦ Plan editieren...");
        koa_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                koa_plan_ladenActionPerformed(evt);
            }
        });
        jPanel331.add(koa_plan_laden);

        jPanel322.add(jPanel331);

        jPanel73.setLayout(new java.awt.BorderLayout());

        jPanel74.setLayout(new java.awt.BorderLayout());

        jButton25.setFont(Config.FONT_NORMAL_SANS);
        jButton25.setText("➕ Neue Kopplung hinzufügen");
        jButton25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton25ActionPerformed(evt);
            }
        });
        jPanel74.add(jButton25, java.awt.BorderLayout.WEST);

        jLabel16.setFont(Config.FONT_NORMAL_SANS);
        jLabel16.setText(" Fügt eine neue Kopplung hinzu. Das Kürzel sollte eindeutig sein.");
        jPanel74.add(jLabel16, java.awt.BorderLayout.CENTER);

        jPanel73.add(jPanel74, java.awt.BorderLayout.NORTH);

        jPanel75.setLayout(new java.awt.BorderLayout());

        jPanel76.setLayout(new java.awt.BorderLayout());
        jPanel75.add(jPanel76, java.awt.BorderLayout.NORTH);

        jPanel77.setLayout(new java.awt.BorderLayout());

        jPanel78.setLayout(new java.awt.BorderLayout());

        jPanel79.setLayout(new java.awt.BorderLayout());
        jPanel78.add(jPanel79, java.awt.BorderLayout.WEST);

        jPanel77.add(jPanel78, java.awt.BorderLayout.NORTH);

        jPanel75.add(jPanel77, java.awt.BorderLayout.CENTER);

        jPanel73.add(jPanel75, java.awt.BorderLayout.CENTER);

        jPanel322.add(jPanel73);

        pKopplungen.add(jPanel322, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pKopplungen, "D_Kopplungen");

        pKopplung.setLayout(new java.awt.BorderLayout());

        jPanel323.setLayout(new javax.swing.BoxLayout(jPanel323, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel80.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        ko_diese_loeschen.setFont(Config.FONT_NORMAL_SANS);
        ko_diese_loeschen.setText(" ✘ Diese Kopplung löschen...");
        ko_diese_loeschen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ko_diese_loeschenActionPerformed(evt);
            }
        });
        jPanel80.add(ko_diese_loeschen);

        jPanel323.add(jPanel80);

        jPanel332.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        ko_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        ko_plan_laden.setText("▦ Plan editieren...");
        ko_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ko_plan_ladenActionPerformed(evt);
            }
        });
        jPanel332.add(ko_plan_laden);

        jPanel323.add(jPanel332);

        jPanel333.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 0));

        ko_stunde_add.setFont(Config.FONT_NORMAL_SANS);
        ko_stunde_add.setText("➕ Stunde(n)...");
        ko_stunde_add.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ko_stunde_addActionPerformed(evt);
            }
        });
        jPanel333.add(ko_stunde_add);

        jPanel323.add(jPanel333);

        jPanel82.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Kürzel", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel82.setLayout(new java.awt.BorderLayout());

        tf_kopplung_kuerzel.setFont(Config.FONT_NORMAL_SANS);
        tf_kopplung_kuerzel.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tf_kopplung_kuerzelKeyReleased(evt);
            }
        });
        jPanel82.add(tf_kopplung_kuerzel, java.awt.BorderLayout.CENTER);

        jPanel323.add(jPanel82);

        jPanel84.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Anzeigename", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel84.setLayout(new java.awt.BorderLayout());

        tf_kopplung_anzeigename.setFont(Config.FONT_NORMAL_SANS);
        tf_kopplung_anzeigename.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tf_kopplung_anzeigenameKeyReleased(evt);
            }
        });
        jPanel84.add(tf_kopplung_anzeigename, java.awt.BorderLayout.CENTER);

        jPanel323.add(jPanel84);

        pKopplung.add(jPanel323, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pKopplung, "D_Kopplung");

        pKurse.setLayout(new java.awt.BorderLayout());

        jPanel324.setLayout(new javax.swing.BoxLayout(jPanel324, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel85.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton27.setFont(Config.FONT_NORMAL_SANS);
        jButton27.setText(" ✘ Alle Kurse löschen...");
        jButton27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton27ActionPerformed(evt);
            }
        });
        jPanel85.add(jButton27);

        jPanel324.add(jPanel85);

        jPanel325.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        kua_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        kua_plan_laden.setText("▦ Plan editieren...");
        kua_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kua_plan_ladenActionPerformed(evt);
            }
        });
        jPanel325.add(kua_plan_laden);

        jPanel324.add(jPanel325);

        jPanel86.setLayout(new java.awt.BorderLayout());

        jPanel87.setLayout(new java.awt.BorderLayout());

        jButton28.setFont(Config.FONT_NORMAL_SANS);
        jButton28.setText("➕ Neuen Kurs hinzufügen");
        jButton28.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton28ActionPerformed(evt);
            }
        });
        jPanel87.add(jButton28, java.awt.BorderLayout.WEST);

        jLabel17.setFont(Config.FONT_NORMAL_SANS);
        jLabel17.setText(" Fügt einen neuen Kurs hinzu.");
        jPanel87.add(jLabel17, java.awt.BorderLayout.CENTER);

        jPanel86.add(jPanel87, java.awt.BorderLayout.NORTH);

        jPanel88.setLayout(new java.awt.BorderLayout());

        jPanel89.setLayout(new java.awt.BorderLayout());
        jPanel88.add(jPanel89, java.awt.BorderLayout.NORTH);

        jPanel90.setLayout(new java.awt.BorderLayout());

        jPanel91.setLayout(new java.awt.BorderLayout());

        jPanel92.setLayout(new java.awt.BorderLayout());
        jPanel91.add(jPanel92, java.awt.BorderLayout.WEST);

        jPanel90.add(jPanel91, java.awt.BorderLayout.NORTH);

        jPanel88.add(jPanel90, java.awt.BorderLayout.CENTER);

        jPanel86.add(jPanel88, java.awt.BorderLayout.CENTER);

        jPanel324.add(jPanel86);

        jLabel28.setFont(Config.FONT_NORMAL_SANS);
        jLabel28.setText(" ");
        jPanel324.add(jLabel28);

        jPanel369.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Kurse sortieren nach ...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel369.setLayout(new java.awt.GridLayout(0, 4));

        buttonGroup5.add(jRadio_ku_sort_kl_fa_le);
        jRadio_ku_sort_kl_fa_le.setFont(Config.FONT_NORMAL_SANS);
        jRadio_ku_sort_kl_fa_le.setText("Klasse, Fach, Lehrkraft");
        jRadio_ku_sort_kl_fa_le.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_ku_sort_kl_fa_leActionPerformed(evt);
            }
        });
        jPanel369.add(jRadio_ku_sort_kl_fa_le);

        buttonGroup5.add(jRadio_ku_sort_kl_le_fa);
        jRadio_ku_sort_kl_le_fa.setFont(Config.FONT_NORMAL_SANS);
        jRadio_ku_sort_kl_le_fa.setText("Klasse, Lehrkraft, Fach");
        jRadio_ku_sort_kl_le_fa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_ku_sort_kl_le_faActionPerformed(evt);
            }
        });
        jPanel369.add(jRadio_ku_sort_kl_le_fa);

        buttonGroup5.add(jRadio_ku_sort_le_kl_fa);
        jRadio_ku_sort_le_kl_fa.setFont(Config.FONT_NORMAL_SANS);
        jRadio_ku_sort_le_kl_fa.setText("Lehrkraft, Klasse, Fach");
        jRadio_ku_sort_le_kl_fa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_ku_sort_le_kl_faActionPerformed(evt);
            }
        });
        jPanel369.add(jRadio_ku_sort_le_kl_fa);

        buttonGroup5.add(jRadio_ku_sort_le_fa_kl);
        jRadio_ku_sort_le_fa_kl.setFont(Config.FONT_NORMAL_SANS);
        jRadio_ku_sort_le_fa_kl.setText("Lehrkraft, Fach, Klasse");
        jRadio_ku_sort_le_fa_kl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_ku_sort_le_fa_klActionPerformed(evt);
            }
        });
        jPanel369.add(jRadio_ku_sort_le_fa_kl);

        buttonGroup5.add(jRadio_ku_sort_fa_kl_le);
        jRadio_ku_sort_fa_kl_le.setFont(Config.FONT_NORMAL_SANS);
        jRadio_ku_sort_fa_kl_le.setText("Fach, Klasse, Lehrkraft");
        jRadio_ku_sort_fa_kl_le.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_ku_sort_fa_kl_leActionPerformed(evt);
            }
        });
        jPanel369.add(jRadio_ku_sort_fa_kl_le);

        buttonGroup5.add(jRadio_ku_sort_fa_le_kl);
        jRadio_ku_sort_fa_le_kl.setFont(Config.FONT_NORMAL_SANS);
        jRadio_ku_sort_fa_le_kl.setText("Fach, Lehrkraft, Klasse");
        jRadio_ku_sort_fa_le_kl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_ku_sort_fa_le_klActionPerformed(evt);
            }
        });
        jPanel369.add(jRadio_ku_sort_fa_le_kl);

        jPanel324.add(jPanel369);

        pKurse.add(jPanel324, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pKurse, "D_Kurse");

        pKurs.setLayout(new java.awt.BorderLayout());

        jPanel81.setLayout(new javax.swing.BoxLayout(jPanel81, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel83.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton29.setFont(Config.FONT_NORMAL_SANS);
        jButton29.setText(" ✘ Diesen Kurs löschen...");
        jButton29.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton29ActionPerformed(evt);
            }
        });
        jPanel83.add(jButton29);

        jPanel81.add(jPanel83);

        jPanel334.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        kua_plan_laden1.setFont(Config.FONT_NORMAL_SANS);
        kua_plan_laden1.setText("▦ Plan editieren...");
        kua_plan_laden1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kua_plan_laden1ActionPerformed(evt);
            }
        });
        jPanel334.add(kua_plan_laden1);

        jPanel81.add(jPanel334);

        jPanel93.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 0, 0));

        jButton30.setFont(Config.FONT_NORMAL_SANS);
        jButton30.setText("➕ Stunde(n)...");
        jButton30.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton30ActionPerformed(evt);
            }
        });
        jPanel93.add(jButton30);

        jPanel81.add(jPanel93);

        jPanel95.setLayout(new java.awt.GridLayout(1, 0));

        jPanel98.setLayout(new java.awt.BorderLayout());

        jScrollPane3.setPreferredSize(new java.awt.Dimension(2, 200));

        jTable1.setFont(Config.FONT_NORMAL_SANS);
        jTable1.setModel(model.table_model_kurs_lehrer);
        jScrollPane3.setViewportView(jTable1);

        jPanel98.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        jPanel95.add(jPanel98);

        jPanel101.setLayout(new java.awt.BorderLayout());

        jScrollPane4.setPreferredSize(new java.awt.Dimension(2, 200));

        jTable2.setFont(Config.FONT_NORMAL_SANS);
        jTable2.setModel(model.table_model_kurs_klasse);
        jScrollPane4.setViewportView(jTable2);

        jPanel101.add(jScrollPane4, java.awt.BorderLayout.CENTER);

        jPanel95.add(jPanel101);

        jPanel99.setLayout(new java.awt.BorderLayout());

        jScrollPane5.setPreferredSize(new java.awt.Dimension(2, 200));

        jTable3.setFont(Config.FONT_NORMAL_SANS);
        jTable3.setModel(model.table_model_kurs_fach);
        jScrollPane5.setViewportView(jTable3);

        jPanel99.add(jScrollPane5, java.awt.BorderLayout.CENTER);

        jPanel95.add(jPanel99);

        jPanel100.setLayout(new java.awt.BorderLayout());

        jScrollPane6.setPreferredSize(new java.awt.Dimension(2, 200));

        jTable4.setFont(Config.FONT_NORMAL_SANS);
        jTable4.setModel(model.table_model_kurs_raum);
        jScrollPane6.setViewportView(jTable4);

        jPanel100.add(jScrollPane6, java.awt.BorderLayout.CENTER);

        jPanel95.add(jPanel100);

        jPanel102.setLayout(new java.awt.BorderLayout());

        jScrollPane7.setPreferredSize(new java.awt.Dimension(2, 200));

        jTable5.setFont(Config.FONT_NORMAL_SANS);
        jTable5.setModel(model.table_model_kurs_kopplung);
        jScrollPane7.setViewportView(jTable5);

        jPanel102.add(jScrollPane7, java.awt.BorderLayout.CENTER);

        jPanel95.add(jPanel102);

        jPanel81.add(jPanel95);

        jPanel122.setLayout(new java.awt.GridLayout(1, 0));

        jPanel123.setLayout(new java.awt.BorderLayout());

        jScrollPane8.setPreferredSize(new java.awt.Dimension(2, 200));

        jTable6.setFont(Config.FONT_NORMAL_SANS);
        jTable6.setModel(model.table_model_kurs_kurs);
        jScrollPane8.setViewportView(jTable6);

        jPanel123.add(jScrollPane8, java.awt.BorderLayout.CENTER);

        jPanel122.add(jPanel123);

        jPanel381.setLayout(new java.awt.BorderLayout());

        jScrollPane9.setPreferredSize(new java.awt.Dimension(2, 200));

        jTable7.setFont(Config.FONT_NORMAL_SANS);
        jTable7.setModel(model.table_model_kurs_hosp);
        jScrollPane9.setViewportView(jTable7);

        jPanel381.add(jScrollPane9, java.awt.BorderLayout.CENTER);

        jPanel122.add(jPanel381);

        jPanel379.setLayout(new java.awt.BorderLayout());
        jPanel122.add(jPanel379);

        jPanel81.add(jPanel122);

        jPanel96.setLayout(new java.awt.BorderLayout());

        jPanel97.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Zusatz (z.B. GK1)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel97.setLayout(new java.awt.BorderLayout());

        tf_kurs_ergaenzung.setFont(Config.FONT_NORMAL_SANS);
        tf_kurs_ergaenzung.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                tf_kurs_ergaenzungKeyReleased(evt);
            }
        });
        jPanel97.add(tf_kurs_ergaenzung, java.awt.BorderLayout.CENTER);

        jPanel96.add(jPanel97, java.awt.BorderLayout.NORTH);

        jPanel81.add(jPanel96);

        jPanel337.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        ku_vertretungsreserven.setFont(Config.FONT_NORMAL_SANS);
        ku_vertretungsreserven.setModel(new javax.swing.SpinnerNumberModel(0, 0, 5, 1));
        ku_vertretungsreserven.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                ku_vertretungsreservenStateChanged(evt);
            }
        });
        jPanel337.add(ku_vertretungsreserven);

        jLabel7.setFont(Config.FONT_NORMAL_SANS);
        jLabel7.setText("Vertretungsreserven (Lehrkräfte, die diesen Unterricht verlassen können)");
        jPanel337.add(jLabel7);

        jPanel81.add(jPanel337);

        jPanel377.setLayout(new java.awt.GridLayout(1, 0));

        ku_nicht_aufeinanderfolgend.setFont(Config.FONT_NORMAL_SANS);
        ku_nicht_aufeinanderfolgend.setText("nicht an aufeinanderfolgenden Tagen (gilt nur für 2-tägige Kurse)");
        ku_nicht_aufeinanderfolgend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ku_nicht_aufeinanderfolgendActionPerformed(evt);
            }
        });
        jPanel377.add(ku_nicht_aufeinanderfolgend);

        jPanel81.add(jPanel377);

        pKurs.add(jPanel81, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pKurs, "D_Kurs");

        pStunde.setLayout(new java.awt.BorderLayout());

        jPanel94.setLayout(new javax.swing.BoxLayout(jPanel94, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel103.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jButton31.setFont(Config.FONT_NORMAL_SANS);
        jButton31.setText(" ✘ Dieses Stundenelement löschen...");
        jButton31.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton31ActionPerformed(evt);
            }
        });
        jPanel103.add(jButton31);

        jPanel94.add(jPanel103);

        jPanel335.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        st_plan_laden.setFont(Config.FONT_NORMAL_SANS);
        st_plan_laden.setText("▦ Plan editieren...");
        st_plan_laden.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                st_plan_ladenActionPerformed(evt);
            }
        });
        jPanel335.add(st_plan_laden);

        jPanel94.add(jPanel335);

        jPanel105.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Wochenstunden", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel105.setLayout(new java.awt.GridLayout(0, 1));

        buttonGroup1.add(jRadioWochenstunden1);
        jRadioWochenstunden1.setFont(Config.FONT_NORMAL_SANS);
        jRadioWochenstunden1.setSelected(true);
        jRadioWochenstunden1.setText("Einzelstunde (an einem Tag).");
        jRadioWochenstunden1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioWochenstunden1ActionPerformed(evt);
            }
        });
        jPanel105.add(jRadioWochenstunden1);

        buttonGroup1.add(jRadioWochenstunden2);
        jRadioWochenstunden2.setFont(Config.FONT_NORMAL_SANS);
        jRadioWochenstunden2.setText("Doppelstunde (an einem Tag).");
        jRadioWochenstunden2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioWochenstunden2ActionPerformed(evt);
            }
        });
        jPanel105.add(jRadioWochenstunden2);

        buttonGroup1.add(jRadioWochenstunden3);
        jRadioWochenstunden3.setFont(Config.FONT_NORMAL_SANS);
        jRadioWochenstunden3.setText("Dreifachstunde (an  einem Tag).");
        jRadioWochenstunden3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioWochenstunden3ActionPerformed(evt);
            }
        });
        jPanel105.add(jRadioWochenstunden3);

        jPanel94.add(jPanel105);

        jPanel106.setLayout(new java.awt.BorderLayout());

        jPanel107.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Typ", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel107.setLayout(new java.awt.GridLayout(0, 1));

        buttonGroup2.add(jRadioStundenTyp1);
        jRadioStundenTyp1.setFont(Config.FONT_NORMAL_SANS);
        jRadioStundenTyp1.setSelected(true);
        jRadioStundenTyp1.setText("Typ \"n\": Die Wochenstunden finden jede Woche statt.");
        jRadioStundenTyp1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioStundenTyp1ActionPerformed(evt);
            }
        });
        jPanel107.add(jRadioStundenTyp1);

        buttonGroup2.add(jRadioStundenTyp2);
        jRadioStundenTyp2.setFont(Config.FONT_NORMAL_SANS);
        jRadioStundenTyp2.setText("Typ \"d\": Die Wochenstunden findet zweiwöchentlich statt, dafür in doppelter Anzahl.");
        jRadioStundenTyp2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioStundenTyp2ActionPerformed(evt);
            }
        });
        jPanel107.add(jRadioStundenTyp2);

        buttonGroup2.add(jRadioStundenTyp3);
        jRadioStundenTyp3.setFont(Config.FONT_NORMAL_SANS);
        jRadioStundenTyp3.setText("Typ \"x\": Das Programm wählt zwischen Typ \"n\" oder Typ \"d\" selbständig. (NOCH NICHT IMPLEMENTIERT!)");
        jRadioStundenTyp3.setEnabled(false);
        jRadioStundenTyp3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioStundenTyp3ActionPerformed(evt);
            }
        });
        jPanel107.add(jRadioStundenTyp3);

        jPanel106.add(jPanel107, java.awt.BorderLayout.NORTH);

        jPanel94.add(jPanel106);

        jPanel366.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Lage des Stundenelementes (bei allen beteiligten Klassen)...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel366.setLayout(new java.awt.GridLayout(0, 4));

        buttonGroup3.add(jRadio_kl_Lage_Egal);
        jRadio_kl_Lage_Egal.setFont(Config.FONT_NORMAL_SANS);
        jRadio_kl_Lage_Egal.setText("Egal");
        jRadio_kl_Lage_Egal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_kl_Lage_EgalActionPerformed(evt);
            }
        });
        jPanel366.add(jRadio_kl_Lage_Egal);

        buttonGroup3.add(jRadio_kl_Lage_Anfang);
        jRadio_kl_Lage_Anfang.setFont(Config.FONT_NORMAL_SANS);
        jRadio_kl_Lage_Anfang.setText("Am Anfang");
        jRadio_kl_Lage_Anfang.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_kl_Lage_AnfangActionPerformed(evt);
            }
        });
        jPanel366.add(jRadio_kl_Lage_Anfang);

        buttonGroup3.add(jRadio_kl_Lage_Nicht_Anfang);
        jRadio_kl_Lage_Nicht_Anfang.setFont(Config.FONT_NORMAL_SANS);
        jRadio_kl_Lage_Nicht_Anfang.setText("Nicht am Anfang");
        jRadio_kl_Lage_Nicht_Anfang.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_kl_Lage_Nicht_AnfangActionPerformed(evt);
            }
        });
        jPanel366.add(jRadio_kl_Lage_Nicht_Anfang);

        buttonGroup3.add(jRadio_kl_Lage_Ende);
        jRadio_kl_Lage_Ende.setFont(Config.FONT_NORMAL_SANS);
        jRadio_kl_Lage_Ende.setText("Am Ende");
        jRadio_kl_Lage_Ende.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_kl_Lage_EndeActionPerformed(evt);
            }
        });
        jPanel366.add(jRadio_kl_Lage_Ende);

        buttonGroup3.add(jRadio_kl_Lage_Nicht_Ende);
        jRadio_kl_Lage_Nicht_Ende.setFont(Config.FONT_NORMAL_SANS);
        jRadio_kl_Lage_Nicht_Ende.setText("Nicht am Ende");
        jRadio_kl_Lage_Nicht_Ende.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_kl_Lage_Nicht_EndeActionPerformed(evt);
            }
        });
        jPanel366.add(jRadio_kl_Lage_Nicht_Ende);

        buttonGroup3.add(jRadio_kl_Lage_Rand);
        jRadio_kl_Lage_Rand.setFont(Config.FONT_NORMAL_SANS);
        jRadio_kl_Lage_Rand.setText("Am Rand");
        jRadio_kl_Lage_Rand.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_kl_Lage_RandActionPerformed(evt);
            }
        });
        jPanel366.add(jRadio_kl_Lage_Rand);

        buttonGroup3.add(jRadio_kl_Lage_Nicht_Rand);
        jRadio_kl_Lage_Nicht_Rand.setFont(Config.FONT_NORMAL_SANS);
        jRadio_kl_Lage_Nicht_Rand.setText("Nicht am Rand");
        jRadio_kl_Lage_Nicht_Rand.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_kl_Lage_Nicht_RandActionPerformed(evt);
            }
        });
        jPanel366.add(jRadio_kl_Lage_Nicht_Rand);

        jPanel94.add(jPanel366);

        jPanel367.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Lage des Stundenelementes (bei allen beteiligten Lehrkräften)...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel367.setLayout(new java.awt.GridLayout(0, 4));

        buttonGroup4.add(jRadio_le2_Lage_Egal);
        jRadio_le2_Lage_Egal.setFont(Config.FONT_NORMAL_SANS);
        jRadio_le2_Lage_Egal.setSelected(true);
        jRadio_le2_Lage_Egal.setText("Egal");
        jRadio_le2_Lage_Egal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_le2_Lage_EgalActionPerformed(evt);
            }
        });
        jPanel367.add(jRadio_le2_Lage_Egal);

        buttonGroup4.add(jRadio_le_Lage_Anfang);
        jRadio_le_Lage_Anfang.setFont(Config.FONT_NORMAL_SANS);
        jRadio_le_Lage_Anfang.setText("Am Anfang");
        jRadio_le_Lage_Anfang.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_le_Lage_AnfangActionPerformed(evt);
            }
        });
        jPanel367.add(jRadio_le_Lage_Anfang);

        buttonGroup4.add(jRadio_le_Lage_Nicht_Anfang);
        jRadio_le_Lage_Nicht_Anfang.setFont(Config.FONT_NORMAL_SANS);
        jRadio_le_Lage_Nicht_Anfang.setText("Nicht am Anfang");
        jRadio_le_Lage_Nicht_Anfang.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_le_Lage_Nicht_AnfangActionPerformed(evt);
            }
        });
        jPanel367.add(jRadio_le_Lage_Nicht_Anfang);

        buttonGroup4.add(jRadio_le_Lage_Ende);
        jRadio_le_Lage_Ende.setFont(Config.FONT_NORMAL_SANS);
        jRadio_le_Lage_Ende.setText("Am Ende");
        jRadio_le_Lage_Ende.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_le_Lage_EndeActionPerformed(evt);
            }
        });
        jPanel367.add(jRadio_le_Lage_Ende);

        buttonGroup4.add(jRadio_le_Lage_Nicht_Ende);
        jRadio_le_Lage_Nicht_Ende.setFont(Config.FONT_NORMAL_SANS);
        jRadio_le_Lage_Nicht_Ende.setText("Nicht am Ende");
        jRadio_le_Lage_Nicht_Ende.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_le_Lage_Nicht_EndeActionPerformed(evt);
            }
        });
        jPanel367.add(jRadio_le_Lage_Nicht_Ende);

        buttonGroup4.add(jRadio_le_Lage_Rand);
        jRadio_le_Lage_Rand.setFont(Config.FONT_NORMAL_SANS);
        jRadio_le_Lage_Rand.setText("Am Rand");
        jRadio_le_Lage_Rand.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_le_Lage_RandActionPerformed(evt);
            }
        });
        jPanel367.add(jRadio_le_Lage_Rand);

        buttonGroup4.add(jRadio_le_Lage_Nicht_Rand);
        jRadio_le_Lage_Nicht_Rand.setFont(Config.FONT_NORMAL_SANS);
        jRadio_le_Lage_Nicht_Rand.setText("Nicht am Rand");
        jRadio_le_Lage_Nicht_Rand.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadio_le_Lage_Nicht_RandActionPerformed(evt);
            }
        });
        jPanel367.add(jRadio_le_Lage_Nicht_Rand);

        jPanel94.add(jPanel367);

        pStunde.add(jPanel94, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pStunde, "D_Stunde");

        pBerechnungen.setLayout(new java.awt.BorderLayout());

        jPanel382.setLayout(new javax.swing.BoxLayout(jPanel382, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel108.setLayout(new java.awt.BorderLayout());

        jButton32.setFont(Config.FONT_NORMAL_SANS);
        jButton32.setText(" ✘ Alle Berechnungen beenden und löschen ...");
        jButton32.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton32ActionPerformed(evt);
            }
        });
        jPanel108.add(jButton32, java.awt.BorderLayout.EAST);

        jPanel382.add(jPanel108);

        jPanel109.setLayout(new java.awt.BorderLayout());

        jPanel110.setLayout(new java.awt.BorderLayout());

        jButton33.setFont(Config.FONT_NORMAL_SANS);
        jButton33.setText("➕ Neue Berechnung starten");
        jButton33.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton33ActionPerformed(evt);
            }
        });
        jPanel110.add(jButton33, java.awt.BorderLayout.WEST);

        jLabel18.setFont(Config.FONT_NORMAL_SANS);
        jLabel18.setText(" Startet eine neue Berechnung mit den aktuellen Einstellungen.");
        jPanel110.add(jLabel18, java.awt.BorderLayout.CENTER);

        jPanel109.add(jPanel110, java.awt.BorderLayout.NORTH);

        jPanel111.setLayout(new java.awt.BorderLayout());

        jPanel112.setLayout(new java.awt.BorderLayout());
        jPanel111.add(jPanel112, java.awt.BorderLayout.NORTH);

        jPanel113.setLayout(new java.awt.BorderLayout());

        jPanel114.setLayout(new java.awt.BorderLayout());

        jPanel115.setLayout(new java.awt.BorderLayout());
        jPanel114.add(jPanel115, java.awt.BorderLayout.WEST);

        jPanel113.add(jPanel114, java.awt.BorderLayout.NORTH);

        jPanel111.add(jPanel113, java.awt.BorderLayout.CENTER);

        jPanel109.add(jPanel111, java.awt.BorderLayout.CENTER);

        jPanel382.add(jPanel109);

        jPanel385.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jLabel35.setFont(Config.FONT_NORMAL_SANS);
        jLabel35.setText("Die folgenden Optionen deaktivieren (falls selektiert) bestimmte Funktionen.");
        jPanel385.add(jLabel35);

        jPanel382.add(jPanel385);

        jPanel387.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jLabel36.setFont(Config.FONT_NORMAL_SANS);
        jLabel36.setText("Sie dienen als Fehleranalyse und sollten eigentlich stets deaktiviert bleiben.");
        jPanel387.add(jLabel36);

        jPanel382.add(jPanel387);

        jPanel386.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Lehrkräfte", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, Config.FONT_NORMAL_HEADER));
        jPanel386.setLayout(new java.awt.GridLayout(0, 4));

        bea_1.setFont(Config.FONT_NORMAL_SANS);
        bea_1.setText("freie Tage");
        bea_1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_1ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_1);

        bea_2.setFont(Config.FONT_NORMAL_SANS);
        bea_2.setText("erst ab Stunde");
        bea_2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_2ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_2);

        bea_3.setFont(Config.FONT_NORMAL_SANS);
        bea_3.setText("nur bis Stunde");
        bea_3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_3ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_3);

        bea_4.setFont(Config.FONT_NORMAL_SANS);
        bea_4.setText("Springstunden (Tag)");
        bea_4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_4ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_4);

        bea_5.setFont(Config.FONT_NORMAL_SANS);
        bea_5.setText("Springstunden (Woche)");
        bea_5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_5ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_5);

        bea_6.setFont(Config.FONT_NORMAL_SANS);
        bea_6.setText("Tagesstundenpräsenz");
        bea_6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_6ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_6);

        bea_7.setFont(Config.FONT_NORMAL_SANS);
        bea_7.setText("Min. Stunden pro Tag");
        bea_7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_7ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_7);

        bea_8.setFont(Config.FONT_NORMAL_SANS);
        bea_8.setText("Max. Stunden in Folge");
        bea_8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_8ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_8);

        bea_9.setFont(Config.FONT_NORMAL_SANS);
        bea_9.setText("Plan (Spalte - Min.)");
        bea_9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_9ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_9);

        bea_10.setFont(Config.FONT_NORMAL_SANS);
        bea_10.setText("Plan (Spalte - Max.)");
        bea_10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_10ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_10);

        bea_11.setFont(Config.FONT_NORMAL_SANS);
        bea_11.setText("Plan (Zeile - Min.)");
        bea_11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_11ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_11);

        bea_12.setFont(Config.FONT_NORMAL_SANS);
        bea_12.setText("Plan (Zeile - Max.)");
        bea_12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_12ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_12);

        bea_13.setFont(Config.FONT_NORMAL_SANS);
        bea_13.setText("Plan (Zeile - Min. Ab.)");
        bea_13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_13ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_13);

        bea_14.setFont(Config.FONT_NORMAL_SANS);
        bea_14.setText("Plan (Zeile - Max. Ab.)");
        bea_14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_14ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_14);

        bea_15.setFont(Config.FONT_NORMAL_SANS);
        bea_15.setText("Plan (Zellen)");
        bea_15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bea_15ActionPerformed(evt);
            }
        });
        jPanel386.add(bea_15);

        jPanel382.add(jPanel386);

        pBerechnungen.add(jPanel382, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pBerechnungen, "D_Berechnungen");

        pBerechnung.setLayout(new java.awt.BorderLayout());

        jPanel116.setLayout(new java.awt.BorderLayout());

        jButton34.setFont(Config.FONT_NORMAL_SANS);
        jButton34.setText(" ✘ Diese Berechnung beenden und löschen...");
        jButton34.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton34ActionPerformed(evt);
            }
        });
        jPanel116.add(jButton34, java.awt.BorderLayout.EAST);

        pBerechnung.add(jPanel116, java.awt.BorderLayout.NORTH);

        jPanel374.setLayout(new java.awt.BorderLayout());

        beTextPaneAlles.setContentType("text/html"); // NOI18N
        beTextPaneAlles.setFont(Config.FONT_NORMAL_SANS);
        scrollTextPaneAlles.setViewportView(beTextPaneAlles);

        jPanel374.add(scrollTextPaneAlles, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Alles", jPanel374);

        jPanel370.setLayout(new java.awt.BorderLayout());

        beTextPaneStatistik.setContentType("text/html"); // NOI18N
        beTextPaneStatistik.setFont(Config.FONT_NORMAL_MONO);
        jScrollPane15.setViewportView(beTextPaneStatistik);

        jPanel370.add(jScrollPane15, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Statistik", jPanel370);

        jPanel52.setLayout(new java.awt.BorderLayout());

        beTextPaneLehrkraefte.setContentType("text/html"); // NOI18N
        beTextPaneLehrkraefte.setFont(Config.FONT_NORMAL_SANS);
        scrollTextPaneLehrkraefte.setViewportView(beTextPaneLehrkraefte);

        jPanel52.add(scrollTextPaneLehrkraefte, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Lehrkräfte", jPanel52);

        jPanel368.setLayout(new java.awt.BorderLayout());

        beTextPaneKlassen.setContentType("text/html"); // NOI18N
        beTextPaneKlassen.setFont(Config.FONT_NORMAL_SANS);
        scrollTextPaneKlassen.setViewportView(beTextPaneKlassen);

        jPanel368.add(scrollTextPaneKlassen, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Klassen", jPanel368);

        jPanel371.setLayout(new java.awt.BorderLayout());

        beTextPaneRaeume.setContentType("text/html"); // NOI18N
        beTextPaneRaeume.setFont(Config.FONT_NORMAL_SANS);
        scrollTextPaneRaeume.setViewportView(beTextPaneRaeume);

        jPanel371.add(scrollTextPaneRaeume, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Räume", jPanel371);

        jPanel372.setLayout(new java.awt.BorderLayout());

        beTextPaneVertretungsreserven.setContentType("text/html"); // NOI18N
        beTextPaneVertretungsreserven.setFont(Config.FONT_NORMAL_SANS);
        scrollTextPaneVertretungsreserven.setViewportView(beTextPaneVertretungsreserven);

        jPanel372.add(scrollTextPaneVertretungsreserven, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Vertretungsreserven", jPanel372);

        jPanel373.setLayout(new java.awt.BorderLayout());

        beTextPaneVertretungsoptionen.setContentType("text/html"); // NOI18N
        beTextPaneVertretungsoptionen.setFont(Config.FONT_NORMAL_SANS);
        scrollTextPaneVertretungsoptionen.setViewportView(beTextPaneVertretungsoptionen);

        jPanel373.add(scrollTextPaneVertretungsoptionen, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Vertretungsoptionen", jPanel373);

        pBerechnung.add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        jPanelCard.add(pBerechnung, "D_Berechnung");

        pPlan.setLayout(new java.awt.BorderLayout());

        jPanel104.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jPanel104MouseExited(evt);
            }
        });
        jPanel104.setLayout(new javax.swing.BoxLayout(jPanel104, javax.swing.BoxLayout.PAGE_AXIS));

        jPanel50.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_button_zurueck.setText("↩ Zurück");
        pl_button_zurueck.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pl_button_zurueckActionPerformed(evt);
            }
        });
        jPanel50.add(pl_button_zurueck);

        jPanel104.add(jPanel50);

        jPanel336.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        plan_diesen_loeschen.setText(" ⮿ Diesen Plan leeren ...");
        plan_diesen_loeschen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                plan_diesen_loeschenActionPerformed(evt);
            }
        });
        jPanel336.add(plan_diesen_loeschen);

        jPanel104.add(jPanel336);

        jPanel375.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        plan_alle_loeschen.setText(" ⮿ ALLE PLÄNE DER SCHULE LEEREN ...");
        plan_alle_loeschen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                plan_alle_loeschenActionPerformed(evt);
            }
        });
        jPanel375.add(plan_alle_loeschen);

        jPanel104.add(jPanel375);

        panel_h_header1a.setLayout(new java.awt.GridBagLayout());

        javax.swing.GroupLayout panelDummy1Layout = new javax.swing.GroupLayout(panelDummy1);
        panelDummy1.setLayout(panelDummy1Layout);
        panelDummy1Layout.setHorizontalGroup(
            panelDummy1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy1Layout.setVerticalGroup(
            panelDummy1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy1, gridBagConstraints);

        javax.swing.GroupLayout panelDummy2Layout = new javax.swing.GroupLayout(panelDummy2);
        panelDummy2.setLayout(panelDummy2Layout);
        panelDummy2Layout.setHorizontalGroup(
            panelDummy2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy2Layout.setVerticalGroup(
            panelDummy2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy2, gridBagConstraints);

        javax.swing.GroupLayout panelDummy3Layout = new javax.swing.GroupLayout(panelDummy3);
        panelDummy3.setLayout(panelDummy3Layout);
        panelDummy3Layout.setHorizontalGroup(
            panelDummy3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy3Layout.setVerticalGroup(
            panelDummy3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy3, gridBagConstraints);

        javax.swing.GroupLayout panelDummy4Layout = new javax.swing.GroupLayout(panelDummy4);
        panelDummy4.setLayout(panelDummy4Layout);
        panelDummy4Layout.setHorizontalGroup(
            panelDummy4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy4Layout.setVerticalGroup(
            panelDummy4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy4, gridBagConstraints);

        javax.swing.GroupLayout panelDummy5Layout = new javax.swing.GroupLayout(panelDummy5);
        panelDummy5.setLayout(panelDummy5Layout);
        panelDummy5Layout.setHorizontalGroup(
            panelDummy5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy5Layout.setVerticalGroup(
            panelDummy5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy5, gridBagConstraints);

        javax.swing.GroupLayout panelDummy6Layout = new javax.swing.GroupLayout(panelDummy6);
        panelDummy6.setLayout(panelDummy6Layout);
        panelDummy6Layout.setHorizontalGroup(
            panelDummy6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy6Layout.setVerticalGroup(
            panelDummy6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy6, gridBagConstraints);

        javax.swing.GroupLayout panelDummy7Layout = new javax.swing.GroupLayout(panelDummy7);
        panelDummy7.setLayout(panelDummy7Layout);
        panelDummy7Layout.setHorizontalGroup(
            panelDummy7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy7Layout.setVerticalGroup(
            panelDummy7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy7, gridBagConstraints);

        javax.swing.GroupLayout panelDummy8Layout = new javax.swing.GroupLayout(panelDummy8);
        panelDummy8.setLayout(panelDummy8Layout);
        panelDummy8Layout.setHorizontalGroup(
            panelDummy8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy8Layout.setVerticalGroup(
            panelDummy8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy8, gridBagConstraints);

        javax.swing.GroupLayout panelDummy9Layout = new javax.swing.GroupLayout(panelDummy9);
        panelDummy9.setLayout(panelDummy9Layout);
        panelDummy9Layout.setHorizontalGroup(
            panelDummy9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy9Layout.setVerticalGroup(
            panelDummy9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy9, gridBagConstraints);

        javax.swing.GroupLayout panelDummy10Layout = new javax.swing.GroupLayout(panelDummy10);
        panelDummy10.setLayout(panelDummy10Layout);
        panelDummy10Layout.setHorizontalGroup(
            panelDummy10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy10Layout.setVerticalGroup(
            panelDummy10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy10, gridBagConstraints);

        javax.swing.GroupLayout panelDummy11Layout = new javax.swing.GroupLayout(panelDummy11);
        panelDummy11.setLayout(panelDummy11Layout);
        panelDummy11Layout.setHorizontalGroup(
            panelDummy11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy11Layout.setVerticalGroup(
            panelDummy11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy11, gridBagConstraints);

        javax.swing.GroupLayout panelDummy12Layout = new javax.swing.GroupLayout(panelDummy12);
        panelDummy12.setLayout(panelDummy12Layout);
        panelDummy12Layout.setHorizontalGroup(
            panelDummy12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy12Layout.setVerticalGroup(
            panelDummy12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 11;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(panelDummy12, gridBagConstraints);

        jPanel139.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(jPanel139, gridBagConstraints);

        jPanel301.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 5));

        jLabel26.setFont(jLabel26.getFont().deriveFont(jLabel26.getFont().getStyle() | java.awt.Font.BOLD, jLabel26.getFont().getSize()+4));
        jLabel26.setText("Spaltensummen");
        jPanel301.add(jLabel26);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(jPanel301, gridBagConstraints);

        jPanel359.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1a.add(jPanel359, gridBagConstraints);

        jPanel104.add(panel_h_header1a);

        panel_h_min.setLayout(new java.awt.GridLayout(1, 0));

        jPanel291.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jLabel30.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        jLabel30.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel30.setText("min.:");
        jPanel291.add(jLabel30);

        panel_h_min.add(jPanel291);

        jPanel127.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_mo_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel127.add(pl_mo_min);

        panel_h_min.add(jPanel127);

        jPanel129.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_di_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel129.add(pl_di_min);

        panel_h_min.add(jPanel129);

        jPanel134.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_mi_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel134.add(pl_mi_min);

        panel_h_min.add(jPanel134);

        jPanel135.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_do_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel135.add(pl_do_min);

        panel_h_min.add(jPanel135);

        jPanel136.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_fr_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel136.add(pl_fr_min);

        panel_h_min.add(jPanel136);

        jPanel137.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_sa_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel137.add(pl_sa_min);

        panel_h_min.add(jPanel137);

        jPanel138.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_so_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel138.add(pl_so_min);

        panel_h_min.add(jPanel138);

        jPanel293.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        panel_h_min.add(jPanel293);

        jPanel294.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        panel_h_min.add(jPanel294);

        jPanel295.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        panel_h_min.add(jPanel295);

        jPanel342.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        panel_h_min.add(jPanel342);

        jPanel104.add(panel_h_min);

        panel_h_max.setLayout(new java.awt.GridLayout(1, 0));

        jPanel292.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 0, 0));

        jLabel_max.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        jLabel_max.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel_max.setText("max.:");
        jPanel292.add(jLabel_max);

        panel_h_max.add(jPanel292);

        jPanel140.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_mo_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel140.add(pl_mo_max);

        panel_h_max.add(jPanel140);

        jPanel141.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_di_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel141.add(pl_di_max);

        panel_h_max.add(jPanel141);

        jPanel142.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_mi_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel142.add(pl_mi_max);

        panel_h_max.add(jPanel142);

        jPanel143.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_do_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel143.add(pl_do_max);

        panel_h_max.add(jPanel143);

        jPanel144.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_fr_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel144.add(pl_fr_max);

        panel_h_max.add(jPanel144);

        jPanel145.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_sa_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel145.add(pl_sa_max);

        panel_h_max.add(jPanel145);

        jPanel146.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_so_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel146.add(pl_so_max);

        panel_h_max.add(jPanel146);

        jPanel298.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        panel_h_max.add(jPanel298);

        jPanel297.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        panel_h_max.add(jPanel297);

        jPanel296.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        panel_h_max.add(jPanel296);

        jPanel341.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        panel_h_max.add(jPanel341);

        jPanel104.add(panel_h_max);

        panel_h_header1b.setLayout(new java.awt.GridBagLayout());

        javax.swing.GroupLayout panelDummy13Layout = new javax.swing.GroupLayout(panelDummy13);
        panelDummy13.setLayout(panelDummy13Layout);
        panelDummy13Layout.setHorizontalGroup(
            panelDummy13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy13Layout.setVerticalGroup(
            panelDummy13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy13, gridBagConstraints);

        javax.swing.GroupLayout panelDummy14Layout = new javax.swing.GroupLayout(panelDummy14);
        panelDummy14.setLayout(panelDummy14Layout);
        panelDummy14Layout.setHorizontalGroup(
            panelDummy14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy14Layout.setVerticalGroup(
            panelDummy14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy14, gridBagConstraints);

        javax.swing.GroupLayout panelDummy15Layout = new javax.swing.GroupLayout(panelDummy15);
        panelDummy15.setLayout(panelDummy15Layout);
        panelDummy15Layout.setHorizontalGroup(
            panelDummy15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy15Layout.setVerticalGroup(
            panelDummy15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy15, gridBagConstraints);

        javax.swing.GroupLayout panelDummy16Layout = new javax.swing.GroupLayout(panelDummy16);
        panelDummy16.setLayout(panelDummy16Layout);
        panelDummy16Layout.setHorizontalGroup(
            panelDummy16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy16Layout.setVerticalGroup(
            panelDummy16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy16, gridBagConstraints);

        javax.swing.GroupLayout panelDummy17Layout = new javax.swing.GroupLayout(panelDummy17);
        panelDummy17.setLayout(panelDummy17Layout);
        panelDummy17Layout.setHorizontalGroup(
            panelDummy17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy17Layout.setVerticalGroup(
            panelDummy17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy17, gridBagConstraints);

        javax.swing.GroupLayout panelDummy18Layout = new javax.swing.GroupLayout(panelDummy18);
        panelDummy18.setLayout(panelDummy18Layout);
        panelDummy18Layout.setHorizontalGroup(
            panelDummy18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy18Layout.setVerticalGroup(
            panelDummy18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy18, gridBagConstraints);

        javax.swing.GroupLayout panelDummy19Layout = new javax.swing.GroupLayout(panelDummy19);
        panelDummy19.setLayout(panelDummy19Layout);
        panelDummy19Layout.setHorizontalGroup(
            panelDummy19Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy19Layout.setVerticalGroup(
            panelDummy19Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy19, gridBagConstraints);

        javax.swing.GroupLayout panelDummy20Layout = new javax.swing.GroupLayout(panelDummy20);
        panelDummy20.setLayout(panelDummy20Layout);
        panelDummy20Layout.setHorizontalGroup(
            panelDummy20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy20Layout.setVerticalGroup(
            panelDummy20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy20, gridBagConstraints);

        javax.swing.GroupLayout panelDummy21Layout = new javax.swing.GroupLayout(panelDummy21);
        panelDummy21.setLayout(panelDummy21Layout);
        panelDummy21Layout.setHorizontalGroup(
            panelDummy21Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy21Layout.setVerticalGroup(
            panelDummy21Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy21, gridBagConstraints);

        javax.swing.GroupLayout panelDummy22Layout = new javax.swing.GroupLayout(panelDummy22);
        panelDummy22.setLayout(panelDummy22Layout);
        panelDummy22Layout.setHorizontalGroup(
            panelDummy22Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy22Layout.setVerticalGroup(
            panelDummy22Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy22, gridBagConstraints);

        javax.swing.GroupLayout panelDummy23Layout = new javax.swing.GroupLayout(panelDummy23);
        panelDummy23.setLayout(panelDummy23Layout);
        panelDummy23Layout.setHorizontalGroup(
            panelDummy23Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy23Layout.setVerticalGroup(
            panelDummy23Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy23, gridBagConstraints);

        javax.swing.GroupLayout panelDummy24Layout = new javax.swing.GroupLayout(panelDummy24);
        panelDummy24.setLayout(panelDummy24Layout);
        panelDummy24Layout.setHorizontalGroup(
            panelDummy24Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        panelDummy24Layout.setVerticalGroup(
            panelDummy24Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 11;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(panelDummy24, gridBagConstraints);

        jPanel360.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(jPanel360, gridBagConstraints);

        jPanel361.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 5));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(jPanel361, gridBagConstraints);

        jLabel27.setFont(jLabel27.getFont().deriveFont(jLabel27.getFont().getStyle() | java.awt.Font.BOLD, jLabel27.getFont().getSize()+4));
        jLabel27.setText("Zeilensummen");
        jPanel362.add(jLabel27);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        panel_h_header1b.add(jPanel362, gridBagConstraints);

        jPanel104.add(panel_h_header1b);

        panel_h_header2.setLayout(new java.awt.GridLayout(1, 0));

        jLabel54.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel54.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel54.setText("Stunde");
        panel_h_header2.add(jLabel54);

        pl_mo_lab.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        pl_mo_lab.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        pl_mo_lab.setText("Montag");
        panel_h_header2.add(pl_mo_lab);

        pl_di_lab.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        pl_di_lab.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        pl_di_lab.setText("Dienstag");
        panel_h_header2.add(pl_di_lab);

        pl_mi_lab.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        pl_mi_lab.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        pl_mi_lab.setText("Mittwoch");
        panel_h_header2.add(pl_mi_lab);

        pl_do_lab.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        pl_do_lab.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        pl_do_lab.setText("Donnertag");
        panel_h_header2.add(pl_do_lab);

        pl_fr_lab.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        pl_fr_lab.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        pl_fr_lab.setText("Freitag");
        panel_h_header2.add(pl_fr_lab);

        pl_sa_lab.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        pl_sa_lab.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        pl_sa_lab.setText("Samstag");
        panel_h_header2.add(pl_sa_lab);

        pl_so_lab.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        pl_so_lab.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        pl_so_lab.setText("Sonntag");
        panel_h_header2.add(pl_so_lab);

        jPanel299.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel62.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        jLabel62.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel62.setText("min.");
        jPanel299.add(jLabel62);

        panel_h_header2.add(jPanel299);

        jPanel300.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel_max_s.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        jLabel_max_s.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_max_s.setText("max.");
        jPanel300.add(jLabel_max_s);

        panel_h_header2.add(jPanel300);

        jPanel340.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel74.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        jLabel74.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel74.setText("min. ab");
        jPanel340.add(jLabel74);

        panel_h_header2.add(jPanel340);

        jPanel343.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        jLabel_max_s_ab.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        jLabel_max_s_ab.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel_max_s_ab.setText("max. ab");
        jPanel343.add(jLabel_max_s_ab);

        panel_h_header2.add(jPanel343);

        jPanel104.add(panel_h_header2);

        panel_h1_s1.setLayout(new java.awt.GridLayout(1, 0));

        jLabel65.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel65.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel65.setText("1.");
        panel_h1_s1.add(jLabel65);

        jPanel147.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel147.add(pl_std_1_mo);

        panel_h1_s1.add(jPanel147);

        jPanel148.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel148.add(pl_std_1_di);

        panel_h1_s1.add(jPanel148);

        jPanel149.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel149.add(pl_std_1_mi);

        panel_h1_s1.add(jPanel149);

        jPanel150.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel150.add(pl_std_1_do);

        panel_h1_s1.add(jPanel150);

        jPanel151.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel151.add(pl_std_1_fr);

        panel_h1_s1.add(jPanel151);

        jPanel152.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel152.add(pl_std_1_sa);

        panel_h1_s1.add(jPanel152);

        jPanel153.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel153.add(pl_std_1_so);

        panel_h1_s1.add(jPanel153);

        jPanel154.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel154.add(pl_std_1_min);

        panel_h1_s1.add(jPanel154);

        jPanel155.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel155.add(pl_std_1_max);

        panel_h1_s1.add(jPanel155);

        jPanel339.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel339.add(pl_std_1_ab_min);

        panel_h1_s1.add(jPanel339);

        jPanel302.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_1_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel302.add(pl_std_1_ab_max);

        panel_h1_s1.add(jPanel302);

        jPanel104.add(panel_h1_s1);

        panel_h1_s2.setLayout(new java.awt.GridLayout(1, 0));

        jLabel66.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel66.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel66.setText("2.");
        panel_h1_s2.add(jLabel66);

        jPanel156.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel156.add(pl_std_2_mo);

        panel_h1_s2.add(jPanel156);

        jPanel157.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel157.add(pl_std_2_di);

        panel_h1_s2.add(jPanel157);

        jPanel158.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel158.add(pl_std_2_mi);

        panel_h1_s2.add(jPanel158);

        jPanel159.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel159.add(pl_std_2_do);

        panel_h1_s2.add(jPanel159);

        jPanel160.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel160.add(pl_std_2_fr);

        panel_h1_s2.add(jPanel160);

        jPanel161.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel161.add(pl_std_2_sa);

        panel_h1_s2.add(jPanel161);

        jPanel162.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel162.add(pl_std_2_so);

        panel_h1_s2.add(jPanel162);

        jPanel163.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel163.add(pl_std_2_min);

        panel_h1_s2.add(jPanel163);

        jPanel164.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel164.add(pl_std_2_max);

        panel_h1_s2.add(jPanel164);

        jPanel344.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel344.add(pl_std_2_ab_min);

        panel_h1_s2.add(jPanel344);

        jPanel303.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_2_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel303.add(pl_std_2_ab_max);

        panel_h1_s2.add(jPanel303);

        jPanel104.add(panel_h1_s2);

        jLabel37.setFont(new java.awt.Font("Tahoma", 0, 6)); // NOI18N
        jLabel37.setText(" ");
        jPanel104.add(jLabel37);

        panel_h1_s3.setLayout(new java.awt.GridLayout(1, 0));

        jLabel67.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel67.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel67.setText("3.");
        panel_h1_s3.add(jLabel67);

        jPanel165.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel165.add(pl_std_3_mo);

        panel_h1_s3.add(jPanel165);

        jPanel166.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel166.add(pl_std_3_di);

        panel_h1_s3.add(jPanel166);

        jPanel167.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel167.add(pl_std_3_mi);

        panel_h1_s3.add(jPanel167);

        jPanel168.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel168.add(pl_std_3_do);

        panel_h1_s3.add(jPanel168);

        jPanel169.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel169.add(pl_std_3_fr);

        panel_h1_s3.add(jPanel169);

        jPanel170.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel170.add(pl_std_3_sa);

        panel_h1_s3.add(jPanel170);

        jPanel171.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel171.add(pl_std_3_so);

        panel_h1_s3.add(jPanel171);

        jPanel172.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel172.add(pl_std_3_min);

        panel_h1_s3.add(jPanel172);

        jPanel173.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel173.add(pl_std_3_max);

        panel_h1_s3.add(jPanel173);

        jPanel345.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel345.add(pl_std_3_ab_min);

        panel_h1_s3.add(jPanel345);

        jPanel304.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_3_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel304.add(pl_std_3_ab_max);

        panel_h1_s3.add(jPanel304);

        jPanel104.add(panel_h1_s3);

        panel_h1_s4.setLayout(new java.awt.GridLayout(1, 0));

        jLabel68.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel68.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel68.setText("4.");
        panel_h1_s4.add(jLabel68);

        jPanel174.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel174.add(pl_std_4_mo);

        panel_h1_s4.add(jPanel174);

        jPanel175.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel175.add(pl_std_4_di);

        panel_h1_s4.add(jPanel175);

        jPanel176.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel176.add(pl_std_4_mi);

        panel_h1_s4.add(jPanel176);

        jPanel177.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel177.add(pl_std_4_do);

        panel_h1_s4.add(jPanel177);

        jPanel178.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel178.add(pl_std_4_fr);

        panel_h1_s4.add(jPanel178);

        jPanel179.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel179.add(pl_std_4_sa);

        panel_h1_s4.add(jPanel179);

        jPanel180.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel180.add(pl_std_4_so);

        panel_h1_s4.add(jPanel180);

        jPanel181.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel181.add(pl_std_4_min);

        panel_h1_s4.add(jPanel181);

        jPanel182.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel182.add(pl_std_4_max);

        panel_h1_s4.add(jPanel182);

        jPanel346.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel346.add(pl_std_4_ab_min);

        panel_h1_s4.add(jPanel346);

        jPanel305.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_4_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel305.add(pl_std_4_ab_max);

        panel_h1_s4.add(jPanel305);

        jPanel104.add(panel_h1_s4);

        jLabel38.setFont(new java.awt.Font("Tahoma", 0, 6)); // NOI18N
        jLabel38.setText(" ");
        jPanel104.add(jLabel38);

        panel_h1_s5.setLayout(new java.awt.GridLayout(1, 0));

        jLabel69.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel69.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel69.setText("5.");
        panel_h1_s5.add(jLabel69);

        jPanel183.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel183.add(pl_std_5_mo);

        panel_h1_s5.add(jPanel183);

        jPanel184.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel184.add(pl_std_5_di);

        panel_h1_s5.add(jPanel184);

        jPanel185.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel185.add(pl_std_5_mi);

        panel_h1_s5.add(jPanel185);

        jPanel186.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel186.add(pl_std_5_do);

        panel_h1_s5.add(jPanel186);

        jPanel187.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel187.add(pl_std_5_fr);

        panel_h1_s5.add(jPanel187);

        jPanel188.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel188.add(pl_std_5_sa);

        panel_h1_s5.add(jPanel188);

        jPanel189.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel189.add(pl_std_5_so);

        panel_h1_s5.add(jPanel189);

        jPanel190.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel190.add(pl_std_5_min);

        panel_h1_s5.add(jPanel190);

        jPanel191.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel191.add(pl_std_5_max);

        panel_h1_s5.add(jPanel191);

        jPanel347.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel347.add(pl_std_5_ab_min);

        panel_h1_s5.add(jPanel347);

        jPanel306.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_5_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel306.add(pl_std_5_ab_max);

        panel_h1_s5.add(jPanel306);

        jPanel104.add(panel_h1_s5);

        panel_h1_s6.setLayout(new java.awt.GridLayout(1, 0));

        jLabel70.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel70.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel70.setText("6.");
        panel_h1_s6.add(jLabel70);

        jPanel192.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel192.add(pl_std_6_mo);

        panel_h1_s6.add(jPanel192);

        jPanel193.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel193.add(pl_std_6_di);

        panel_h1_s6.add(jPanel193);

        jPanel194.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel194.add(pl_std_6_mi);

        panel_h1_s6.add(jPanel194);

        jPanel195.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel195.add(pl_std_6_do);

        panel_h1_s6.add(jPanel195);

        jPanel196.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel196.add(pl_std_6_fr);

        panel_h1_s6.add(jPanel196);

        jPanel197.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel197.add(pl_std_6_sa);

        panel_h1_s6.add(jPanel197);

        jPanel198.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel198.add(pl_std_6_so);

        panel_h1_s6.add(jPanel198);

        jPanel199.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel199.add(pl_std_6_min);

        panel_h1_s6.add(jPanel199);

        jPanel200.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel200.add(pl_std_6_max);

        panel_h1_s6.add(jPanel200);

        jPanel348.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel348.add(pl_std_6_ab_min);

        panel_h1_s6.add(jPanel348);

        jPanel307.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_6_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel307.add(pl_std_6_ab_max);

        panel_h1_s6.add(jPanel307);

        jPanel104.add(panel_h1_s6);

        jLabel39.setFont(new java.awt.Font("Tahoma", 0, 6)); // NOI18N
        jLabel39.setText(" ");
        jPanel104.add(jLabel39);

        panel_h1_s7.setLayout(new java.awt.GridLayout(1, 0));

        jLabel71.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel71.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel71.setText("7.");
        panel_h1_s7.add(jLabel71);

        jPanel201.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel201.add(pl_std_7_mo);

        panel_h1_s7.add(jPanel201);

        jPanel202.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel202.add(pl_std_7_di);

        panel_h1_s7.add(jPanel202);

        jPanel203.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel203.add(pl_std_7_mi);

        panel_h1_s7.add(jPanel203);

        jPanel204.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel204.add(pl_std_7_do);

        panel_h1_s7.add(jPanel204);

        jPanel205.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel205.add(pl_std_7_fr);

        panel_h1_s7.add(jPanel205);

        jPanel206.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel206.add(pl_std_7_sa);

        panel_h1_s7.add(jPanel206);

        jPanel207.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel207.add(pl_std_7_so);

        panel_h1_s7.add(jPanel207);

        jPanel208.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel208.add(pl_std_7_min);

        panel_h1_s7.add(jPanel208);

        jPanel209.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel209.add(pl_std_7_max);

        panel_h1_s7.add(jPanel209);

        jPanel349.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel349.add(pl_std_7_ab_min);

        panel_h1_s7.add(jPanel349);

        jPanel308.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_7_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel308.add(pl_std_7_ab_max);

        panel_h1_s7.add(jPanel308);

        jPanel104.add(panel_h1_s7);

        panel_h1_s8.setLayout(new java.awt.GridLayout(1, 0));

        jLabel72.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel72.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel72.setText("8.");
        panel_h1_s8.add(jLabel72);

        jPanel210.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel210.add(pl_std_8_mo);

        panel_h1_s8.add(jPanel210);

        jPanel211.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel211.add(pl_std_8_di);

        panel_h1_s8.add(jPanel211);

        jPanel212.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel212.add(pl_std_8_mi);

        panel_h1_s8.add(jPanel212);

        jPanel213.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel213.add(pl_std_8_do);

        panel_h1_s8.add(jPanel213);

        jPanel214.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel214.add(pl_std_8_fr);

        panel_h1_s8.add(jPanel214);

        jPanel215.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel215.add(pl_std_8_sa);

        panel_h1_s8.add(jPanel215);

        jPanel216.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel216.add(pl_std_8_so);

        panel_h1_s8.add(jPanel216);

        jPanel217.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel217.add(pl_std_8_min);

        panel_h1_s8.add(jPanel217);

        jPanel218.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel218.add(pl_std_8_max);

        panel_h1_s8.add(jPanel218);

        jPanel350.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel350.add(pl_std_8_ab_min);

        panel_h1_s8.add(jPanel350);

        jPanel309.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_8_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel309.add(pl_std_8_ab_max);

        panel_h1_s8.add(jPanel309);

        jPanel104.add(panel_h1_s8);

        panel_h1_s9.setLayout(new java.awt.GridLayout(1, 0));

        jLabel73.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel73.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel73.setText("9.");
        panel_h1_s9.add(jLabel73);

        jPanel219.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel219.add(pl_std_9_mo);

        panel_h1_s9.add(jPanel219);

        jPanel220.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel220.add(pl_std_9_di);

        panel_h1_s9.add(jPanel220);

        jPanel221.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel221.add(pl_std_9_mi);

        panel_h1_s9.add(jPanel221);

        jPanel222.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel222.add(pl_std_9_do);

        panel_h1_s9.add(jPanel222);

        jPanel223.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel223.add(pl_std_9_fr);

        panel_h1_s9.add(jPanel223);

        jPanel224.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel224.add(pl_std_9_sa);

        panel_h1_s9.add(jPanel224);

        jPanel225.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel225.add(pl_std_9_so);

        panel_h1_s9.add(jPanel225);

        jPanel226.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel226.add(pl_std_9_min);

        panel_h1_s9.add(jPanel226);

        jPanel227.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel227.add(pl_std_9_max);

        panel_h1_s9.add(jPanel227);

        jPanel351.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel351.add(pl_std_9_ab_min);

        panel_h1_s9.add(jPanel351);

        jPanel310.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_9_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel310.add(pl_std_9_ab_max);

        panel_h1_s9.add(jPanel310);

        jPanel104.add(panel_h1_s9);

        panel_h1_s10.setLayout(new java.awt.GridLayout(1, 0));

        jLabel83.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel83.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel83.setText("10.");
        panel_h1_s10.add(jLabel83);

        jPanel228.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel228.add(pl_std_10_mo);

        panel_h1_s10.add(jPanel228);

        jPanel229.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel229.add(pl_std_10_di);

        panel_h1_s10.add(jPanel229);

        jPanel230.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel230.add(pl_std_10_mi);

        panel_h1_s10.add(jPanel230);

        jPanel231.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel231.add(pl_std_10_do);

        panel_h1_s10.add(jPanel231);

        jPanel232.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel232.add(pl_std_10_fr);

        panel_h1_s10.add(jPanel232);

        jPanel233.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel233.add(pl_std_10_sa);

        panel_h1_s10.add(jPanel233);

        jPanel234.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel234.add(pl_std_10_so);

        panel_h1_s10.add(jPanel234);

        jPanel235.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel235.add(pl_std_10_min);

        panel_h1_s10.add(jPanel235);

        jPanel236.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel236.add(pl_std_10_max);

        panel_h1_s10.add(jPanel236);

        jPanel352.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel352.add(pl_std_10_ab_min);

        panel_h1_s10.add(jPanel352);

        jPanel311.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_10_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel311.add(pl_std_10_ab_max);

        panel_h1_s10.add(jPanel311);

        jPanel104.add(panel_h1_s10);

        panel_h1_s11.setLayout(new java.awt.GridLayout(1, 0));

        jLabel85.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel85.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel85.setText("11.");
        panel_h1_s11.add(jLabel85);

        jPanel237.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel237.add(pl_std_11_mo);

        panel_h1_s11.add(jPanel237);

        jPanel238.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel238.add(pl_std_11_di);

        panel_h1_s11.add(jPanel238);

        jPanel239.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel239.add(pl_std_11_mi);

        panel_h1_s11.add(jPanel239);

        jPanel240.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel240.add(pl_std_11_do);

        panel_h1_s11.add(jPanel240);

        jPanel241.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel241.add(pl_std_11_fr);

        panel_h1_s11.add(jPanel241);

        jPanel242.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel242.add(pl_std_11_sa);

        panel_h1_s11.add(jPanel242);

        jPanel243.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel243.add(pl_std_11_so);

        panel_h1_s11.add(jPanel243);

        jPanel244.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel244.add(pl_std_11_min);

        panel_h1_s11.add(jPanel244);

        jPanel245.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel245.add(pl_std_11_max);

        panel_h1_s11.add(jPanel245);

        jPanel353.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel353.add(pl_std_11_ab_min);

        panel_h1_s11.add(jPanel353);

        jPanel312.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_11_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel312.add(pl_std_11_ab_max);

        panel_h1_s11.add(jPanel312);

        jPanel104.add(panel_h1_s11);

        panel_h1_s12.setLayout(new java.awt.GridLayout(1, 0));

        jLabel87.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel87.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel87.setText("12.");
        panel_h1_s12.add(jLabel87);

        jPanel246.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel246.add(pl_std_12_mo);

        panel_h1_s12.add(jPanel246);

        jPanel247.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel247.add(pl_std_12_di);

        panel_h1_s12.add(jPanel247);

        jPanel248.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel248.add(pl_std_12_mi);

        panel_h1_s12.add(jPanel248);

        jPanel249.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel249.add(pl_std_12_do);

        panel_h1_s12.add(jPanel249);

        jPanel250.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel250.add(pl_std_12_fr);

        panel_h1_s12.add(jPanel250);

        jPanel251.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel251.add(pl_std_12_sa);

        panel_h1_s12.add(jPanel251);

        jPanel252.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel252.add(pl_std_12_so);

        panel_h1_s12.add(jPanel252);

        jPanel253.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel253.add(pl_std_12_min);

        panel_h1_s12.add(jPanel253);

        jPanel254.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel254.add(pl_std_12_max);

        panel_h1_s12.add(jPanel254);

        jPanel354.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel354.add(pl_std_12_ab_min);

        panel_h1_s12.add(jPanel354);

        jPanel313.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_12_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel313.add(pl_std_12_ab_max);

        panel_h1_s12.add(jPanel313);

        jPanel104.add(panel_h1_s12);

        panel_h1_s13.setLayout(new java.awt.GridLayout(1, 0));

        jLabel89.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel89.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel89.setText("13.");
        panel_h1_s13.add(jLabel89);

        jPanel255.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel255.add(pl_std_13_mo);

        panel_h1_s13.add(jPanel255);

        jPanel256.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel256.add(pl_std_13_di);

        panel_h1_s13.add(jPanel256);

        jPanel257.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel257.add(pl_std_13_mi);

        panel_h1_s13.add(jPanel257);

        jPanel258.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel258.add(pl_std_13_do);

        panel_h1_s13.add(jPanel258);

        jPanel259.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel259.add(pl_std_13_fr);

        panel_h1_s13.add(jPanel259);

        jPanel260.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel260.add(pl_std_13_sa);

        panel_h1_s13.add(jPanel260);

        jPanel261.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel261.add(pl_std_13_so);

        panel_h1_s13.add(jPanel261);

        jPanel262.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel262.add(pl_std_13_min);

        panel_h1_s13.add(jPanel262);

        jPanel263.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel263.add(pl_std_13_max);

        panel_h1_s13.add(jPanel263);

        jPanel355.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel355.add(pl_std_13_ab_min);

        panel_h1_s13.add(jPanel355);

        jPanel314.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_13_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel314.add(pl_std_13_ab_max);

        panel_h1_s13.add(jPanel314);

        jPanel104.add(panel_h1_s13);

        panel_h1_s14.setLayout(new java.awt.GridLayout(1, 0));

        jLabel91.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel91.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel91.setText("14.");
        panel_h1_s14.add(jLabel91);

        jPanel264.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel264.add(pl_std_14_mo);

        panel_h1_s14.add(jPanel264);

        jPanel265.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel265.add(pl_std_14_di);

        panel_h1_s14.add(jPanel265);

        jPanel266.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel266.add(pl_std_14_mi);

        panel_h1_s14.add(jPanel266);

        jPanel267.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel267.add(pl_std_14_do);

        panel_h1_s14.add(jPanel267);

        jPanel268.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel268.add(pl_std_14_fr);

        panel_h1_s14.add(jPanel268);

        jPanel269.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel269.add(pl_std_14_sa);

        panel_h1_s14.add(jPanel269);

        jPanel270.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel270.add(pl_std_14_so);

        panel_h1_s14.add(jPanel270);

        jPanel271.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel271.add(pl_std_14_min);

        panel_h1_s14.add(jPanel271);

        jPanel272.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel272.add(pl_std_14_max);

        panel_h1_s14.add(jPanel272);

        jPanel356.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel356.add(pl_std_14_ab_min);

        panel_h1_s14.add(jPanel356);

        jPanel315.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_14_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel315.add(pl_std_14_ab_max);

        panel_h1_s14.add(jPanel315);

        jPanel104.add(panel_h1_s14);

        panel_h1_s15.setLayout(new java.awt.GridLayout(1, 0));

        jLabel93.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel93.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel93.setText("15.");
        panel_h1_s15.add(jLabel93);

        jPanel273.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel273.add(pl_std_15_mo);

        panel_h1_s15.add(jPanel273);

        jPanel274.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel274.add(pl_std_15_di);

        panel_h1_s15.add(jPanel274);

        jPanel275.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel275.add(pl_std_15_mi);

        panel_h1_s15.add(jPanel275);

        jPanel276.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel276.add(pl_std_15_do);

        panel_h1_s15.add(jPanel276);

        jPanel277.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel277.add(pl_std_15_fr);

        panel_h1_s15.add(jPanel277);

        jPanel278.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel278.add(pl_std_15_sa);

        panel_h1_s15.add(jPanel278);

        jPanel279.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel279.add(pl_std_15_so);

        panel_h1_s15.add(jPanel279);

        jPanel280.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel280.add(pl_std_15_min);

        panel_h1_s15.add(jPanel280);

        jPanel281.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel281.add(pl_std_15_max);

        panel_h1_s15.add(jPanel281);

        jPanel357.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel357.add(pl_std_15_ab_min);

        panel_h1_s15.add(jPanel357);

        jPanel316.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_15_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel316.add(pl_std_15_ab_max);

        panel_h1_s15.add(jPanel316);

        jPanel104.add(panel_h1_s15);

        panel_h1_s16.setLayout(new java.awt.GridLayout(1, 0));

        jLabel95.setFont(new java.awt.Font("Tahoma", 1, 12)); // NOI18N
        jLabel95.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel95.setText("16.");
        panel_h1_s16.add(jLabel95);

        jPanel282.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_mo.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel282.add(pl_std_16_mo);

        panel_h1_s16.add(jPanel282);

        jPanel283.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_di.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel283.add(pl_std_16_di);

        panel_h1_s16.add(jPanel283);

        jPanel284.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_mi.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel284.add(pl_std_16_mi);

        panel_h1_s16.add(jPanel284);

        jPanel285.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_do.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel285.add(pl_std_16_do);

        panel_h1_s16.add(jPanel285);

        jPanel286.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_fr.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel286.add(pl_std_16_fr);

        panel_h1_s16.add(jPanel286);

        jPanel287.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_sa.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel287.add(pl_std_16_sa);

        panel_h1_s16.add(jPanel287);

        jPanel288.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_so.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel288.add(pl_std_16_so);

        panel_h1_s16.add(jPanel288);

        jPanel289.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel289.add(pl_std_16_min);

        panel_h1_s16.add(jPanel289);

        jPanel290.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel290.add(pl_std_16_max);

        panel_h1_s16.add(jPanel290);

        jPanel358.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_ab_min.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel358.add(pl_std_16_ab_min);

        panel_h1_s16.add(jPanel358);

        jPanel317.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));

        pl_std_16_ab_max.setFont(new java.awt.Font("Courier New", 1, 12)); // NOI18N
        jPanel317.add(pl_std_16_ab_max);

        panel_h1_s16.add(jPanel317);

        jPanel104.add(panel_h1_s16);

        pPlan.add(jPanel104, java.awt.BorderLayout.NORTH);

        jPanelCard.add(pPlan, "D_Plan");

        jPanel3.add(jPanelCard, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel3, java.awt.BorderLayout.CENTER);

        jMenu1.setText("Datei");
        jMenu1.setFont(Config.FONT_NORMAL_HEADER);

        jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_DOWN_MASK));
        jMenuItem2.setFont(Config.FONT_NORMAL_SANS);
        jMenuItem2.setText("Öffnen...");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem2);

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_DOWN_MASK));
        jMenuItem1.setFont(Config.FONT_NORMAL_SANS);
        jMenuItem1.setText("Speichern...");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * reacts on node selection (selects the corespondend card)
     *
     * @param evt
     */
    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
        try {
            if (!card_wechsel_erlaubt) {
                return;
            }

            // select nothing
            CardLayout card2 = (CardLayout) jPanelCard.getLayout();
            card2.show(jPanelCard, "D_Empty");

            // TREE SELECTION
            Object node = jTree1.getLastSelectedPathComponent();

            // nichts ausgewählt
            if (node == null) {
                return;
            }

            // zwei oder mehr ausgewählt
            if (jTree1.getSelectionPaths().length > 1) {
                card2.show(jPanelCard, "D_Multi");
                return;
            }

            // 
            if ((node instanceof D_Schule) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Schule sc = (D_Schule) node;
                sc_WochenTage.setValue(sc.max_t);
                sc_StundenProTag.setValue(sc.max_s);
                sc_le_MaxSpringstundenProTag.setValue(sc.max_spring_pro_tag);
                sc_le_MaxSpringstundenProWoche.setValue(sc.max_spring_pro_woche);
                sc_le_MaxTagesstundenpraesenz.setValue(sc.max_praesenz_pro_tag);
                sc_le_MinStundenProTag.setValue(sc.min_stunden_le);
                sc_le_Max_Stunden_in_Folge.setValue(sc.max_stunden_folge_le);
                sc_keine_einzelstunde_in_1.setSelected(sc.keine_einzelstunde_in_1);
                sc_keine_einzelstunde_in_2.setSelected(sc.keine_einzelstunde_in_2);
                sc_keine_einzelstunde_in_3.setSelected(sc.keine_einzelstunde_in_3);
                sc_keine_einzelstunde_in_4.setSelected(sc.keine_einzelstunde_in_4);
                sc_keine_einzelstunde_in_5.setSelected(sc.keine_einzelstunde_in_5);
                sc_keine_einzelstunde_in_6.setSelected(sc.keine_einzelstunde_in_6);
                sc_keinen_uebergang_1_2.setSelected(sc.keinen_uebergang_1_2);
                sc_keinen_uebergang_2_3.setSelected(sc.keinen_uebergang_2_3);
                sc_keinen_uebergang_3_4.setSelected(sc.keinen_uebergang_3_4);
                sc_keinen_uebergang_4_5.setSelected(sc.keinen_uebergang_4_5);
                sc_keinen_uebergang_5_6.setSelected(sc.keinen_uebergang_5_6);
                sc_keinen_uebergang_6_7.setSelected(sc.keinen_uebergang_6_7);
                sc_keinen_uebergang_7_8.setSelected(sc.keinen_uebergang_7_8);
                sc_label_min_aufeinander_von.setText("" + sc.min_aufeinanderfolgend_von);
                ((SpinnerNumberModel) sc_min_aufeinanderfolgend.getModel()).setMaximum(sc.min_aufeinanderfolgend_von);
                sc_min_aufeinanderfolgend.setValue(sc.min_aufeinanderfolgend);
                card2.show(jPanelCard, "D_Schule");
            }
            if ((node instanceof D_Schule) && (VIEW == VIEW_PLAN)) {
                D_Schule sc = (D_Schule) node;
                gui_plan_load("plan", sc.plan, "schule", "id", sc.id);
                card2.show(jPanelCard, "D_Plan");
            }
            if ((node instanceof D_Schule) && (VIEW == VIEW_VERTRETUNGSRESERVEN)) {
                D_Schule sc = (D_Schule) node;
                gui_plan_load("planV", sc.planV, "schule", "id", sc.id);
                card2.show(jPanelCard, "D_Plan");
            }
            if ((node instanceof D_Schule) && (VIEW == VIEW_VERTRETUNGSOPTIONEN)) {
                D_Schule sc = (D_Schule) node;
                gui_plan_load("planO", sc.planO, "schule", "id", sc.id);
                card2.show(jPanelCard, "D_Plan");
            }

            if (node instanceof D_Einstellungen) {
                card2.show(jPanelCard, "D_Einstellungen");
            }

            if ((node instanceof D_Lehrkraefte) && (VIEW == VIEW_ATTRIBUTES)) {
                card2.show(jPanelCard, "D_Lehrkraefte");
            }

            if ((node instanceof D_Lehrkraefte) && (VIEW == VIEW_PLAN)) {
                D_Lehrkraefte lea = (D_Lehrkraefte) node;
                gui_plan_load("plan", lea.plan, "lehrkraefte", "id", lea.id);
                card2.show(jPanelCard, "D_Plan");
            }

            if ((node instanceof D_Lehrkraft) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Schule sc = model.get_d_schule();
                D_Lehrkraft le = (D_Lehrkraft) node;
                le_kuerzel.setText(le.kuerzel);
                le_anzeigename.setText(le.anzeigename);
                le_bemerkung.setText(le.bemerkung);
                le_darf_vertreten.setSelected(le.darf_vertreten != 0);
                le_freie_tage.setValue(le.freie_tage);
                le_ab_stunde_x.setValue(le.mind_x_ab_stunde);
                le_ab_stunde_y.setValue(le.mind_y_ab_stunde);
                le_ab_stunde_y.setVisible(le.mind_x_ab_stunde != 0);
                le_bis_stunde_x.setValue(le.mind_x_bis_stunde);
                le_bis_stunde_y.setValue(le.mind_y_bis_stunde);
                le_bis_stunde_y.setVisible(le.mind_x_bis_stunde != 0);
                le_spring_pro_tag_check.setSelected(le.spring_pro_tag_check != 0);
                le_spring_pro_tag_check.setText("Standard (" + sc.max_spring_pro_tag + ") nehmen");
                le_spring_pro_tag_wert.setValue(le.spring_pro_tag_wert);
                le_spring_pro_tag_wert.setVisible(le.spring_pro_tag_check == 0);
                le_spring_pro_woche_check.setSelected(le.spring_pro_woche_check != 0);
                le_spring_pro_woche_check.setText("Standard (" + sc.max_spring_pro_woche + ") nehmen");
                le_spring_pro_woche_wert.setValue(le.spring_pro_woche_wert);
                le_spring_pro_woche_wert.setVisible(le.spring_pro_woche_check == 0);
                le_tagesstunden_check.setSelected(le.tagesstunden_check != 0);
                le_tagesstunden_check.setText("Standard (" + sc.max_praesenz_pro_tag + ") nehmen");
                le_tagesstunden_wert.setValue(le.tagesstunden_wert);
                le_tagesstunden_wert.setVisible(le.tagesstunden_check == 0);
                le_min_std_pro_tag_check.setSelected(le.min_stunden_check != 0);
                le_min_std_pro_tag_check.setText("Standard (" + sc.min_stunden_le + ") nehmen");
                le_min_std_pro_tag_spinner.setValue(le.min_stunden_wert);
                le_min_std_pro_tag_spinner.setVisible(le.min_stunden_check == 0);
                le_max_stunden_in_folge_check.setSelected(le.max_stunden_folge_check != 0);
                le_max_stunden_in_folge_check.setText("Standard (" + sc.max_stunden_folge_le + ") nehmen");
                le_max_stunden_in_folge_spinner.setValue(le.max_stunden_folge_wert);
                le_max_stunden_in_folge_spinner.setVisible(le.max_stunden_folge_check == 0);
                card2.show(jPanelCard, "D_Lehrkraft");
            }
            if ((node instanceof D_Lehrkraft) && (VIEW == VIEW_PLAN)) {
                D_Lehrkraft le = (D_Lehrkraft) node;
                gui_plan_load("plan", le.plan, "lehrkraft", "id", le.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // KLASSEN
            if ((node instanceof D_Klassen) && (VIEW == VIEW_ATTRIBUTES)) {
                card2.show(jPanelCard, "D_Klassen");
            }
            if ((node instanceof D_Klassen) && (VIEW == VIEW_PLAN)) {
                D_Klassen kla = (D_Klassen) node;
                gui_plan_load("plan", kla.plan, "klassen", "id", kla.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // KLASSE
            if ((node instanceof D_Klasse) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Klasse dk = (D_Klasse) node;
                tf_klasse_kuerzel.setText(dk.kuerzel);
                card2.show(jPanelCard, "D_Klasse");
            }
            if ((node instanceof D_Klasse) && (VIEW == VIEW_PLAN)) {
                D_Klasse kl = (D_Klasse) node;
                gui_plan_load("plan", kl.plan, "klasse", "id", kl.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // FÄCHER
            if (node instanceof D_Faecher) {
                card2.show(jPanelCard, "D_Faecher");
            }

            // FACH
            if (node instanceof D_Fach) {
                D_Fach df = (D_Fach) node;
                tf_fach_kuerzel.setText(df.kuerzel);
                tf_fach_anzeigename.setText(df.anzeigename);
                card2.show(jPanelCard, "D_Fach");
            }

            // RÄUME
            if ((node instanceof D_Raeume) && (VIEW == VIEW_ATTRIBUTES)) {
                card2.show(jPanelCard, "D_Raeume");
            }
            if ((node instanceof D_Raeume) && (VIEW == VIEW_PLAN)) {
                D_Raeume raa = (D_Raeume) node;
                gui_plan_load("plan", raa.plan, "raeume", "id", raa.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // RAUM
            if ((node instanceof D_Raum) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Raum dr = (D_Raum) node;
                tf_raum_kuerzel.setText(dr.kuerzel);
                card2.show(jPanelCard, "D_Raum");
            }
            if ((node instanceof D_Raum) && (VIEW == VIEW_PLAN)) {
                D_Raum ra = (D_Raum) node;
                gui_plan_load("plan", ra.plan, "raum", "id", ra.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // KOPPLUNGEN
            if ((node instanceof D_Kopplungen) && (VIEW == VIEW_ATTRIBUTES)) {
                card2.show(jPanelCard, "D_Kopplungen");
            }
            if ((node instanceof D_Kopplungen) && (VIEW == VIEW_PLAN)) {
                D_Kopplungen koa = (D_Kopplungen) node;
                gui_plan_load("plan", koa.plan, "kopplungen", "id", koa.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // KOPPLUNG
            if ((node instanceof D_Kopplung) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Kopplung ko = (D_Kopplung) node;
                tf_kopplung_kuerzel.setText(ko.kuerzel);
                tf_kopplung_anzeigename.setText(ko.anzeigename);
                card2.show(jPanelCard, "D_Kopplung");
            }
            if ((node instanceof D_Kopplung) && (VIEW == VIEW_PLAN)) {
                D_Kopplung ko = (D_Kopplung) node;
                gui_plan_load("plan", ko.plan, "kopplung", "id", ko.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // KURSE
            if ((node instanceof D_Kurse) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Kurse kua = (D_Kurse) node;
                jRadio_ku_sort_kl_fa_le.setSelected(kua.sortierung == Config.KURSE_SORTIEREN_NACH_KL_FA_LE);
                jRadio_ku_sort_kl_le_fa.setSelected(kua.sortierung == Config.KURSE_SORTIEREN_NACH_KL_LE_FA);
                jRadio_ku_sort_le_kl_fa.setSelected(kua.sortierung == Config.KURSE_SORTIEREN_NACH_LE_KL_FA);
                jRadio_ku_sort_le_fa_kl.setSelected(kua.sortierung == Config.KURSE_SORTIEREN_NACH_LE_FA_KL);
                jRadio_ku_sort_fa_kl_le.setSelected(kua.sortierung == Config.KURSE_SORTIEREN_NACH_FA_KL_LE);
                jRadio_ku_sort_fa_le_kl.setSelected(kua.sortierung == Config.KURSE_SORTIEREN_NACH_FA_LE_KL);
                card2.show(jPanelCard, "D_Kurse");
            }
            if ((node instanceof D_Kurse) && (VIEW == VIEW_PLAN)) {
                D_Kurse kua = (D_Kurse) node;
                gui_plan_load("plan", kua.plan, "kurse", "id", kua.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // KURS
            if ((node instanceof D_Kurs) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Kurs ku = (D_Kurs) node;
                model.table_model_kurs_lehrer.lade_tabelle(ku);
                model.table_model_kurs_klasse.lade_tabelle(ku);
                model.table_model_kurs_fach.lade_tabelle(ku);
                model.table_model_kurs_raum.lade_tabelle(ku);
                model.table_model_kurs_kopplung.lade_tabelle(ku);
                model.table_model_kurs_kurs.lade_tabelle(ku);
                model.table_model_kurs_hosp.lade_tabelle(ku);
                tf_kurs_ergaenzung.setText(ku.ergaenzung);
                ku_vertretungsreserven.setValue(ku.vertretungsreserven);
                ku_nicht_aufeinanderfolgend.setSelected(ku.nicht_aufeinanderfolgend == 1);
                ku_nicht_aufeinanderfolgend.setEnabled(ku.st_map.size() == 2);
                card2.show(jPanelCard, "D_Kurs");
            }
            if ((node instanceof D_Kurs) && (VIEW == VIEW_PLAN)) {
                D_Kurs ku = (D_Kurs) node;
                gui_plan_load("plan", ku.plan, "kurs", "id", ku.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // STUNDE (KU)
            if ((node instanceof D_Stunde) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Stunde st = (D_Stunde) node;
                jRadioWochenstunden1.setSelected(st.wochenstunden == 1);
                jRadioWochenstunden2.setSelected(st.wochenstunden == 2);
                jRadioWochenstunden3.setSelected(st.wochenstunden == 3);

                jRadioStundenTyp1.setSelected(st.typ == Config.STUNDEN_TYP_N);
                jRadioStundenTyp2.setSelected(st.typ == Config.STUNDEN_TYP_D);
                jRadioStundenTyp3.setSelected(st.typ == Config.STUNDEN_TYP_X);

                jRadio_kl_Lage_Egal.setSelected(st.lage_kl == Config.STUNDEN_LAGE_EGAL);
                jRadio_kl_Lage_Anfang.setSelected(st.lage_kl == Config.STUNDEN_LAGE_AM_ANFANG);
                jRadio_kl_Lage_Nicht_Anfang.setSelected(st.lage_kl == Config.STUNDEN_LAGE_NICHT_AM_ANFANG);
                jRadio_kl_Lage_Ende.setSelected(st.lage_kl == Config.STUNDEN_LAGE_AM_ENDE);
                jRadio_kl_Lage_Nicht_Ende.setSelected(st.lage_kl == Config.STUNDEN_LAGE_NICHT_AM_ENDE);
                jRadio_kl_Lage_Rand.setSelected(st.lage_kl == Config.STUNDEN_LAGE_AM_RAND);
                jRadio_kl_Lage_Nicht_Rand.setSelected(st.lage_kl == Config.STUNDEN_LAGE_NICHT_AM_RAND);

                jRadio_le2_Lage_Egal.setSelected(st.lage_le == Config.STUNDEN_LAGE_EGAL);
                jRadio_le_Lage_Anfang.setSelected(st.lage_le == Config.STUNDEN_LAGE_AM_ANFANG);
                jRadio_le_Lage_Nicht_Anfang.setSelected(st.lage_le == Config.STUNDEN_LAGE_NICHT_AM_ANFANG);
                jRadio_le_Lage_Ende.setSelected(st.lage_le == Config.STUNDEN_LAGE_AM_ENDE);
                jRadio_le_Lage_Nicht_Ende.setSelected(st.lage_le == Config.STUNDEN_LAGE_NICHT_AM_ENDE);
                jRadio_le_Lage_Rand.setSelected(st.lage_le == Config.STUNDEN_LAGE_AM_RAND);
                jRadio_le_Lage_Nicht_Rand.setSelected(st.lage_le == Config.STUNDEN_LAGE_NICHT_AM_RAND);

                card2.show(jPanelCard, "D_Stunde");
            }
            if ((node instanceof D_Stunde) && (VIEW == VIEW_PLAN)) {
                D_Stunde st = (D_Stunde) node;
                gui_plan_load("plan", st.plan, "stunde", "id", st.id);
                card2.show(jPanelCard, "D_Plan");
            }

            // STUNDE (KO)
            if ((node instanceof D_Stunde_Ko) && (VIEW == VIEW_ATTRIBUTES)) {
                D_Stunde_Ko st_ko = (D_Stunde_Ko) node;

                jRadioWochenstunden1.setSelected(st_ko.wochenstunden == 1);
                jRadioWochenstunden2.setSelected(st_ko.wochenstunden == 2);
                jRadioWochenstunden3.setSelected(st_ko.wochenstunden == 3);

                jRadioStundenTyp1.setSelected(st_ko.typ == Config.STUNDEN_TYP_N);
                jRadioStundenTyp2.setSelected(st_ko.typ == Config.STUNDEN_TYP_D);
                jRadioStundenTyp3.setSelected(st_ko.typ == Config.STUNDEN_TYP_X);

                jRadio_kl_Lage_Egal.setSelected(st_ko.lage_kl == Config.STUNDEN_LAGE_EGAL);
                jRadio_kl_Lage_Anfang.setSelected(st_ko.lage_kl == Config.STUNDEN_LAGE_AM_ANFANG);
                jRadio_kl_Lage_Nicht_Anfang.setSelected(st_ko.lage_kl == Config.STUNDEN_LAGE_NICHT_AM_ANFANG);
                jRadio_kl_Lage_Ende.setSelected(st_ko.lage_kl == Config.STUNDEN_LAGE_AM_ENDE);
                jRadio_kl_Lage_Nicht_Ende.setSelected(st_ko.lage_kl == Config.STUNDEN_LAGE_NICHT_AM_ENDE);
                jRadio_kl_Lage_Rand.setSelected(st_ko.lage_kl == Config.STUNDEN_LAGE_AM_RAND);
                jRadio_kl_Lage_Nicht_Rand.setSelected(st_ko.lage_kl == Config.STUNDEN_LAGE_NICHT_AM_RAND);

                jRadio_le2_Lage_Egal.setSelected(st_ko.lage_le == Config.STUNDEN_LAGE_EGAL);
                jRadio_le_Lage_Anfang.setSelected(st_ko.lage_le == Config.STUNDEN_LAGE_AM_ANFANG);
                jRadio_le_Lage_Nicht_Anfang.setSelected(st_ko.lage_le == Config.STUNDEN_LAGE_NICHT_AM_ANFANG);
                jRadio_le_Lage_Ende.setSelected(st_ko.lage_le == Config.STUNDEN_LAGE_AM_ENDE);
                jRadio_le_Lage_Nicht_Ende.setSelected(st_ko.lage_le == Config.STUNDEN_LAGE_NICHT_AM_ENDE);
                jRadio_le_Lage_Rand.setSelected(st_ko.lage_le == Config.STUNDEN_LAGE_AM_RAND);
                jRadio_le_Lage_Nicht_Rand.setSelected(st_ko.lage_le == Config.STUNDEN_LAGE_NICHT_AM_RAND);

                card2.show(jPanelCard, "D_Stunde");
            }
            if ((node instanceof D_Stunde_Ko) && (VIEW == VIEW_PLAN)) {
                D_Stunde_Ko st_ko = (D_Stunde_Ko) node;
                gui_plan_load("plan", st_ko.plan, "stunde_ko", "id", st_ko.id);
                card2.show(jPanelCard, "D_Plan");
            }

            if (node instanceof D_Berechnungen) {
                D_Berechnungen bea = (D_Berechnungen) node;
                bea_1.setSelected(bea.deaktiviere_le_freie_tage);
                bea_2.setSelected(bea.deaktiviere_le_erst_ab_stunde);
                bea_3.setSelected(bea.deaktiviere_le_nur_bis_stunde);
                bea_4.setSelected(bea.deaktiviere_le_springstunden_tag);
                bea_5.setSelected(bea.deaktiviere_le_springstunden_woche);
                bea_6.setSelected(bea.deaktiviere_le_tagesstundenpraesenz);
                bea_7.setSelected(bea.deaktiviere_le_min_stunden_pro_tag);
                bea_8.setSelected(bea.deaktiviere_le_max_stunden_in_folge);
                bea_9.setSelected(bea.deaktiviere_le_plan_spalte_min);
                bea_10.setSelected(bea.deaktiviere_le_plan_spalte_max);
                bea_11.setSelected(bea.deaktiviere_le_plan_zeile_min);
                bea_12.setSelected(bea.deaktiviere_le_plan_zeile_max);
                bea_13.setSelected(bea.deaktiviere_le_plan_zeile_min_ab);
                bea_14.setSelected(bea.deaktiviere_le_plan_zeile_max_ab);
                bea_15.setSelected(bea.deaktiviere_le_plan_zellen);
                card2.show(jPanelCard, "D_Berechnungen");
            }

            if (node instanceof D_Berechnung) {
                D_Berechnung be = (D_Berechnung) node;
                D_Schule_SOL sc_er = model.db_be_get_ergebnis(be.id);
                sc_er.html_erzeuge_alles(beTextPaneAlles, beTextPaneStatistik, beTextPaneLehrkraefte, beTextPaneKlassen, beTextPaneRaeume, beTextPaneVertretungsreserven, beTextPaneVertretungsoptionen);
                card2.show(jPanelCard, "D_Berechnung");
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jTree1ValueChanged

    /**
     * CryptoMiniSat für Windows herunterladen. <br>
     *
     * @param evt
     */
    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        try {
            URI uri = new URI("https://ci.appveyor.com/project/msoos/cryptominisat");
            java.awt.Desktop.getDesktop().browse(uri);
        } catch (URISyntaxException | IOException ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton6ActionPerformed

    /**
     * CryptoMiniSat für Linux herunterladen. <br>
     *
     * @param evt
     */
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        try {
            URI uri = new URI("https://github.com/msoos/cryptominisat/releases/tag/5.8.0");
            java.awt.Desktop.getDesktop().browse(uri);
        } catch (URISyntaxException | IOException ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * Pfad von CryptoMiniSat auswählen und speichern. <br>
     *
     * @param evt
     */
    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        try {
            Config.setFileChooserFont(fcCrypto.getComponents(), Config.FONT_NORMAL_SANS);
            //fcCrypto.setFont(Config.FONT_NORMAL_SANS);

            // select old directory ...
            File old = new File(Config.get_solver_crypto_pfad());
            if (old.isFile()) {
                fcCrypto.setCurrentDirectory(old.getParentFile());
            }

            // choose cryptominisat file ...
            if (fcCrypto.showOpenDialog(this) != JFileChooser.APPROVE_OPTION) {
                return;
            }

            String pfad = fcCrypto.getSelectedFile().getAbsolutePath();
            jTextField2.setText(pfad);
            Config.set_solver_crypto_pfad(pfad);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton5ActionPerformed

    /**
     * CryptoMiniSat testen. <br>
     * Hierzu werden verschiedene Formeln erstellt und gelöst. <br>
     *
     * @param evt
     */
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        try {
            jTextArea1.setText("");
            if (model.click_test_solver(jTextArea1, 1)) {
                jLabel6.setText(" Testergebnis: 👍 ERFOLGREICH!");
            } else {
                jLabel6.setText(" Testergebnis: 👎 FEHLERHAFT!");
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * Alle Daten der Schule löschen. <br>
     *
     * @param evt
     */
    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Daten löschen?", "Alle Daten löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_sc_clear();
                gui_select_path(model.tr_get_node_schule(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton7ActionPerformed

    /**
     * Daten der Schule speichern. <br>
     *
     * @param evt
     */
    private void jButtonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveActionPerformed
        try {
            Config.setFileChooserFont(fcSaveOpen.getComponents(), Config.FONT_NORMAL_SANS);
            //fcSaveOpen.setFont(Config.FONT_NORMAL_SANS);

            // Alten Pfad auswählen...
            File old = new File(Config.get_solver_speicher_pfad());
            if (old.isFile()) {
                fcSaveOpen.setCurrentDirectory(old.getParentFile());
            }

            // Datei auswählen...
            if (fcSaveOpen.showSaveDialog(this) != JFileChooser.APPROVE_OPTION) {
                return;
            }

            // Überschreiben?
            File file = fcSaveOpen.getSelectedFile();
            if (file.exists()) {
                if (JOptionPane.showConfirmDialog(this, "Wollen Sie die Datei wirklich überschreiben?", "Die Datei existiert bereits", JOptionPane.YES_NO_OPTION) != JOptionPane.YES_OPTION) {
                    return;
                }
            }

            // Neuen Pfad speichern...
            String pfad = file.getAbsolutePath();
            Config.set_solver_speicher_pfad(pfad);
            model.db_save_to_file(file);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButtonSaveActionPerformed

    /**
     * Daten der Schule laden. <br>
     *
     * @param evt
     */
    private void jButtonOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOpenActionPerformed
        try {
            Config.setFileChooserFont(fcSaveOpen.getComponents(), Config.FONT_NORMAL_SANS);
            //fcSaveOpen.setFont(Config.FONT_NORMAL_SANS);

            // Alten Pfad auswählen...
            File old = new File(Config.get_solver_speicher_pfad());
            if (old.isFile()) {
                fcSaveOpen.setCurrentDirectory(old.getParentFile());
            }

            // Datei auswählen...
            if (fcSaveOpen.showOpenDialog(this) != JFileChooser.APPROVE_OPTION) {
                return;
            }

            // Überschreiben?
            File file = fcSaveOpen.getSelectedFile();
            if ((file.exists() == false) || (file.isDirectory())) {
                throw new Exception("Es wurde keine Datei ausgewählt!");
            }

            // Neuen Pfad speichern...
            String pfad = file.getAbsolutePath();
            Config.set_solver_speicher_pfad(pfad);

            model.db_load_from_file(file);

            gui_select_path(model.tr_get_node_schule(), true, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButtonOpenActionPerformed

    /**
     * Alle Fächer löschen. <br>
     *
     * @param evt
     */
    private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Fächer löschen?", "Alle Fächer löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_fa_alle_loeschen();
                gui_select_path(model.tr_get_node_faecher(), false, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton10ActionPerformed

    /**
     * Neues Fach hinzufügen. <br>
     *
     * @param evt
     */
    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
        try {
            int id = model.db_fa_erzeugen();
            gui_select_path(model.tr_get_node_fach(id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton11ActionPerformed

    /**
     * Standardfächer (Grundschule) hinzufügen. <br>
     *
     * @param evt
     */
    private void jButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton12ActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Standardfächer laden (vorhandene Fächer werden gelöscht)?", "Standardfächer laden", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_fa_erzeuge_standard_grundschule();
                gui_select_path(model.tr_get_node_faecher(), true, true);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton12ActionPerformed

    /**
     * Neue Lehrkraft hinzufügen. <br>
     *
     * @param evt
     */
    private void jButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton14ActionPerformed
        execute(ACTION_LEA_ERZEUGE_NEUE_LEHRKRAFT);
    }//GEN-LAST:event_jButton14ActionPerformed

    private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton13ActionPerformed
        execute(ACTION_LEA_ALLE_LOESCHEN);
    }//GEN-LAST:event_jButton13ActionPerformed

    /**
     * Diese Lehrkraft löschen. <br>
     *
     * @param evt
     */
    private void le_diese_loeschenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_le_diese_loeschenActionPerformed
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie die Lehkraft '" + le.kuerzel + "' wirklich löschen?", "Lehrkraft löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_le_loesche(le.id);
                gui_select_path(model.tr_get_node_lehrkraefte(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_diese_loeschenActionPerformed

    /**
     * Das Kürzel der Lehrkraft wurde geändert. <br>
     */
    private void le_kuerzelKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_le_kuerzelKeyReleased
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_kuerzel(le.id, le_kuerzel.getText());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_kuerzelKeyReleased

    /**
     * Alle Klassen löschen. <br>
     *
     * @param evt
     */
    private void jButton16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton16ActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Klassen löschen?", "Alle Klassen löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_kl_alle_loeschen();
                gui_select_path(model.tr_get_node_klassen(), false, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton16ActionPerformed

    /**
     * Neue Klasse hinzufügen. <br>
     *
     * @param evt
     */
    private void jButton17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton17ActionPerformed
        try {
            int id = model.db_kl_erzeugen();
            gui_select_path(model.tr_get_node_klasse(id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton17ActionPerformed

    /**
     * Diese Klasse löschen. <br>
     *
     * @param evt
     */
    private void jButton18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton18ActionPerformed
        try {
            D_Klasse kl = (D_Klasse) jTree1.getLastSelectedPathComponent();
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie die Klasse '" + kl.kuerzel + "' wirklich löschen?", "Klasse löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_kl_loesche(kl.id);
                gui_select_path(model.tr_get_node_klassen(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton18ActionPerformed

    /**
     * Das Kürzel der Klasse wurde geändert. <br>
     *
     * @param evt
     */
    private void tf_klasse_kuerzelKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tf_klasse_kuerzelKeyReleased
        try {
            D_Klasse kl = (D_Klasse) jTree1.getLastSelectedPathComponent();
            model.db_kl_change_kuerzel(kl.id, tf_klasse_kuerzel.getText());
            gui_select_path(model.tr_get_node_klasse(kl.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_tf_klasse_kuerzelKeyReleased

    /**
     * Der Anzeigename der Lehrkraft wurde geändert. <br>
     *
     * @param evt
     */
    private void le_anzeigenameKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_le_anzeigenameKeyReleased
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_anzeigename(le.id, le_anzeigename.getText());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_anzeigenameKeyReleased

    /**
     * Lade Standardklassen (Grundschule, 2-zügig). <br>
     *
     * @param evt
     */
    private void jButton19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton19ActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Standardklassen laden (vorhandene Klassen werden gelöscht)?", "Standardklassen laden", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_kl_erzeuge_standardklassen(new String[]{"1", "2", "3", "4"}, new String[]{"a", "b"});
                gui_select_path(model.tr_get_node_klassen(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton19ActionPerformed

    /**
     * Alle Räume löschen. <br>
     *
     * @param evt
     */
    private void jButton20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton20ActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Räume löschen?", "Alle Räume löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_ra_alle_loeschen();
                gui_select_path(model.tr_get_node_raeume(), false, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton20ActionPerformed

    /**
     * Einen neuen Raum hinzufügen. <br>
     *
     * @param evt
     */
    private void jButton21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton21ActionPerformed
        try {
            int id = model.db_ra_erzeugen("?");
            gui_select_path(model.tr_get_node_raum(id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton21ActionPerformed

    /**
     * Diesen Raum löschen. <br>
     *
     * @param evt
     */
    private void ra_diesen_loeschenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ra_diesen_loeschenActionPerformed
        try {
            D_Raum ra = (D_Raum) jTree1.getLastSelectedPathComponent();
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie den Raum '" + ra.kuerzel + "' wirklich löschen?", "Raum löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_ra_loesche(ra.id);
                gui_select_path(model.tr_get_node_raeume(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_ra_diesen_loeschenActionPerformed

    /**
     * Das Kürzel des Raumes wurde geändert. <br>
     *
     * @param evt
     */
    private void tf_raum_kuerzelKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tf_raum_kuerzelKeyReleased
        try {
            D_Raum ra = (D_Raum) jTree1.getLastSelectedPathComponent();
            model.db_ra_change_kuerzel(ra.id, tf_raum_kuerzel.getText());
            gui_select_path(model.tr_get_node_raum(ra.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_tf_raum_kuerzelKeyReleased

    /**
     * Dieses Fach löschen. <br>
     *
     * @param evt
     */
    private void jButton23ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton23ActionPerformed
        try {
            D_Fach fa = (D_Fach) jTree1.getLastSelectedPathComponent();
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie dieses Fach '" + fa.kuerzel + "' wirklich löschen?", "Fach löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_fa_loesche(fa.id);
                gui_select_path(model.tr_get_node_faecher(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton23ActionPerformed

    /**
     * Das Kürzel des Faches wurde geändert. <br>
     *
     * @param evt
     */
    private void tf_fach_kuerzelKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tf_fach_kuerzelKeyReleased
        try {
            D_Fach fa = (D_Fach) jTree1.getLastSelectedPathComponent();
            model.db_fa_change_kuerzel(fa.id, tf_fach_kuerzel.getText());
            gui_select_path(model.tr_get_node_fach(fa.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_tf_fach_kuerzelKeyReleased

    /**
     * Der Anzeigename des Faches wurde geändert. <br>
     *
     * @param evt
     */
    private void tf_fach_anzeigenameKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tf_fach_anzeigenameKeyReleased
        try {
            D_Fach fa = (D_Fach) jTree1.getLastSelectedPathComponent();
            model.db_fa_change_anzeigename(fa.id, tf_fach_anzeigename.getText());
            gui_select_path(model.tr_get_node_fach(fa.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_tf_fach_anzeigenameKeyReleased

    /**
     * Alle Kopplungen löschen. <br>
     *
     * @param evt
     */
    private void koa_alle_loeschenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_koa_alle_loeschenActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Kopplungen löschen?", "Alle Kopplungen löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_ko_alle_loeschen();
                gui_select_path(model.tr_get_node_kopplungen(), false, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_koa_alle_loeschenActionPerformed

    /**
     * Neue Kopplung hinzufügen. <br>
     *
     * @param evt
     */
    private void jButton25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton25ActionPerformed
        try {
            int id = model.db_ko_erzeugen();
            gui_select_path(model.tr_get_node_kopplung(id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton25ActionPerformed

    /**
     * Diese Kopplung löschen. <br>
     *
     * @param evt
     */
    private void ko_diese_loeschenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ko_diese_loeschenActionPerformed
        try {
            D_Kopplung ko = (D_Kopplung) jTree1.getLastSelectedPathComponent();
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie die Kopplung '" + ko.kuerzel + "' wirklich löschen?", "Kopplung löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_ko_loesche(ko.id);
                gui_select_path(model.tr_get_node_kopplungen(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_ko_diese_loeschenActionPerformed

    /**
     * Das Kürzel der Kopplung wurde geändert. <br>
     *
     * @param evt
     */
    private void tf_kopplung_kuerzelKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tf_kopplung_kuerzelKeyReleased
        try {
            D_Kopplung ko = (D_Kopplung) jTree1.getLastSelectedPathComponent();
            model.db_ko_change_kuerzel(ko.id, tf_kopplung_kuerzel.getText());
            gui_select_path(model.tr_get_node_kopplung(ko.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_tf_kopplung_kuerzelKeyReleased

    /**
     * Der Anzeigename der Kopplung wurde geändert. <br>
     *
     * @param evt
     */
    private void tf_kopplung_anzeigenameKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tf_kopplung_anzeigenameKeyReleased
        try {
            D_Kopplung ko = (D_Kopplung) jTree1.getLastSelectedPathComponent();
            model.db_ko_change_anzeigename(ko.id, tf_kopplung_anzeigename.getText());
            gui_select_path(model.tr_get_node_kopplung(ko.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_tf_kopplung_anzeigenameKeyReleased

    /**
     * Alle Kurse löschen. <br>
     *
     * @param evt
     */
    private void jButton27ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton27ActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Kurse löschen?", "Alle Kurse löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_ku_alle_loeschen();
                gui_select_path(model.tr_get_node_kurse(), false, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton27ActionPerformed

    /**
     * Neuen Kurs hinzufügen. <br>
     *
     * @param evt
     */
    private void jButton28ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton28ActionPerformed
        try {
            int id = model.db_ku_erzeugen();
            gui_select_path(model.tr_get_node_kurs(id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton28ActionPerformed

    /**
     * Diesen Kurs löschen. <br>
     *
     * @param evt
     */
    private void jButton29ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton29ActionPerformed
        try {
            D_Kurs ku = (D_Kurs) jTree1.getLastSelectedPathComponent();
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie den Kurs '" + ku.toString() + "' wirklich löschen?", "Kurs löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_ku_loesche(ku.id);
                gui_select_path(model.tr_get_node_kurse(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton29ActionPerformed

    /**
     * Der Kurs ändert den Ergänzungstext. <br>
     *
     * @param evt
     */
    private void tf_kurs_ergaenzungKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_tf_kurs_ergaenzungKeyReleased
        try {
            D_Kurs ku = (D_Kurs) jTree1.getLastSelectedPathComponent();
            model.db_ku_change_ergaenzung(ku.id, tf_kurs_ergaenzung.getText());
            gui_select_path(model.tr_get_node_kurs(ku.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_tf_kurs_ergaenzungKeyReleased

    /**
     * Fügt dem Kurs ein Stundenelement hinzu. <br>
     *
     * @param evt
     */
    private void jButton30ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton30ActionPerformed
        try {
            D_Kurs ku = (D_Kurs) jTree1.getLastSelectedPathComponent();
            model.db_st_erzeugen(ku.id);
            gui_select_path(model.tr_get_node_kurs(ku.id), true, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton30ActionPerformed

    /**
     * Dieses Stundenelement löschen. <br>
     *
     * @param evt
     */
    private void jButton31ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton31ActionPerformed
        try {
            if (jTree1.getLastSelectedPathComponent() instanceof D_Stunde) {
                D_Stunde st = (D_Stunde) jTree1.getLastSelectedPathComponent();
                if (JOptionPane.showConfirmDialog(this, "Wollen Sie das Stundenelement '" + st.toString() + "' wirklich löschen?", "Stundenelement des Kurses löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                    model.db_st_loesche(st.id);
                    gui_select_path(model.tr_get_node_kurs(st.ku_id), true, false);
                }
            } else {
                D_Stunde_Ko st_ko = (D_Stunde_Ko) jTree1.getLastSelectedPathComponent();
                if (JOptionPane.showConfirmDialog(this, "Wollen Sie das Stundenelement '" + st_ko.toString() + "' wirklich löschen?", "Stundenelement der Kopplung löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                    model.db_st_ko_loesche(st_ko.id);
                    gui_select_path(model.tr_get_node_kopplung(st_ko.ko_id), true, false);
                }
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton31ActionPerformed

    /**
     * Wochenstunden = 1. <br>
     *
     * @param evt
     */
    private void jRadioWochenstunden1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioWochenstunden1ActionPerformed
        try {
            gui_update_stunde_wochenstunden();
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jRadioWochenstunden1ActionPerformed

    /**
     * Wochenstunden = 2. <br>
     *
     * @param evt
     */
    private void jRadioWochenstunden2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioWochenstunden2ActionPerformed
        try {
            gui_update_stunde_wochenstunden();
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jRadioWochenstunden2ActionPerformed

    /**
     * Wochenstunden = 3. <br>
     *
     * @param evt
     */
    private void jRadioWochenstunden3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioWochenstunden3ActionPerformed
        try {
            gui_update_stunde_wochenstunden();
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jRadioWochenstunden3ActionPerformed

    /**
     * Stundentyp "n". <br>
     *
     * @param evt
     */
    private void jRadioStundenTyp1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioStundenTyp1ActionPerformed
        gui_update_stunde_typ();
    }//GEN-LAST:event_jRadioStundenTyp1ActionPerformed

    /**
     * Stundentyp "d". <br>
     *
     * @param evt
     */
    private void jRadioStundenTyp2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioStundenTyp2ActionPerformed
        gui_update_stunde_typ();
    }//GEN-LAST:event_jRadioStundenTyp2ActionPerformed

    /**
     * Stundentyp "x". <br>
     *
     * @param evt
     */
    private void jRadioStundenTyp3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioStundenTyp3ActionPerformed
        gui_update_stunde_typ();
    }//GEN-LAST:event_jRadioStundenTyp3ActionPerformed

    /**
     * Schule - Wochenstunden (5 bis 7) wurde geändert. <br>
     *
     * @param evt
     */
    private void sc_WochenTageStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sc_WochenTageStateChanged
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            int p_wochentage = (int) sc_WochenTage.getValue();
            model.db_sc_change_wochentage(sc.id, p_wochentage);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_WochenTageStateChanged

    /**
     * Stunden pro Tag 4 bis 16. <br>
     *
     * @param evt
     */
    private void sc_StundenProTagStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sc_StundenProTagStateChanged
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            int p_stunden_pro_tag = (int) sc_StundenProTag.getValue();
            model.db_sc_change_stunden_pro_tag(sc.id, p_stunden_pro_tag);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_StundenProTagStateChanged

    /**
     * Alle Berechnungen löschen. <br>
     *
     * @param evt
     */
    private void jButton32ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton32ActionPerformed
        execute(ACTION_BEA_ALLE_BERECHNUNGEN_BEENDEN_UND_LOESCHEN);
    }//GEN-LAST:event_jButton32ActionPerformed

    private void jButton33ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton33ActionPerformed
        execute(ACTION_BEA_STARTE_BERECHNUNG);
    }//GEN-LAST:event_jButton33ActionPerformed

    /**
     * Die Bemerkung der Lehrkraft wurde geändert. <br>
     *
     * @param evt
     */
    private void le_bemerkungKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_le_bemerkungKeyReleased
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_bemerkung(le.id, le_bemerkung.getText());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_bemerkungKeyReleased

    /**
     * Schule - Maximale Anzahl an Springstunden pro Tag wurde geändert. <br>
     *
     * @param evt
     */
    private void sc_le_MaxSpringstundenProTagStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sc_le_MaxSpringstundenProTagStateChanged
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            int p_wert = (int) sc_le_MaxSpringstundenProTag.getValue();
            model.db_sc_change_max_spring_pro_tag(sc.id, p_wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_le_MaxSpringstundenProTagStateChanged

    /**
     * Schule - Maximale Anzahl an Springstunden pro Woche wurde geändert. <br>
     *
     * @param evt
     */
    private void sc_le_MaxSpringstundenProWocheStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sc_le_MaxSpringstundenProWocheStateChanged
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            int p_wert = (int) sc_le_MaxSpringstundenProWoche.getValue();
            model.db_sc_change_max_spring_pro_woche(sc.id, p_wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_le_MaxSpringstundenProWocheStateChanged

    /**
     * Fügt der Kopplung ein Stundenelement hinzu. <br>
     *
     * @param evt
     */
    private void ko_stunde_addActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ko_stunde_addActionPerformed
        try {
            D_Kopplung ko = (D_Kopplung) jTree1.getLastSelectedPathComponent();
            model.db_st_ko_erzeugen(ko.id);
            gui_select_path(model.tr_get_node_kopplung(ko.id), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_ko_stunde_addActionPerformed

    /**
     * Diese Berechnung beenden und löschen. <br>
     *
     * @param evt
     */
    private void jButton34ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton34ActionPerformed
        try {
            D_Berechnung be = (D_Berechnung) jTree1.getLastSelectedPathComponent();
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie die Berechnung '" + be.toString() + "' wirklich beenden und löschen?", "Berechnung beenden und löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                model.db_be_loesche(be);
                gui_select_path(model.tr_get_node_berechnungen(), true, false);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton34ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        jButtonSaveActionPerformed(evt);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        jButtonOpenActionPerformed(evt);
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void le_darf_vertretenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_le_darf_vertretenActionPerformed
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_darf_vertreten(le.id, le_darf_vertreten.isSelected());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_darf_vertretenActionPerformed

    private void le_freie_tageStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_freie_tageStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_freie_tag(le.id, (Integer) le_freie_tage.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, true);

        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_freie_tageStateChanged

    private void le_ab_stunde_xStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_ab_stunde_xStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_ab_stunde_x(le.id, (Integer) le_ab_stunde_x.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_ab_stunde_xStateChanged

    private void le_ab_stunde_yStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_ab_stunde_yStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_ab_stunde_y(le.id, (Integer) le_ab_stunde_y.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_ab_stunde_yStateChanged

    private void le_bis_stunde_xStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_bis_stunde_xStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_bis_stunde_x(le.id, (Integer) le_bis_stunde_x.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_bis_stunde_xStateChanged

    private void le_bis_stunde_yStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_bis_stunde_yStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_bis_stunde_y(le.id, (Integer) le_bis_stunde_y.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_bis_stunde_yStateChanged

    private void le_spring_pro_tag_checkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_le_spring_pro_tag_checkActionPerformed
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_spring_pro_tag_check(le.id, le_spring_pro_tag_check.isSelected());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_spring_pro_tag_checkActionPerformed

    private void le_spring_pro_tag_wertStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_spring_pro_tag_wertStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_spring_pro_tag_wert(le.id, (Integer) le_spring_pro_tag_wert.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_spring_pro_tag_wertStateChanged

    private void le_spring_pro_woche_checkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_le_spring_pro_woche_checkActionPerformed
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_spring_pro_woche_check(le.id, le_spring_pro_woche_check.isSelected());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_spring_pro_woche_checkActionPerformed

    private void le_spring_pro_woche_wertStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_spring_pro_woche_wertStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_spring_pro_woche_wert(le.id, (Integer) le_spring_pro_woche_wert.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_spring_pro_woche_wertStateChanged

    private void le_tagesstunden_checkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_le_tagesstunden_checkActionPerformed
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_tagesstunden_check(le.id, le_tagesstunden_check.isSelected());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_tagesstunden_checkActionPerformed

    private void le_tagesstunden_wertStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_tagesstunden_wertStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_tagesstunden_wert(le.id, (Integer) le_tagesstunden_wert.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_tagesstunden_wertStateChanged

    private void sc_le_MaxTagesstundenpraesenzStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sc_le_MaxTagesstundenpraesenzStateChanged
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            int wert = (int) sc_le_MaxTagesstundenpraesenz.getValue();
            model.db_sc_change_max_tagespraesenz(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_le_MaxTagesstundenpraesenzStateChanged

    /**
     * Button Plan "zurück" wurde gedrückt. <br>
     *
     * @param evt
     */
    private void pl_button_zurueckActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pl_button_zurueckActionPerformed
        try {
            VIEW = VIEW_ATTRIBUTES;
            jTree1ValueChanged(null);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_pl_button_zurueckActionPerformed

    private void jPanelCardMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanelCardMouseExited
        jTree1.requestFocus();
    }//GEN-LAST:event_jPanelCardMouseExited

    /**
     * Button "Plan editieren" wurde gedrückt. <br>
     *
     * @param evt
     */
    private void le_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_le_plan_ladenActionPerformed
        try {
            VIEW = VIEW_PLAN;
            jTree1ValueChanged(null);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_plan_ladenActionPerformed

    private void sc_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_sc_plan_ladenActionPerformed

    private void lea_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lea_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_lea_plan_ladenActionPerformed

    private void kla_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kla_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_kla_plan_ladenActionPerformed

    private void kl_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kl_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_kl_plan_ladenActionPerformed

    private void raa_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_raa_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_raa_plan_ladenActionPerformed

    private void ra_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ra_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_ra_plan_ladenActionPerformed

    private void koa_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_koa_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_koa_plan_ladenActionPerformed

    private void ko_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ko_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_ko_plan_ladenActionPerformed

    private void kua_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kua_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_kua_plan_ladenActionPerformed

    private void kua_plan_laden1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kua_plan_laden1ActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_kua_plan_laden1ActionPerformed

    private void st_plan_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_st_plan_ladenActionPerformed
        execute(ACTION_SPECIAL_VIEW_SHOW_PLAN);
    }//GEN-LAST:event_st_plan_ladenActionPerformed

    /**
     * Plan - Alle Werte löschen. <br>
     *
     * @param evt
     */
    private void plan_diesen_loeschenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_plan_diesen_loeschenActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Werte dieses Planes löschen?", "Plan leeren", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                // Diesen Plan leeren
                for (int t = 0; t < 7; t++) {
                    plan_tag_min[t].setSelectedIndex(0);
                    plan_tag_max[t].setSelectedIndex(0);
                }
                for (int s = 0; s < 16; s++) {
                    plan_stunde_min[s].setSelectedIndex(0);
                    plan_stunde_max[s].setSelectedIndex(0);
                    plan_stunde_ab_max[s].setSelectedIndex(0);
                    plan_stunde_ab_min[s].setSelectedIndex(0);
                }
                for (int s = 0; s < 16; s++) {
                    for (int t = 0; t < 7; t++) {
                        plan_stunde_tag[s][t].setSelectedIndex(0);
                    }
                }
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_plan_diesen_loeschenActionPerformed

    private void ku_vertretungsreservenStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_ku_vertretungsreservenStateChanged
        try {
            D_Kurs ku = (D_Kurs) jTree1.getLastSelectedPathComponent();
            int vertretungsreserven = (int) ku_vertretungsreserven.getValue();
            model.db_ku_change_vertretungsreserven(ku.id, vertretungsreserven);
            gui_select_path(model.tr_get_node_kurs(ku.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_ku_vertretungsreservenStateChanged

    private void sc_keine_einzelstunde_in_1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keine_einzelstunde_in_1ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keine_einzelstunde_in_1.isSelected();
            model.db_sc_change_keine_einzelstunde_in_1(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keine_einzelstunde_in_1ActionPerformed

    private void sc_keine_einzelstunde_in_2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keine_einzelstunde_in_2ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keine_einzelstunde_in_2.isSelected();
            model.db_sc_change_keine_einzelstunde_in_2(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keine_einzelstunde_in_2ActionPerformed

    private void sc_keine_einzelstunde_in_3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keine_einzelstunde_in_3ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keine_einzelstunde_in_3.isSelected();
            model.db_sc_change_keine_einzelstunde_in_3(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keine_einzelstunde_in_3ActionPerformed

    private void sc_keine_einzelstunde_in_4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keine_einzelstunde_in_4ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keine_einzelstunde_in_4.isSelected();
            model.db_sc_change_keine_einzelstunde_in_4(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keine_einzelstunde_in_4ActionPerformed

    private void sc_keine_einzelstunde_in_5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keine_einzelstunde_in_5ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keine_einzelstunde_in_5.isSelected();
            model.db_sc_change_keine_einzelstunde_in_5(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keine_einzelstunde_in_5ActionPerformed

    private void sc_keine_einzelstunde_in_6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keine_einzelstunde_in_6ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keine_einzelstunde_in_6.isSelected();
            model.db_sc_change_keine_einzelstunde_in_6(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keine_einzelstunde_in_6ActionPerformed

    private void sc_planVR_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_planVR_ladenActionPerformed
        gui_plan_show_vertretungsreserven();
    }//GEN-LAST:event_sc_planVR_ladenActionPerformed

    private void jPanel104MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel104MouseExited
        try {
            gui_plan_save();
            jTree1.requestFocus();
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jPanel104MouseExited

    private void sc_keinen_uebergang_1_2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keinen_uebergang_1_2ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keinen_uebergang_1_2.isSelected();
            model.db_sc_change_keinen_uebergang_1_2(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keinen_uebergang_1_2ActionPerformed

    private void sc_keinen_uebergang_2_3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keinen_uebergang_2_3ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keinen_uebergang_2_3.isSelected();
            model.db_sc_change_keinen_uebergang_2_3(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keinen_uebergang_2_3ActionPerformed

    private void sc_keinen_uebergang_3_4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keinen_uebergang_3_4ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keinen_uebergang_3_4.isSelected();
            model.db_sc_change_keinen_uebergang_3_4(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keinen_uebergang_3_4ActionPerformed

    private void sc_keinen_uebergang_4_5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keinen_uebergang_4_5ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keinen_uebergang_4_5.isSelected();
            model.db_sc_change_keinen_uebergang_4_5(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keinen_uebergang_4_5ActionPerformed

    private void sc_keinen_uebergang_5_6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keinen_uebergang_5_6ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keinen_uebergang_5_6.isSelected();
            model.db_sc_change_keinen_uebergang_5_6(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keinen_uebergang_5_6ActionPerformed

    private void sc_keinen_uebergang_6_7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keinen_uebergang_6_7ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keinen_uebergang_6_7.isSelected();
            model.db_sc_change_keinen_uebergang_6_7(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keinen_uebergang_6_7ActionPerformed

    private void sc_keinen_uebergang_7_8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_keinen_uebergang_7_8ActionPerformed
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            boolean wert = sc_keinen_uebergang_7_8.isSelected();
            model.db_sc_change_keinen_uebergang_7_8(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_keinen_uebergang_7_8ActionPerformed

    private void sc_planVO_ladenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sc_planVO_ladenActionPerformed
        gui_plan_show_vertretungsoptionen();
    }//GEN-LAST:event_sc_planVO_ladenActionPerformed

    private void jRadio_kl_Lage_EgalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_kl_Lage_EgalActionPerformed
        gui_update_stunde_lage_kl();
    }//GEN-LAST:event_jRadio_kl_Lage_EgalActionPerformed

    private void jRadio_kl_Lage_AnfangActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_kl_Lage_AnfangActionPerformed
        gui_update_stunde_lage_kl();
    }//GEN-LAST:event_jRadio_kl_Lage_AnfangActionPerformed

    private void jRadio_kl_Lage_Nicht_AnfangActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_kl_Lage_Nicht_AnfangActionPerformed
        gui_update_stunde_lage_kl();
    }//GEN-LAST:event_jRadio_kl_Lage_Nicht_AnfangActionPerformed

    private void jRadio_kl_Lage_EndeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_kl_Lage_EndeActionPerformed
        gui_update_stunde_lage_kl();
    }//GEN-LAST:event_jRadio_kl_Lage_EndeActionPerformed

    private void jRadio_kl_Lage_Nicht_EndeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_kl_Lage_Nicht_EndeActionPerformed
        gui_update_stunde_lage_kl();
    }//GEN-LAST:event_jRadio_kl_Lage_Nicht_EndeActionPerformed

    private void jRadio_kl_Lage_RandActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_kl_Lage_RandActionPerformed
        gui_update_stunde_lage_kl();
    }//GEN-LAST:event_jRadio_kl_Lage_RandActionPerformed

    private void jRadio_kl_Lage_Nicht_RandActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_kl_Lage_Nicht_RandActionPerformed
        gui_update_stunde_lage_kl();
    }//GEN-LAST:event_jRadio_kl_Lage_Nicht_RandActionPerformed

    private void jRadio_le2_Lage_EgalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_le2_Lage_EgalActionPerformed
        gui_update_stunde_lage_le();
    }//GEN-LAST:event_jRadio_le2_Lage_EgalActionPerformed

    private void jRadio_le_Lage_AnfangActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_le_Lage_AnfangActionPerformed
        gui_update_stunde_lage_le();
    }//GEN-LAST:event_jRadio_le_Lage_AnfangActionPerformed

    private void jRadio_le_Lage_Nicht_AnfangActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_le_Lage_Nicht_AnfangActionPerformed
        gui_update_stunde_lage_le();
    }//GEN-LAST:event_jRadio_le_Lage_Nicht_AnfangActionPerformed

    private void jRadio_le_Lage_EndeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_le_Lage_EndeActionPerformed
        gui_update_stunde_lage_le();
    }//GEN-LAST:event_jRadio_le_Lage_EndeActionPerformed

    private void jRadio_le_Lage_Nicht_EndeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_le_Lage_Nicht_EndeActionPerformed
        gui_update_stunde_lage_le();
    }//GEN-LAST:event_jRadio_le_Lage_Nicht_EndeActionPerformed

    private void jRadio_le_Lage_RandActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_le_Lage_RandActionPerformed
        gui_update_stunde_lage_le();
    }//GEN-LAST:event_jRadio_le_Lage_RandActionPerformed

    private void jRadio_le_Lage_Nicht_RandActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_le_Lage_Nicht_RandActionPerformed
        gui_update_stunde_lage_le();
    }//GEN-LAST:event_jRadio_le_Lage_Nicht_RandActionPerformed

    private void jRadio_ku_sort_kl_fa_leActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_ku_sort_kl_fa_leActionPerformed
        gui_update_kurse_sort();
    }//GEN-LAST:event_jRadio_ku_sort_kl_fa_leActionPerformed

    private void jRadio_ku_sort_kl_le_faActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_ku_sort_kl_le_faActionPerformed
        gui_update_kurse_sort();
    }//GEN-LAST:event_jRadio_ku_sort_kl_le_faActionPerformed

    private void jRadio_ku_sort_le_kl_faActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_ku_sort_le_kl_faActionPerformed
        gui_update_kurse_sort();
    }//GEN-LAST:event_jRadio_ku_sort_le_kl_faActionPerformed

    private void jRadio_ku_sort_le_fa_klActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_ku_sort_le_fa_klActionPerformed
        gui_update_kurse_sort();
    }//GEN-LAST:event_jRadio_ku_sort_le_fa_klActionPerformed

    private void jRadio_ku_sort_fa_kl_leActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_ku_sort_fa_kl_leActionPerformed
        gui_update_kurse_sort();
    }//GEN-LAST:event_jRadio_ku_sort_fa_kl_leActionPerformed

    private void jRadio_ku_sort_fa_le_klActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadio_ku_sort_fa_le_klActionPerformed
        gui_update_kurse_sort();
    }//GEN-LAST:event_jRadio_ku_sort_fa_le_klActionPerformed

    private void sc_le_MinStundenProTagStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sc_le_MinStundenProTagStateChanged
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            int wert = (int) sc_le_MinStundenProTag.getValue();
            model.db_sc_le_change_min_stunden_pro_tag(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_le_MinStundenProTagStateChanged

    private void le_min_std_pro_tag_checkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_le_min_std_pro_tag_checkActionPerformed
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_min_stunden_check(le.id, le_min_std_pro_tag_check.isSelected());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_min_std_pro_tag_checkActionPerformed

    private void le_min_std_pro_tag_spinnerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_min_std_pro_tag_spinnerStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_min_stunden_wert(le.id, (Integer) le_min_std_pro_tag_spinner.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_min_std_pro_tag_spinnerStateChanged

    private void ku_nicht_aufeinanderfolgendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ku_nicht_aufeinanderfolgendActionPerformed
        try {
            D_Kurs ku = (D_Kurs) jTree1.getLastSelectedPathComponent();
            int wert = ku_nicht_aufeinanderfolgend.isSelected() ? 1 : 0;
            model.db_ku_change_nicht_aufeinanderfolgend(ku.id, wert);
            gui_select_path(model.tr_get_node_kurs(ku.id), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_ku_nicht_aufeinanderfolgendActionPerformed

    private void sc_min_aufeinanderfolgendStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sc_min_aufeinanderfolgendStateChanged
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            int wert = (int) sc_min_aufeinanderfolgend.getValue();
            model.db_sc_change_min_aufeinanderfolgend(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_min_aufeinanderfolgendStateChanged

    private void sc_le_Max_Stunden_in_FolgeStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_sc_le_Max_Stunden_in_FolgeStateChanged
        try {
            D_Schule sc = (D_Schule) jTree1.getLastSelectedPathComponent();
            int wert = (int) sc_le_Max_Stunden_in_Folge.getValue();
            model.db_sc_le_change_max_stunden_in_folge(sc.id, wert);
            gui_select_path(model.tr_get_node_schule(), true, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_sc_le_Max_Stunden_in_FolgeStateChanged

    private void le_max_stunden_in_folge_checkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_le_max_stunden_in_folge_checkActionPerformed
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_change_max_stunden_folge_check(le.id, le_max_stunden_in_folge_check.isSelected());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_max_stunden_in_folge_checkActionPerformed

    private void le_max_stunden_in_folge_spinnerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_le_max_stunden_in_folge_spinnerStateChanged
        try {
            D_Lehrkraft le = (D_Lehrkraft) jTree1.getLastSelectedPathComponent();
            model.db_le_max_stunden_folge_wert(le.id, (Integer) le_max_stunden_in_folge_spinner.getValue());
            gui_select_path(model.tr_get_node_lehrkraft(le.id), false, false);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_le_max_stunden_in_folge_spinnerStateChanged

    private void plan_alle_loeschenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_plan_alle_loeschenActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Werte ALLER Pläne löschen?", "Alle Pläne der Schule leeren", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                // Alle Daten leeren
                model.db_sc_plaene_loeschen();
                // Diesen Plan leeren (sonst werden die eingetragenen Werte sofort wieder gesetzt)
                for (int t = 0; t < 7; t++) {
                    plan_tag_min[t].setSelectedIndex(0);
                    plan_tag_max[t].setSelectedIndex(0);
                }
                for (int s = 0; s < 16; s++) {
                    plan_stunde_min[s].setSelectedIndex(0);
                    plan_stunde_max[s].setSelectedIndex(0);
                    plan_stunde_ab_max[s].setSelectedIndex(0);
                    plan_stunde_ab_min[s].setSelectedIndex(0);
                }
                for (int s = 0; s < 16; s++) {
                    for (int t = 0; t < 7; t++) {
                        plan_stunde_tag[s][t].setSelectedIndex(0);
                    }
                }
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_plan_alle_loeschenActionPerformed

    private void jButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton15ActionPerformed
        try {
            if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle ausgewählten Objekte löschen?", "Auswahl löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                for (TreePath tp : jTree1.getSelectionPaths()) {
                    Object obj = tp.getLastPathComponent();
                    if (obj instanceof D_Lehrkraft) {
                        model.db_le_loesche(((D_Lehrkraft) obj).id);
                    }
                    if (obj instanceof D_Klasse) {
                        model.db_kl_loesche(((D_Klasse) obj).id);
                    }
                    if (obj instanceof D_Fach) {
                        model.db_fa_loesche(((D_Fach) obj).id);
                    }
                    if (obj instanceof D_Raum) {
                        model.db_ra_loesche(((D_Raum) obj).id);
                    }
                    if (obj instanceof D_Kopplung) {
                        model.db_ko_loesche(((D_Kopplung) obj).id);
                    }
                    if (obj instanceof D_Stunde_Ko) {
                        model.db_st_ko_loesche(((D_Stunde_Ko) obj).id);
                    }
                    if (obj instanceof D_Kurs) {
                        model.db_ku_loesche(((D_Kurs) obj).id);
                    }
                    if (obj instanceof D_Stunde) {
                        model.db_st_loesche(((D_Stunde) obj).id);
                    }
                    if (obj instanceof D_Berechnung) {
                        model.db_be_loesche(((D_Berechnung) obj));
                    }
                }
                gui_select_path(model.tr_get_node_schule(), true, true);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }//GEN-LAST:event_jButton15ActionPerformed

    private void bea_1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_1ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_FREIE_TAGE);
    }//GEN-LAST:event_bea_1ActionPerformed

    private void bea_2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_2ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_ERST_AB_STUNDE);
    }//GEN-LAST:event_bea_2ActionPerformed

    private void bea_3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_3ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_NUR_BIS_STUNDE);
    }//GEN-LAST:event_bea_3ActionPerformed

    private void bea_4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_4ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_SPRINGSTUNDEN_TAG);
    }//GEN-LAST:event_bea_4ActionPerformed

    private void bea_5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_5ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_SPRINGSTUNDEN_WOCHE);
    }//GEN-LAST:event_bea_5ActionPerformed

    private void bea_6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_6ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_TAGESSTUNDENPRAESENZ);
    }//GEN-LAST:event_bea_6ActionPerformed

    private void bea_7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_7ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_MIN_STUNDEN_PRO_TAG);
    }//GEN-LAST:event_bea_7ActionPerformed

    private void bea_8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_8ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_MAX_STUNDEN_IN_FOLGE);
    }//GEN-LAST:event_bea_8ActionPerformed

    private void bea_9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_9ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_PLAN_SPALTE_MIN);
    }//GEN-LAST:event_bea_9ActionPerformed

    private void bea_10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_10ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_PLAN_SPALTE_MAX);
    }//GEN-LAST:event_bea_10ActionPerformed

    private void bea_11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_11ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MIN);
    }//GEN-LAST:event_bea_11ActionPerformed

    private void bea_12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_12ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MAX);
    }//GEN-LAST:event_bea_12ActionPerformed

    private void bea_13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_13ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MIN_AB);
    }//GEN-LAST:event_bea_13ActionPerformed

    private void bea_14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_14ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MAX_AB);
    }//GEN-LAST:event_bea_14ActionPerformed

    private void bea_15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bea_15ActionPerformed
        execute(ACTION_BEA_CHECKBOX_LE_PLAN_ZELLEN);
    }//GEN-LAST:event_bea_15ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
 /*  try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Windows Classic".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
                
                Metal
Nimbus
CDE/Motif
Windows
Windows Classic
                 
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Gui.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }*/
        //</editor-fold>

        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new Gui().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextPane beTextPaneAlles;
    private javax.swing.JTextPane beTextPaneKlassen;
    private javax.swing.JTextPane beTextPaneLehrkraefte;
    private javax.swing.JTextPane beTextPaneRaeume;
    private javax.swing.JTextPane beTextPaneStatistik;
    private javax.swing.JTextPane beTextPaneVertretungsoptionen;
    private javax.swing.JTextPane beTextPaneVertretungsreserven;
    private javax.swing.JCheckBox bea_1;
    private javax.swing.JCheckBox bea_10;
    private javax.swing.JCheckBox bea_11;
    private javax.swing.JCheckBox bea_12;
    private javax.swing.JCheckBox bea_13;
    private javax.swing.JCheckBox bea_14;
    private javax.swing.JCheckBox bea_15;
    private javax.swing.JCheckBox bea_2;
    private javax.swing.JCheckBox bea_3;
    private javax.swing.JCheckBox bea_4;
    private javax.swing.JCheckBox bea_5;
    private javax.swing.JCheckBox bea_6;
    private javax.swing.JCheckBox bea_7;
    private javax.swing.JCheckBox bea_8;
    private javax.swing.JCheckBox bea_9;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.ButtonGroup buttonGroup4;
    private javax.swing.ButtonGroup buttonGroup5;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton14;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton16;
    private javax.swing.JButton jButton17;
    private javax.swing.JButton jButton18;
    private javax.swing.JButton jButton19;
    private javax.swing.JButton jButton20;
    private javax.swing.JButton jButton21;
    private javax.swing.JButton jButton23;
    private javax.swing.JButton jButton25;
    private javax.swing.JButton jButton27;
    private javax.swing.JButton jButton28;
    private javax.swing.JButton jButton29;
    private javax.swing.JButton jButton30;
    private javax.swing.JButton jButton31;
    private javax.swing.JButton jButton32;
    private javax.swing.JButton jButton33;
    private javax.swing.JButton jButton34;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButtonOpen;
    private javax.swing.JButton jButtonSave;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel54;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel62;
    private javax.swing.JLabel jLabel65;
    private javax.swing.JLabel jLabel66;
    private javax.swing.JLabel jLabel67;
    private javax.swing.JLabel jLabel68;
    private javax.swing.JLabel jLabel69;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel70;
    private javax.swing.JLabel jLabel71;
    private javax.swing.JLabel jLabel72;
    private javax.swing.JLabel jLabel73;
    private javax.swing.JLabel jLabel74;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel83;
    private javax.swing.JLabel jLabel85;
    private javax.swing.JLabel jLabel87;
    private javax.swing.JLabel jLabel89;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabel91;
    private javax.swing.JLabel jLabel93;
    private javax.swing.JLabel jLabel95;
    private javax.swing.JLabel jLabel_max;
    private javax.swing.JLabel jLabel_max_s;
    private javax.swing.JLabel jLabel_max_s_ab;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel100;
    private javax.swing.JPanel jPanel101;
    private javax.swing.JPanel jPanel102;
    private javax.swing.JPanel jPanel103;
    private javax.swing.JPanel jPanel104;
    private javax.swing.JPanel jPanel105;
    private javax.swing.JPanel jPanel106;
    private javax.swing.JPanel jPanel107;
    private javax.swing.JPanel jPanel108;
    private javax.swing.JPanel jPanel109;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel110;
    private javax.swing.JPanel jPanel111;
    private javax.swing.JPanel jPanel112;
    private javax.swing.JPanel jPanel113;
    private javax.swing.JPanel jPanel114;
    private javax.swing.JPanel jPanel115;
    private javax.swing.JPanel jPanel116;
    private javax.swing.JPanel jPanel117;
    private javax.swing.JPanel jPanel118;
    private javax.swing.JPanel jPanel119;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel120;
    private javax.swing.JPanel jPanel121;
    private javax.swing.JPanel jPanel122;
    private javax.swing.JPanel jPanel123;
    private javax.swing.JPanel jPanel124;
    private javax.swing.JPanel jPanel125;
    private javax.swing.JPanel jPanel126;
    private javax.swing.JPanel jPanel127;
    private javax.swing.JPanel jPanel128;
    private javax.swing.JPanel jPanel129;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel130;
    private javax.swing.JPanel jPanel131;
    private javax.swing.JPanel jPanel132;
    private javax.swing.JPanel jPanel133;
    private javax.swing.JPanel jPanel134;
    private javax.swing.JPanel jPanel135;
    private javax.swing.JPanel jPanel136;
    private javax.swing.JPanel jPanel137;
    private javax.swing.JPanel jPanel138;
    private javax.swing.JPanel jPanel139;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel140;
    private javax.swing.JPanel jPanel141;
    private javax.swing.JPanel jPanel142;
    private javax.swing.JPanel jPanel143;
    private javax.swing.JPanel jPanel144;
    private javax.swing.JPanel jPanel145;
    private javax.swing.JPanel jPanel146;
    private javax.swing.JPanel jPanel147;
    private javax.swing.JPanel jPanel148;
    private javax.swing.JPanel jPanel149;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel150;
    private javax.swing.JPanel jPanel151;
    private javax.swing.JPanel jPanel152;
    private javax.swing.JPanel jPanel153;
    private javax.swing.JPanel jPanel154;
    private javax.swing.JPanel jPanel155;
    private javax.swing.JPanel jPanel156;
    private javax.swing.JPanel jPanel157;
    private javax.swing.JPanel jPanel158;
    private javax.swing.JPanel jPanel159;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel160;
    private javax.swing.JPanel jPanel161;
    private javax.swing.JPanel jPanel162;
    private javax.swing.JPanel jPanel163;
    private javax.swing.JPanel jPanel164;
    private javax.swing.JPanel jPanel165;
    private javax.swing.JPanel jPanel166;
    private javax.swing.JPanel jPanel167;
    private javax.swing.JPanel jPanel168;
    private javax.swing.JPanel jPanel169;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel170;
    private javax.swing.JPanel jPanel171;
    private javax.swing.JPanel jPanel172;
    private javax.swing.JPanel jPanel173;
    private javax.swing.JPanel jPanel174;
    private javax.swing.JPanel jPanel175;
    private javax.swing.JPanel jPanel176;
    private javax.swing.JPanel jPanel177;
    private javax.swing.JPanel jPanel178;
    private javax.swing.JPanel jPanel179;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel180;
    private javax.swing.JPanel jPanel181;
    private javax.swing.JPanel jPanel182;
    private javax.swing.JPanel jPanel183;
    private javax.swing.JPanel jPanel184;
    private javax.swing.JPanel jPanel185;
    private javax.swing.JPanel jPanel186;
    private javax.swing.JPanel jPanel187;
    private javax.swing.JPanel jPanel188;
    private javax.swing.JPanel jPanel189;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel190;
    private javax.swing.JPanel jPanel191;
    private javax.swing.JPanel jPanel192;
    private javax.swing.JPanel jPanel193;
    private javax.swing.JPanel jPanel194;
    private javax.swing.JPanel jPanel195;
    private javax.swing.JPanel jPanel196;
    private javax.swing.JPanel jPanel197;
    private javax.swing.JPanel jPanel198;
    private javax.swing.JPanel jPanel199;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel200;
    private javax.swing.JPanel jPanel201;
    private javax.swing.JPanel jPanel202;
    private javax.swing.JPanel jPanel203;
    private javax.swing.JPanel jPanel204;
    private javax.swing.JPanel jPanel205;
    private javax.swing.JPanel jPanel206;
    private javax.swing.JPanel jPanel207;
    private javax.swing.JPanel jPanel208;
    private javax.swing.JPanel jPanel209;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel210;
    private javax.swing.JPanel jPanel211;
    private javax.swing.JPanel jPanel212;
    private javax.swing.JPanel jPanel213;
    private javax.swing.JPanel jPanel214;
    private javax.swing.JPanel jPanel215;
    private javax.swing.JPanel jPanel216;
    private javax.swing.JPanel jPanel217;
    private javax.swing.JPanel jPanel218;
    private javax.swing.JPanel jPanel219;
    private javax.swing.JPanel jPanel22;
    private javax.swing.JPanel jPanel220;
    private javax.swing.JPanel jPanel221;
    private javax.swing.JPanel jPanel222;
    private javax.swing.JPanel jPanel223;
    private javax.swing.JPanel jPanel224;
    private javax.swing.JPanel jPanel225;
    private javax.swing.JPanel jPanel226;
    private javax.swing.JPanel jPanel227;
    private javax.swing.JPanel jPanel228;
    private javax.swing.JPanel jPanel229;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel230;
    private javax.swing.JPanel jPanel231;
    private javax.swing.JPanel jPanel232;
    private javax.swing.JPanel jPanel233;
    private javax.swing.JPanel jPanel234;
    private javax.swing.JPanel jPanel235;
    private javax.swing.JPanel jPanel236;
    private javax.swing.JPanel jPanel237;
    private javax.swing.JPanel jPanel238;
    private javax.swing.JPanel jPanel239;
    private javax.swing.JPanel jPanel24;
    private javax.swing.JPanel jPanel240;
    private javax.swing.JPanel jPanel241;
    private javax.swing.JPanel jPanel242;
    private javax.swing.JPanel jPanel243;
    private javax.swing.JPanel jPanel244;
    private javax.swing.JPanel jPanel245;
    private javax.swing.JPanel jPanel246;
    private javax.swing.JPanel jPanel247;
    private javax.swing.JPanel jPanel248;
    private javax.swing.JPanel jPanel249;
    private javax.swing.JPanel jPanel25;
    private javax.swing.JPanel jPanel250;
    private javax.swing.JPanel jPanel251;
    private javax.swing.JPanel jPanel252;
    private javax.swing.JPanel jPanel253;
    private javax.swing.JPanel jPanel254;
    private javax.swing.JPanel jPanel255;
    private javax.swing.JPanel jPanel256;
    private javax.swing.JPanel jPanel257;
    private javax.swing.JPanel jPanel258;
    private javax.swing.JPanel jPanel259;
    private javax.swing.JPanel jPanel26;
    private javax.swing.JPanel jPanel260;
    private javax.swing.JPanel jPanel261;
    private javax.swing.JPanel jPanel262;
    private javax.swing.JPanel jPanel263;
    private javax.swing.JPanel jPanel264;
    private javax.swing.JPanel jPanel265;
    private javax.swing.JPanel jPanel266;
    private javax.swing.JPanel jPanel267;
    private javax.swing.JPanel jPanel268;
    private javax.swing.JPanel jPanel269;
    private javax.swing.JPanel jPanel27;
    private javax.swing.JPanel jPanel270;
    private javax.swing.JPanel jPanel271;
    private javax.swing.JPanel jPanel272;
    private javax.swing.JPanel jPanel273;
    private javax.swing.JPanel jPanel274;
    private javax.swing.JPanel jPanel275;
    private javax.swing.JPanel jPanel276;
    private javax.swing.JPanel jPanel277;
    private javax.swing.JPanel jPanel278;
    private javax.swing.JPanel jPanel279;
    private javax.swing.JPanel jPanel28;
    private javax.swing.JPanel jPanel280;
    private javax.swing.JPanel jPanel281;
    private javax.swing.JPanel jPanel282;
    private javax.swing.JPanel jPanel283;
    private javax.swing.JPanel jPanel284;
    private javax.swing.JPanel jPanel285;
    private javax.swing.JPanel jPanel286;
    private javax.swing.JPanel jPanel287;
    private javax.swing.JPanel jPanel288;
    private javax.swing.JPanel jPanel289;
    private javax.swing.JPanel jPanel29;
    private javax.swing.JPanel jPanel290;
    private javax.swing.JPanel jPanel291;
    private javax.swing.JPanel jPanel292;
    private javax.swing.JPanel jPanel293;
    private javax.swing.JPanel jPanel294;
    private javax.swing.JPanel jPanel295;
    private javax.swing.JPanel jPanel296;
    private javax.swing.JPanel jPanel297;
    private javax.swing.JPanel jPanel298;
    private javax.swing.JPanel jPanel299;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel30;
    private javax.swing.JPanel jPanel300;
    private javax.swing.JPanel jPanel301;
    private javax.swing.JPanel jPanel302;
    private javax.swing.JPanel jPanel303;
    private javax.swing.JPanel jPanel304;
    private javax.swing.JPanel jPanel305;
    private javax.swing.JPanel jPanel306;
    private javax.swing.JPanel jPanel307;
    private javax.swing.JPanel jPanel308;
    private javax.swing.JPanel jPanel309;
    private javax.swing.JPanel jPanel31;
    private javax.swing.JPanel jPanel310;
    private javax.swing.JPanel jPanel311;
    private javax.swing.JPanel jPanel312;
    private javax.swing.JPanel jPanel313;
    private javax.swing.JPanel jPanel314;
    private javax.swing.JPanel jPanel315;
    private javax.swing.JPanel jPanel316;
    private javax.swing.JPanel jPanel317;
    private javax.swing.JPanel jPanel319;
    private javax.swing.JPanel jPanel32;
    private javax.swing.JPanel jPanel320;
    private javax.swing.JPanel jPanel321;
    private javax.swing.JPanel jPanel322;
    private javax.swing.JPanel jPanel323;
    private javax.swing.JPanel jPanel324;
    private javax.swing.JPanel jPanel325;
    private javax.swing.JPanel jPanel326;
    private javax.swing.JPanel jPanel327;
    private javax.swing.JPanel jPanel328;
    private javax.swing.JPanel jPanel329;
    private javax.swing.JPanel jPanel33;
    private javax.swing.JPanel jPanel330;
    private javax.swing.JPanel jPanel331;
    private javax.swing.JPanel jPanel332;
    private javax.swing.JPanel jPanel333;
    private javax.swing.JPanel jPanel334;
    private javax.swing.JPanel jPanel335;
    private javax.swing.JPanel jPanel336;
    private javax.swing.JPanel jPanel337;
    private javax.swing.JPanel jPanel338;
    private javax.swing.JPanel jPanel339;
    private javax.swing.JPanel jPanel34;
    private javax.swing.JPanel jPanel340;
    private javax.swing.JPanel jPanel341;
    private javax.swing.JPanel jPanel342;
    private javax.swing.JPanel jPanel343;
    private javax.swing.JPanel jPanel344;
    private javax.swing.JPanel jPanel345;
    private javax.swing.JPanel jPanel346;
    private javax.swing.JPanel jPanel347;
    private javax.swing.JPanel jPanel348;
    private javax.swing.JPanel jPanel349;
    private javax.swing.JPanel jPanel35;
    private javax.swing.JPanel jPanel350;
    private javax.swing.JPanel jPanel351;
    private javax.swing.JPanel jPanel352;
    private javax.swing.JPanel jPanel353;
    private javax.swing.JPanel jPanel354;
    private javax.swing.JPanel jPanel355;
    private javax.swing.JPanel jPanel356;
    private javax.swing.JPanel jPanel357;
    private javax.swing.JPanel jPanel358;
    private javax.swing.JPanel jPanel359;
    private javax.swing.JPanel jPanel36;
    private javax.swing.JPanel jPanel360;
    private javax.swing.JPanel jPanel361;
    private javax.swing.JPanel jPanel362;
    private javax.swing.JPanel jPanel363;
    private javax.swing.JPanel jPanel364;
    private javax.swing.JPanel jPanel365;
    private javax.swing.JPanel jPanel366;
    private javax.swing.JPanel jPanel367;
    private javax.swing.JPanel jPanel368;
    private javax.swing.JPanel jPanel369;
    private javax.swing.JPanel jPanel37;
    private javax.swing.JPanel jPanel370;
    private javax.swing.JPanel jPanel371;
    private javax.swing.JPanel jPanel372;
    private javax.swing.JPanel jPanel373;
    private javax.swing.JPanel jPanel374;
    private javax.swing.JPanel jPanel375;
    private javax.swing.JPanel jPanel376;
    private javax.swing.JPanel jPanel377;
    private javax.swing.JPanel jPanel378;
    private javax.swing.JPanel jPanel379;
    private javax.swing.JPanel jPanel38;
    private javax.swing.JPanel jPanel380;
    private javax.swing.JPanel jPanel381;
    private javax.swing.JPanel jPanel382;
    private javax.swing.JPanel jPanel383;
    private javax.swing.JPanel jPanel384;
    private javax.swing.JPanel jPanel385;
    private javax.swing.JPanel jPanel386;
    private javax.swing.JPanel jPanel387;
    private javax.swing.JPanel jPanel39;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel40;
    private javax.swing.JPanel jPanel41;
    private javax.swing.JPanel jPanel42;
    private javax.swing.JPanel jPanel43;
    private javax.swing.JPanel jPanel44;
    private javax.swing.JPanel jPanel45;
    private javax.swing.JPanel jPanel46;
    private javax.swing.JPanel jPanel47;
    private javax.swing.JPanel jPanel48;
    private javax.swing.JPanel jPanel49;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel50;
    private javax.swing.JPanel jPanel51;
    private javax.swing.JPanel jPanel52;
    private javax.swing.JPanel jPanel53;
    private javax.swing.JPanel jPanel54;
    private javax.swing.JPanel jPanel55;
    private javax.swing.JPanel jPanel56;
    private javax.swing.JPanel jPanel57;
    private javax.swing.JPanel jPanel58;
    private javax.swing.JPanel jPanel59;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel60;
    private javax.swing.JPanel jPanel61;
    private javax.swing.JPanel jPanel62;
    private javax.swing.JPanel jPanel63;
    private javax.swing.JPanel jPanel64;
    private javax.swing.JPanel jPanel65;
    private javax.swing.JPanel jPanel66;
    private javax.swing.JPanel jPanel67;
    private javax.swing.JPanel jPanel68;
    private javax.swing.JPanel jPanel69;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel70;
    private javax.swing.JPanel jPanel71;
    private javax.swing.JPanel jPanel72;
    private javax.swing.JPanel jPanel73;
    private javax.swing.JPanel jPanel74;
    private javax.swing.JPanel jPanel75;
    private javax.swing.JPanel jPanel76;
    private javax.swing.JPanel jPanel77;
    private javax.swing.JPanel jPanel78;
    private javax.swing.JPanel jPanel79;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel80;
    private javax.swing.JPanel jPanel81;
    private javax.swing.JPanel jPanel82;
    private javax.swing.JPanel jPanel83;
    private javax.swing.JPanel jPanel84;
    private javax.swing.JPanel jPanel85;
    private javax.swing.JPanel jPanel86;
    private javax.swing.JPanel jPanel87;
    private javax.swing.JPanel jPanel88;
    private javax.swing.JPanel jPanel89;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jPanel90;
    private javax.swing.JPanel jPanel91;
    private javax.swing.JPanel jPanel92;
    private javax.swing.JPanel jPanel93;
    private javax.swing.JPanel jPanel94;
    private javax.swing.JPanel jPanel95;
    private javax.swing.JPanel jPanel96;
    private javax.swing.JPanel jPanel97;
    private javax.swing.JPanel jPanel98;
    private javax.swing.JPanel jPanel99;
    private javax.swing.JPanel jPanelCard;
    private javax.swing.JPanel jPanelWest;
    private javax.swing.JRadioButton jRadioStundenTyp1;
    private javax.swing.JRadioButton jRadioStundenTyp2;
    private javax.swing.JRadioButton jRadioStundenTyp3;
    private javax.swing.JRadioButton jRadioWochenstunden1;
    private javax.swing.JRadioButton jRadioWochenstunden2;
    private javax.swing.JRadioButton jRadioWochenstunden3;
    private javax.swing.JRadioButton jRadio_kl_Lage_Anfang;
    private javax.swing.JRadioButton jRadio_kl_Lage_Egal;
    private javax.swing.JRadioButton jRadio_kl_Lage_Ende;
    private javax.swing.JRadioButton jRadio_kl_Lage_Nicht_Anfang;
    private javax.swing.JRadioButton jRadio_kl_Lage_Nicht_Ende;
    private javax.swing.JRadioButton jRadio_kl_Lage_Nicht_Rand;
    private javax.swing.JRadioButton jRadio_kl_Lage_Rand;
    private javax.swing.JRadioButton jRadio_ku_sort_fa_kl_le;
    private javax.swing.JRadioButton jRadio_ku_sort_fa_le_kl;
    private javax.swing.JRadioButton jRadio_ku_sort_kl_fa_le;
    private javax.swing.JRadioButton jRadio_ku_sort_kl_le_fa;
    private javax.swing.JRadioButton jRadio_ku_sort_le_fa_kl;
    private javax.swing.JRadioButton jRadio_ku_sort_le_kl_fa;
    private javax.swing.JRadioButton jRadio_le2_Lage_Egal;
    private javax.swing.JRadioButton jRadio_le_Lage_Anfang;
    private javax.swing.JRadioButton jRadio_le_Lage_Ende;
    private javax.swing.JRadioButton jRadio_le_Lage_Nicht_Anfang;
    private javax.swing.JRadioButton jRadio_le_Lage_Nicht_Ende;
    private javax.swing.JRadioButton jRadio_le_Lage_Nicht_Rand;
    private javax.swing.JRadioButton jRadio_le_Lage_Rand;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane15;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTable jTable3;
    private javax.swing.JTable jTable4;
    private javax.swing.JTable jTable5;
    private javax.swing.JTable jTable6;
    private javax.swing.JTable jTable7;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTree jTree1;
    private javax.swing.JButton kl_plan_laden;
    private javax.swing.JButton kla_plan_laden;
    private javax.swing.JButton ko_diese_loeschen;
    private javax.swing.JButton ko_plan_laden;
    private javax.swing.JButton ko_stunde_add;
    private javax.swing.JButton koa_alle_loeschen;
    private javax.swing.JButton koa_plan_laden;
    private javax.swing.JCheckBox ku_nicht_aufeinanderfolgend;
    private javax.swing.JSpinner ku_vertretungsreserven;
    private javax.swing.JButton kua_plan_laden;
    private javax.swing.JButton kua_plan_laden1;
    private javax.swing.JSpinner le_ab_stunde_x;
    private javax.swing.JSpinner le_ab_stunde_y;
    private javax.swing.JTextField le_anzeigename;
    private javax.swing.JTextField le_bemerkung;
    private javax.swing.JSpinner le_bis_stunde_x;
    private javax.swing.JSpinner le_bis_stunde_y;
    private javax.swing.JCheckBox le_darf_vertreten;
    private javax.swing.JButton le_diese_loeschen;
    private javax.swing.JSpinner le_freie_tage;
    private javax.swing.JTextField le_kuerzel;
    private javax.swing.JCheckBox le_max_stunden_in_folge_check;
    private javax.swing.JSpinner le_max_stunden_in_folge_spinner;
    private javax.swing.JCheckBox le_min_std_pro_tag_check;
    private javax.swing.JSpinner le_min_std_pro_tag_spinner;
    private javax.swing.JButton le_plan_laden;
    private javax.swing.JCheckBox le_spring_pro_tag_check;
    private javax.swing.JSpinner le_spring_pro_tag_wert;
    private javax.swing.JCheckBox le_spring_pro_woche_check;
    private javax.swing.JSpinner le_spring_pro_woche_wert;
    private javax.swing.JCheckBox le_tagesstunden_check;
    private javax.swing.JSpinner le_tagesstunden_wert;
    private javax.swing.JButton lea_plan_laden;
    private javax.swing.JPanel pBerechnung;
    private javax.swing.JPanel pBerechnungen;
    private javax.swing.JPanel pColumn1a;
    private javax.swing.JPanel pColumn1b;
    private javax.swing.JPanel pColumn2a;
    private javax.swing.JPanel pColumn2b;
    private javax.swing.JPanel pColumn2b1;
    private javax.swing.JPanel pColumn2b2;
    private javax.swing.JPanel pColumn2b3;
    private javax.swing.JPanel pEinstellungen;
    private javax.swing.JPanel pFach;
    private javax.swing.JPanel pFaecher;
    private javax.swing.JPanel pKlasse;
    private javax.swing.JPanel pKlassen;
    private javax.swing.JPanel pKopplung;
    private javax.swing.JPanel pKopplungen;
    private javax.swing.JPanel pKurs;
    private javax.swing.JPanel pKurse;
    private javax.swing.JPanel pLeer;
    private javax.swing.JPanel pLehrkraefte;
    private javax.swing.JPanel pLehrkraft;
    private javax.swing.JPanel pMulti;
    private javax.swing.JPanel pPlan;
    private javax.swing.JPanel pRaeume;
    private javax.swing.JPanel pRaum;
    private javax.swing.JPanel pSchule;
    private javax.swing.JPanel pStunde;
    private javax.swing.JPanel panelDummy1;
    private javax.swing.JPanel panelDummy10;
    private javax.swing.JPanel panelDummy11;
    private javax.swing.JPanel panelDummy12;
    private javax.swing.JPanel panelDummy13;
    private javax.swing.JPanel panelDummy14;
    private javax.swing.JPanel panelDummy15;
    private javax.swing.JPanel panelDummy16;
    private javax.swing.JPanel panelDummy17;
    private javax.swing.JPanel panelDummy18;
    private javax.swing.JPanel panelDummy19;
    private javax.swing.JPanel panelDummy2;
    private javax.swing.JPanel panelDummy20;
    private javax.swing.JPanel panelDummy21;
    private javax.swing.JPanel panelDummy22;
    private javax.swing.JPanel panelDummy23;
    private javax.swing.JPanel panelDummy24;
    private javax.swing.JPanel panelDummy3;
    private javax.swing.JPanel panelDummy4;
    private javax.swing.JPanel panelDummy5;
    private javax.swing.JPanel panelDummy6;
    private javax.swing.JPanel panelDummy7;
    private javax.swing.JPanel panelDummy8;
    private javax.swing.JPanel panelDummy9;
    private javax.swing.JPanel panel_h1_s1;
    private javax.swing.JPanel panel_h1_s10;
    private javax.swing.JPanel panel_h1_s11;
    private javax.swing.JPanel panel_h1_s12;
    private javax.swing.JPanel panel_h1_s13;
    private javax.swing.JPanel panel_h1_s14;
    private javax.swing.JPanel panel_h1_s15;
    private javax.swing.JPanel panel_h1_s16;
    private javax.swing.JPanel panel_h1_s2;
    private javax.swing.JPanel panel_h1_s3;
    private javax.swing.JPanel panel_h1_s4;
    private javax.swing.JPanel panel_h1_s5;
    private javax.swing.JPanel panel_h1_s6;
    private javax.swing.JPanel panel_h1_s7;
    private javax.swing.JPanel panel_h1_s8;
    private javax.swing.JPanel panel_h1_s9;
    private javax.swing.JPanel panel_h_header1a;
    private javax.swing.JPanel panel_h_header1b;
    private javax.swing.JPanel panel_h_header2;
    private javax.swing.JPanel panel_h_max;
    private javax.swing.JPanel panel_h_min;
    private javax.swing.JButton pl_button_zurueck;
    private javax.swing.JLabel pl_di_lab;
    private javax.swing.JComboBox<String> pl_di_max;
    private javax.swing.JComboBox<String> pl_di_min;
    private javax.swing.JLabel pl_do_lab;
    private javax.swing.JComboBox<String> pl_do_max;
    private javax.swing.JComboBox<String> pl_do_min;
    private javax.swing.JLabel pl_fr_lab;
    private javax.swing.JComboBox<String> pl_fr_max;
    private javax.swing.JComboBox<String> pl_fr_min;
    private javax.swing.JLabel pl_mi_lab;
    private javax.swing.JComboBox<String> pl_mi_max;
    private javax.swing.JComboBox<String> pl_mi_min;
    private javax.swing.JLabel pl_mo_lab;
    private javax.swing.JComboBox<String> pl_mo_max;
    private javax.swing.JComboBox<String> pl_mo_min;
    private javax.swing.JLabel pl_sa_lab;
    private javax.swing.JComboBox<String> pl_sa_max;
    private javax.swing.JComboBox<String> pl_sa_min;
    private javax.swing.JLabel pl_so_lab;
    private javax.swing.JComboBox<String> pl_so_max;
    private javax.swing.JComboBox<String> pl_so_min;
    private javax.swing.JComboBox<String> pl_std_10_ab_max;
    private javax.swing.JComboBox<String> pl_std_10_ab_min;
    private javax.swing.JComboBox<String> pl_std_10_di;
    private javax.swing.JComboBox<String> pl_std_10_do;
    private javax.swing.JComboBox<String> pl_std_10_fr;
    private javax.swing.JComboBox<String> pl_std_10_max;
    private javax.swing.JComboBox<String> pl_std_10_mi;
    private javax.swing.JComboBox<String> pl_std_10_min;
    private javax.swing.JComboBox<String> pl_std_10_mo;
    private javax.swing.JComboBox<String> pl_std_10_sa;
    private javax.swing.JComboBox<String> pl_std_10_so;
    private javax.swing.JComboBox<String> pl_std_11_ab_max;
    private javax.swing.JComboBox<String> pl_std_11_ab_min;
    private javax.swing.JComboBox<String> pl_std_11_di;
    private javax.swing.JComboBox<String> pl_std_11_do;
    private javax.swing.JComboBox<String> pl_std_11_fr;
    private javax.swing.JComboBox<String> pl_std_11_max;
    private javax.swing.JComboBox<String> pl_std_11_mi;
    private javax.swing.JComboBox<String> pl_std_11_min;
    private javax.swing.JComboBox<String> pl_std_11_mo;
    private javax.swing.JComboBox<String> pl_std_11_sa;
    private javax.swing.JComboBox<String> pl_std_11_so;
    private javax.swing.JComboBox<String> pl_std_12_ab_max;
    private javax.swing.JComboBox<String> pl_std_12_ab_min;
    private javax.swing.JComboBox<String> pl_std_12_di;
    private javax.swing.JComboBox<String> pl_std_12_do;
    private javax.swing.JComboBox<String> pl_std_12_fr;
    private javax.swing.JComboBox<String> pl_std_12_max;
    private javax.swing.JComboBox<String> pl_std_12_mi;
    private javax.swing.JComboBox<String> pl_std_12_min;
    private javax.swing.JComboBox<String> pl_std_12_mo;
    private javax.swing.JComboBox<String> pl_std_12_sa;
    private javax.swing.JComboBox<String> pl_std_12_so;
    private javax.swing.JComboBox<String> pl_std_13_ab_max;
    private javax.swing.JComboBox<String> pl_std_13_ab_min;
    private javax.swing.JComboBox<String> pl_std_13_di;
    private javax.swing.JComboBox<String> pl_std_13_do;
    private javax.swing.JComboBox<String> pl_std_13_fr;
    private javax.swing.JComboBox<String> pl_std_13_max;
    private javax.swing.JComboBox<String> pl_std_13_mi;
    private javax.swing.JComboBox<String> pl_std_13_min;
    private javax.swing.JComboBox<String> pl_std_13_mo;
    private javax.swing.JComboBox<String> pl_std_13_sa;
    private javax.swing.JComboBox<String> pl_std_13_so;
    private javax.swing.JComboBox<String> pl_std_14_ab_max;
    private javax.swing.JComboBox<String> pl_std_14_ab_min;
    private javax.swing.JComboBox<String> pl_std_14_di;
    private javax.swing.JComboBox<String> pl_std_14_do;
    private javax.swing.JComboBox<String> pl_std_14_fr;
    private javax.swing.JComboBox<String> pl_std_14_max;
    private javax.swing.JComboBox<String> pl_std_14_mi;
    private javax.swing.JComboBox<String> pl_std_14_min;
    private javax.swing.JComboBox<String> pl_std_14_mo;
    private javax.swing.JComboBox<String> pl_std_14_sa;
    private javax.swing.JComboBox<String> pl_std_14_so;
    private javax.swing.JComboBox<String> pl_std_15_ab_max;
    private javax.swing.JComboBox<String> pl_std_15_ab_min;
    private javax.swing.JComboBox<String> pl_std_15_di;
    private javax.swing.JComboBox<String> pl_std_15_do;
    private javax.swing.JComboBox<String> pl_std_15_fr;
    private javax.swing.JComboBox<String> pl_std_15_max;
    private javax.swing.JComboBox<String> pl_std_15_mi;
    private javax.swing.JComboBox<String> pl_std_15_min;
    private javax.swing.JComboBox<String> pl_std_15_mo;
    private javax.swing.JComboBox<String> pl_std_15_sa;
    private javax.swing.JComboBox<String> pl_std_15_so;
    private javax.swing.JComboBox<String> pl_std_16_ab_max;
    private javax.swing.JComboBox<String> pl_std_16_ab_min;
    private javax.swing.JComboBox<String> pl_std_16_di;
    private javax.swing.JComboBox<String> pl_std_16_do;
    private javax.swing.JComboBox<String> pl_std_16_fr;
    private javax.swing.JComboBox<String> pl_std_16_max;
    private javax.swing.JComboBox<String> pl_std_16_mi;
    private javax.swing.JComboBox<String> pl_std_16_min;
    private javax.swing.JComboBox<String> pl_std_16_mo;
    private javax.swing.JComboBox<String> pl_std_16_sa;
    private javax.swing.JComboBox<String> pl_std_16_so;
    private javax.swing.JComboBox<String> pl_std_1_ab_max;
    private javax.swing.JComboBox<String> pl_std_1_ab_min;
    private javax.swing.JComboBox<String> pl_std_1_di;
    private javax.swing.JComboBox<String> pl_std_1_do;
    private javax.swing.JComboBox<String> pl_std_1_fr;
    private javax.swing.JComboBox<String> pl_std_1_max;
    private javax.swing.JComboBox<String> pl_std_1_mi;
    private javax.swing.JComboBox<String> pl_std_1_min;
    private javax.swing.JComboBox<String> pl_std_1_mo;
    private javax.swing.JComboBox<String> pl_std_1_sa;
    private javax.swing.JComboBox<String> pl_std_1_so;
    private javax.swing.JComboBox<String> pl_std_2_ab_max;
    private javax.swing.JComboBox<String> pl_std_2_ab_min;
    private javax.swing.JComboBox<String> pl_std_2_di;
    private javax.swing.JComboBox<String> pl_std_2_do;
    private javax.swing.JComboBox<String> pl_std_2_fr;
    private javax.swing.JComboBox<String> pl_std_2_max;
    private javax.swing.JComboBox<String> pl_std_2_mi;
    private javax.swing.JComboBox<String> pl_std_2_min;
    private javax.swing.JComboBox<String> pl_std_2_mo;
    private javax.swing.JComboBox<String> pl_std_2_sa;
    private javax.swing.JComboBox<String> pl_std_2_so;
    private javax.swing.JComboBox<String> pl_std_3_ab_max;
    private javax.swing.JComboBox<String> pl_std_3_ab_min;
    private javax.swing.JComboBox<String> pl_std_3_di;
    private javax.swing.JComboBox<String> pl_std_3_do;
    private javax.swing.JComboBox<String> pl_std_3_fr;
    private javax.swing.JComboBox<String> pl_std_3_max;
    private javax.swing.JComboBox<String> pl_std_3_mi;
    private javax.swing.JComboBox<String> pl_std_3_min;
    private javax.swing.JComboBox<String> pl_std_3_mo;
    private javax.swing.JComboBox<String> pl_std_3_sa;
    private javax.swing.JComboBox<String> pl_std_3_so;
    private javax.swing.JComboBox<String> pl_std_4_ab_max;
    private javax.swing.JComboBox<String> pl_std_4_ab_min;
    private javax.swing.JComboBox<String> pl_std_4_di;
    private javax.swing.JComboBox<String> pl_std_4_do;
    private javax.swing.JComboBox<String> pl_std_4_fr;
    private javax.swing.JComboBox<String> pl_std_4_max;
    private javax.swing.JComboBox<String> pl_std_4_mi;
    private javax.swing.JComboBox<String> pl_std_4_min;
    private javax.swing.JComboBox<String> pl_std_4_mo;
    private javax.swing.JComboBox<String> pl_std_4_sa;
    private javax.swing.JComboBox<String> pl_std_4_so;
    private javax.swing.JComboBox<String> pl_std_5_ab_max;
    private javax.swing.JComboBox<String> pl_std_5_ab_min;
    private javax.swing.JComboBox<String> pl_std_5_di;
    private javax.swing.JComboBox<String> pl_std_5_do;
    private javax.swing.JComboBox<String> pl_std_5_fr;
    private javax.swing.JComboBox<String> pl_std_5_max;
    private javax.swing.JComboBox<String> pl_std_5_mi;
    private javax.swing.JComboBox<String> pl_std_5_min;
    private javax.swing.JComboBox<String> pl_std_5_mo;
    private javax.swing.JComboBox<String> pl_std_5_sa;
    private javax.swing.JComboBox<String> pl_std_5_so;
    private javax.swing.JComboBox<String> pl_std_6_ab_max;
    private javax.swing.JComboBox<String> pl_std_6_ab_min;
    private javax.swing.JComboBox<String> pl_std_6_di;
    private javax.swing.JComboBox<String> pl_std_6_do;
    private javax.swing.JComboBox<String> pl_std_6_fr;
    private javax.swing.JComboBox<String> pl_std_6_max;
    private javax.swing.JComboBox<String> pl_std_6_mi;
    private javax.swing.JComboBox<String> pl_std_6_min;
    private javax.swing.JComboBox<String> pl_std_6_mo;
    private javax.swing.JComboBox<String> pl_std_6_sa;
    private javax.swing.JComboBox<String> pl_std_6_so;
    private javax.swing.JComboBox<String> pl_std_7_ab_max;
    private javax.swing.JComboBox<String> pl_std_7_ab_min;
    private javax.swing.JComboBox<String> pl_std_7_di;
    private javax.swing.JComboBox<String> pl_std_7_do;
    private javax.swing.JComboBox<String> pl_std_7_fr;
    private javax.swing.JComboBox<String> pl_std_7_max;
    private javax.swing.JComboBox<String> pl_std_7_mi;
    private javax.swing.JComboBox<String> pl_std_7_min;
    private javax.swing.JComboBox<String> pl_std_7_mo;
    private javax.swing.JComboBox<String> pl_std_7_sa;
    private javax.swing.JComboBox<String> pl_std_7_so;
    private javax.swing.JComboBox<String> pl_std_8_ab_max;
    private javax.swing.JComboBox<String> pl_std_8_ab_min;
    private javax.swing.JComboBox<String> pl_std_8_di;
    private javax.swing.JComboBox<String> pl_std_8_do;
    private javax.swing.JComboBox<String> pl_std_8_fr;
    private javax.swing.JComboBox<String> pl_std_8_max;
    private javax.swing.JComboBox<String> pl_std_8_mi;
    private javax.swing.JComboBox<String> pl_std_8_min;
    private javax.swing.JComboBox<String> pl_std_8_mo;
    private javax.swing.JComboBox<String> pl_std_8_sa;
    private javax.swing.JComboBox<String> pl_std_8_so;
    private javax.swing.JComboBox<String> pl_std_9_ab_max;
    private javax.swing.JComboBox<String> pl_std_9_ab_min;
    private javax.swing.JComboBox<String> pl_std_9_di;
    private javax.swing.JComboBox<String> pl_std_9_do;
    private javax.swing.JComboBox<String> pl_std_9_fr;
    private javax.swing.JComboBox<String> pl_std_9_max;
    private javax.swing.JComboBox<String> pl_std_9_mi;
    private javax.swing.JComboBox<String> pl_std_9_min;
    private javax.swing.JComboBox<String> pl_std_9_mo;
    private javax.swing.JComboBox<String> pl_std_9_sa;
    private javax.swing.JComboBox<String> pl_std_9_so;
    private javax.swing.JButton plan_alle_loeschen;
    private javax.swing.JButton plan_diesen_loeschen;
    private javax.swing.JButton ra_diesen_loeschen;
    private javax.swing.JButton ra_plan_laden;
    private javax.swing.JButton raa_plan_laden;
    private javax.swing.JSpinner sc_StundenProTag;
    private javax.swing.JSpinner sc_WochenTage;
    private javax.swing.JCheckBox sc_keine_einzelstunde_in_1;
    private javax.swing.JCheckBox sc_keine_einzelstunde_in_2;
    private javax.swing.JCheckBox sc_keine_einzelstunde_in_3;
    private javax.swing.JCheckBox sc_keine_einzelstunde_in_4;
    private javax.swing.JCheckBox sc_keine_einzelstunde_in_5;
    private javax.swing.JCheckBox sc_keine_einzelstunde_in_6;
    private javax.swing.JCheckBox sc_keinen_uebergang_1_2;
    private javax.swing.JCheckBox sc_keinen_uebergang_2_3;
    private javax.swing.JCheckBox sc_keinen_uebergang_3_4;
    private javax.swing.JCheckBox sc_keinen_uebergang_4_5;
    private javax.swing.JCheckBox sc_keinen_uebergang_5_6;
    private javax.swing.JCheckBox sc_keinen_uebergang_6_7;
    private javax.swing.JCheckBox sc_keinen_uebergang_7_8;
    private javax.swing.JLabel sc_label_min_aufeinander_von;
    private javax.swing.JSpinner sc_le_MaxSpringstundenProTag;
    private javax.swing.JSpinner sc_le_MaxSpringstundenProWoche;
    private javax.swing.JSpinner sc_le_MaxTagesstundenpraesenz;
    private javax.swing.JSpinner sc_le_Max_Stunden_in_Folge;
    private javax.swing.JSpinner sc_le_MinStundenProTag;
    private javax.swing.JSpinner sc_min_aufeinanderfolgend;
    private javax.swing.JButton sc_planVO_laden;
    private javax.swing.JButton sc_planVR_laden;
    private javax.swing.JButton sc_plan_laden;
    private javax.swing.JScrollPane scrollTextPaneAlles;
    private javax.swing.JScrollPane scrollTextPaneKlassen;
    private javax.swing.JScrollPane scrollTextPaneLehrkraefte;
    private javax.swing.JScrollPane scrollTextPaneRaeume;
    private javax.swing.JScrollPane scrollTextPaneVertretungsoptionen;
    private javax.swing.JScrollPane scrollTextPaneVertretungsreserven;
    private javax.swing.JButton st_plan_laden;
    private javax.swing.JPanel temp;
    private javax.swing.JTextField tf_fach_anzeigename;
    private javax.swing.JTextField tf_fach_kuerzel;
    private javax.swing.JTextField tf_klasse_kuerzel;
    private javax.swing.JTextField tf_kopplung_anzeigename;
    private javax.swing.JTextField tf_kopplung_kuerzel;
    private javax.swing.JTextField tf_kurs_ergaenzung;
    private javax.swing.JTextField tf_raum_kuerzel;
    // End of variables declaration//GEN-END:variables

    @SuppressWarnings("CallToPrintStackTrace")
    protected void handle_exception(Exception ex) {
        ex.printStackTrace();
        JOptionPane.showMessageDialog(this, ex.getMessage());

    }

    private void gui_standardauswahl() throws Exception {
        gui_select_path(model.tr_get_node_schule(), true, false);
    }

    void gui_tree_structure_changed_pre(boolean select_same) {
        if (select_same) {
            select_same_path = jTree1.getSelectionPath();
        }
        card_wechsel_erlaubt = false;
        expanded_paths = jTree1.getExpandedDescendants(model.tr_get_node_root());
    }

    void gui_tree_structure_changed_post(boolean select_same) throws Exception {
        if (expanded_paths != null) {
            while (expanded_paths.hasMoreElements()) {
                TreePath tp = expanded_paths.nextElement();
                if (model.tr_path_exists(tp)) {
                    jTree1.expandPath(tp);
                }
            }
        }
        card_wechsel_erlaubt = true;
        if (select_same) {
            gui_select_path(select_same_path, false, false);
        }

    }

    void gui_select_path(TreePath tp, boolean expand, boolean card_wechsel_verbieten) throws Exception {
        if (card_wechsel_verbieten) {
            card_wechsel_erlaubt = false;
        } else {
            jTree1.setSelectionPath(model.tr_get_node_root());
            jTree1.scrollPathToVisible(model.tr_get_node_root());
        }
        jTree1.setSelectionPath(tp);
        jTree1.scrollPathToVisible(tp);
        if (expand) {
            jTree1.expandPath(tp);
        }
        if (card_wechsel_verbieten) {
            card_wechsel_erlaubt = true;
        }
    }

    private void gui_update_stunde_wochenstunden() throws Exception {
        int anzahl = 0;
        if (jRadioWochenstunden1.isSelected()) {
            anzahl = 1;
        }
        if (jRadioWochenstunden2.isSelected()) {
            anzahl = 2;
        }
        if (jRadioWochenstunden3.isSelected()) {
            anzahl = 3;
        }
        Object node = jTree1.getLastSelectedPathComponent();
        if (node instanceof D_Stunde) {
            D_Stunde st = (D_Stunde) jTree1.getLastSelectedPathComponent();
            model.db_st_change_wochenstunden(st.id, anzahl);
            gui_select_path(model.tr_get_node_stunde(st.id), false, true);
        } else {
            D_Stunde_Ko st_ko = (D_Stunde_Ko) jTree1.getLastSelectedPathComponent();
            model.db_st_ko_change_wochenstunden(st_ko.id, anzahl);
            gui_select_path(model.tr_get_node_stunde_ko(st_ko.id), false, true);
        }

    }

    private void gui_update_stunde_typ() {
        try {
            int typ = 0;
            if (jRadioStundenTyp1.isSelected()) {
                typ = Config.STUNDEN_TYP_N;
            }
            if (jRadioStundenTyp2.isSelected()) {
                typ = Config.STUNDEN_TYP_D;
            }
            if (jRadioStundenTyp3.isSelected()) {
                typ = Config.STUNDEN_TYP_X;
            }
            Object node = jTree1.getLastSelectedPathComponent();
            if (node instanceof D_Stunde) {
                D_Stunde st = (D_Stunde) jTree1.getLastSelectedPathComponent();
                model.db_st_change_typ(st.id, typ);
                gui_select_path(model.tr_get_node_stunde(st.id), false, true);
            } else {
                D_Stunde_Ko st_ko = (D_Stunde_Ko) jTree1.getLastSelectedPathComponent();
                model.db_st_ko_change_typ(st_ko.id, typ);
                gui_select_path(model.tr_get_node_stunde_ko(st_ko.id), false, true);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }

    private void gui_update_stunde_lage_kl() {
        try {

            int lage = 0;
            if (jRadio_kl_Lage_Egal.isSelected()) {
                lage = Config.STUNDEN_LAGE_EGAL;
            }
            if (jRadio_kl_Lage_Anfang.isSelected()) {
                lage = Config.STUNDEN_LAGE_AM_ANFANG;
            }
            if (jRadio_kl_Lage_Nicht_Anfang.isSelected()) {
                lage = Config.STUNDEN_LAGE_NICHT_AM_ANFANG;
            }
            if (jRadio_kl_Lage_Ende.isSelected()) {
                lage = Config.STUNDEN_LAGE_AM_ENDE;
            }
            if (jRadio_kl_Lage_Nicht_Ende.isSelected()) {
                lage = Config.STUNDEN_LAGE_NICHT_AM_ENDE;
            }
            if (jRadio_kl_Lage_Rand.isSelected()) {
                lage = Config.STUNDEN_LAGE_AM_RAND;
            }
            if (jRadio_kl_Lage_Nicht_Rand.isSelected()) {
                lage = Config.STUNDEN_LAGE_NICHT_AM_RAND;
            }

            Object node = jTree1.getLastSelectedPathComponent();
            if (node instanceof D_Stunde) {
                D_Stunde st = (D_Stunde) jTree1.getLastSelectedPathComponent();
                model.db_st_change_lage_kl(st.id, lage);
                gui_select_path(model.tr_get_node_stunde(st.id), false, true);
            } else {
                D_Stunde_Ko st_ko = (D_Stunde_Ko) jTree1.getLastSelectedPathComponent();
                model.db_st_ko_change_lage_kl(st_ko.id, lage);
                gui_select_path(model.tr_get_node_stunde_ko(st_ko.id), false, true);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }

    private void gui_update_stunde_lage_le() {
        try {

            int lage = 0;
            if (jRadio_le2_Lage_Egal.isSelected()) {
                lage = Config.STUNDEN_LAGE_EGAL;
            }
            if (jRadio_le_Lage_Anfang.isSelected()) {
                lage = Config.STUNDEN_LAGE_AM_ANFANG;
            }
            if (jRadio_le_Lage_Nicht_Anfang.isSelected()) {
                lage = Config.STUNDEN_LAGE_NICHT_AM_ANFANG;
            }
            if (jRadio_le_Lage_Ende.isSelected()) {
                lage = Config.STUNDEN_LAGE_AM_ENDE;
            }
            if (jRadio_le_Lage_Nicht_Ende.isSelected()) {
                lage = Config.STUNDEN_LAGE_NICHT_AM_ENDE;
            }
            if (jRadio_le_Lage_Rand.isSelected()) {
                lage = Config.STUNDEN_LAGE_AM_RAND;
            }
            if (jRadio_le_Lage_Nicht_Rand.isSelected()) {
                lage = Config.STUNDEN_LAGE_NICHT_AM_RAND;
            }

            Object node = jTree1.getLastSelectedPathComponent();
            if (node instanceof D_Stunde) {
                D_Stunde st = (D_Stunde) jTree1.getLastSelectedPathComponent();
                model.db_st_change_lage_le(st.id, lage);
                gui_select_path(model.tr_get_node_stunde(st.id), false, true);
            } else {
                D_Stunde_Ko st_ko = (D_Stunde_Ko) jTree1.getLastSelectedPathComponent();
                model.db_st_ko_change_lage_le(st_ko.id, lage);
                gui_select_path(model.tr_get_node_stunde_ko(st_ko.id), false, true);
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }

    private void gui_plan_load(String data_column, String plan_data, String table, String id_column, int id) throws Exception {
        plan_table = table;
        plan_data_column = data_column;
        plan_id_column = id_column;
        plan_id = id;
        int max_t = model.get_d_schule().max_t;
        int max_s = model.get_d_schule().max_s;

        if (data_column.equals("plan")) {
            jLabel26.setText(ConfigS.LABEL_PLAN_SPALTE);
            jLabel27.setText(ConfigS.LABEL_PLAN_ZEILE);
            jLabel_max.setVisible(true);
            jLabel_max_s.setVisible(true);
            jLabel_max_s_ab.setVisible(true);
            for (int t = 0; t < 7; t++) {
                plan_tag_min[t].setVisible(t < max_t);
                plan_tag_max[t].setVisible(t < max_t);
                plan_tag_lab[t].setVisible(t < max_t);
                Config.add_items(plan_tag_min[t], true, 1, 16);
                Config.add_items(plan_tag_max[t], true, 0, 15);
            }
            for (int s = 0; s < 16; s++) {
                plan_stunde_min[s].setVisible(s < max_s);
                plan_stunde_max[s].setVisible(s < max_s);
                plan_stunde_ab_max[s].setVisible(s < max_s);
                plan_stunde_ab_min[s].setVisible(s < max_s);
                Config.add_items(plan_stunde_min[s], true, 1, 7);
                Config.add_items(plan_stunde_max[s], true, 0, 6);
                Config.add_items(plan_stunde_ab_max[s], true, 0, 99);
                Config.add_items(plan_stunde_ab_min[s], true, 1, 99);
            }
            for (int s = 0; s < 16; s++) {
                for (int t = 0; t < 7; t++) {
                    plan_stunde_tag[s][t].setVisible((t < max_t) && (s < max_s));
                    Config.add_items_plan_inner(plan_stunde_tag[s][t], true);
                }
            }
        }

        if (data_column.equals("planV") || data_column.equals("planO")) {
            jLabel26.setText(ConfigS.LABEL_PLANV_SPALTE);
            jLabel27.setText(ConfigS.LABEL_PLANV_ZEILE);
            jLabel_max.setVisible(false);
            jLabel_max_s.setVisible(false);
            jLabel_max_s_ab.setVisible(false);
            for (int t = 0; t < 7; t++) {
                plan_tag_min[t].setVisible(t < max_t);
                plan_tag_max[t].setVisible(false);
                plan_tag_lab[t].setVisible(t < max_t);
                Config.add_items(plan_tag_min[t], true, 1, 16 * 4);
                Config.add_items(plan_tag_max[t], true, 0, -1);
            }
            for (int s = 0; s < 16; s++) {
                plan_stunde_min[s].setVisible(s < max_s);
                plan_stunde_ab_min[s].setVisible(s < max_s);
                plan_stunde_max[s].setVisible(false);
                plan_stunde_ab_max[s].setVisible(false);
                Config.add_items(plan_stunde_min[s], true, 1, 99);
                Config.add_items(plan_stunde_ab_min[s], true, 1, 99);
                Config.add_items(plan_stunde_max[s], true, 0, -1);
                Config.add_items(plan_stunde_ab_max[s], true, 0, -1);
            }
            for (int s = 0; s < 16; s++) {
                for (int t = 0; t < 7; t++) {
                    plan_stunde_tag[s][t].setVisible((t < max_t) && (s < max_s));
                    Config.add_items(plan_stunde_tag[s][t], true, 0, 6);
                }
            }
        }

        // Daten laden
        String[] sSplit = plan_data.split(";");
        for (String line : sSplit) {
            String[] sSplit2 = line.split(",");
            if (sSplit2.length != 3) {
                continue;
            }
            int s = Integer.parseInt(sSplit2[0]);
            int t = Integer.parseInt(sSplit2[1]);
            String v = sSplit2[2];
            if (s == -2) {
                plan_tag_min[t].setSelectedItem(v);
                continue;
            }
            if (s == -1) {
                plan_tag_max[t].setSelectedItem(v);
                continue;
            }
            if ((s >= 0) && (t >= 0)) {
                plan_stunde_tag[s][t].setSelectedItem(v);
            }

            if (t == -1) {
                plan_stunde_min[s].setSelectedItem(v);
            }
            if (t == -2) {
                plan_stunde_max[s].setSelectedItem(v);
            }
            if (t == -3) {
                plan_stunde_ab_max[s].setSelectedItem(v);
            }
            if (t == -4) {
                plan_stunde_ab_min[s].setSelectedItem(v);
            }

        }

    }

    private void gui_plan_save() throws Exception {
        String plan_data = "";

        for (int t = 0; t < 7; t++) {
            String sValueTagMin = plan_tag_min[t].getSelectedItem().toString();
            if (!sValueTagMin.isBlank()) {
                plan_data = plan_data + ";-2," + t + "," + sValueTagMin;
            }
            String sValueTagMax = plan_tag_max[t].getSelectedItem().toString();
            if (!sValueTagMax.isBlank()) {
                plan_data = plan_data + ";-1," + t + "," + sValueTagMax;
            }
        }
        for (int s = 0; s < 16; s++) {
            String sValueStundeMin = plan_stunde_min[s].getSelectedItem().toString();
            if (!sValueStundeMin.isBlank()) {
                plan_data = plan_data + ";" + s + "," + (-1) + "," + sValueStundeMin;
            }
            String sValueStundeMax = plan_stunde_max[s].getSelectedItem().toString();
            if (!sValueStundeMax.isBlank()) {
                plan_data = plan_data + ";" + s + "," + (-2) + "," + sValueStundeMax;
            }
            String sValueStundeAbMax = plan_stunde_ab_max[s].getSelectedItem().toString();
            if (!sValueStundeAbMax.isBlank()) {
                plan_data = plan_data + ";" + s + "," + (-3) + "," + sValueStundeAbMax;
            }
            String sValueStundeAbMin = plan_stunde_ab_min[s].getSelectedItem().toString();
            if (!sValueStundeAbMin.isBlank()) {
                plan_data = plan_data + ";" + s + "," + (-4) + "," + sValueStundeAbMin;
            }
        }
        for (int s = 0; s < 16; s++) {
            for (int t = 0; t < 7; t++) {
                String sValueStundeTag = plan_stunde_tag[s][t].getSelectedItem().toString();
                if (!sValueStundeTag.isBlank()) {
                    plan_data = plan_data + ";" + s + "," + t + "," + sValueStundeTag;
                }
            }

        }

        model.db_pl_save(plan_table, plan_id_column, plan_id, plan_data_column, plan_data);

        if (plan_table.equals("schule")) {
            gui_select_path(model.tr_get_node_schule(), false, true);
        }
        if (plan_table.equals("lehrkraefte")) {
            gui_select_path(model.tr_get_node_lehrkraefte(), false, true);
        }
        if (plan_table.equals("lehrkraft")) {
            gui_select_path(model.tr_get_node_lehrkraft(plan_id), false, true);
        }
        if (plan_table.equals("klassen")) {
            gui_select_path(model.tr_get_node_klassen(), false, true);
        }
        if (plan_table.equals("klasse")) {
            gui_select_path(model.tr_get_node_klasse(plan_id), false, true);
        }
        if (plan_table.equals("raeume")) {
            gui_select_path(model.tr_get_node_raeume(), false, true);
        }
        if (plan_table.equals("raum")) {
            gui_select_path(model.tr_get_node_raum(plan_id), false, true);
        }
        if (plan_table.equals("kopplungen")) {
            gui_select_path(model.tr_get_node_kopplungen(), false, true);
        }
        if (plan_table.equals("kopplung")) {
            gui_select_path(model.tr_get_node_kopplung(plan_id), false, true);
        }
        if (plan_table.equals("kurse")) {
            gui_select_path(model.tr_get_node_kurse(), false, true);
        }
        if (plan_table.equals("kurs")) {
            gui_select_path(model.tr_get_node_kurs(plan_id), false, true);
        }
        if (plan_table.equals("stunde")) {
            gui_select_path(model.tr_get_node_stunde(plan_id), false, true);
        }
        if (plan_table.equals("stunde_ko")) {
            gui_select_path(model.tr_get_node_stunde_ko(plan_id), false, true);
        }

    }

    private void gui_plan_show_vertretungsreserven() {
        try {
            VIEW = VIEW_VERTRETUNGSRESERVEN;
            jTree1ValueChanged(null);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }

    private void gui_plan_show_vertretungsoptionen() {
        try {
            VIEW = VIEW_VERTRETUNGSOPTIONEN;
            jTree1ValueChanged(null);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }

    private void gui_update_kurse_sort() {
        try {

            int sortierung = 0;
            if (jRadio_ku_sort_kl_fa_le.isSelected()) {
                sortierung = Config.KURSE_SORTIEREN_NACH_KL_FA_LE;
            }
            if (jRadio_ku_sort_kl_le_fa.isSelected()) {
                sortierung = Config.KURSE_SORTIEREN_NACH_KL_LE_FA;
            }
            if (jRadio_ku_sort_le_kl_fa.isSelected()) {
                sortierung = Config.KURSE_SORTIEREN_NACH_LE_KL_FA;
            }
            if (jRadio_ku_sort_le_fa_kl.isSelected()) {
                sortierung = Config.KURSE_SORTIEREN_NACH_LE_FA_KL;
            }
            if (jRadio_ku_sort_fa_kl_le.isSelected()) {
                sortierung = Config.KURSE_SORTIEREN_NACH_FA_KL_LE;
            }
            if (jRadio_ku_sort_fa_le_kl.isSelected()) {
                sortierung = Config.KURSE_SORTIEREN_NACH_FA_LE_KL;
            }

            D_Kurse kua = (D_Kurse) jTree1.getLastSelectedPathComponent();
            model.db_kua_sortiere_nach(kua.id, sortierung);
            gui_select_path(model.tr_get_node_kurse(), false, true);
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }

    private void execute(int nr) {
        try {
            switch (nr) {
                case ACTION_SPECIAL_VIEW_SHOW_PLAN -> {
                    VIEW = VIEW_PLAN;
                    jTree1ValueChanged(null);
                }
                case ACTION_LEA_ERZEUGE_NEUE_LEHRKRAFT -> {
                    int id = model.db_le_erzeugen("?", "", "");
                    gui_select_path(model.tr_get_node_lehrkraft(id), false, false);
                }
                case ACTION_LEA_ALLE_LOESCHEN -> {
                    if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Lehrkräfte löschen?", "Alle Lehrkräfte löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                        model.db_le_alle_loeschen();
                        gui_select_path(model.tr_get_node_lehrkraefte(), false, false);
                    }
                }

                case 200 -> {
                }
                case 250 -> {
                }
                case 300 -> {
                }
                case 350 -> {
                }
                case 400 -> {
                }
                case 450 -> {
                }
                case 500 -> {
                }
                case 550 -> {
                }
                case 600 -> {
                }
                case 650 -> {
                }
                case 700 -> {
                }
                case ACTION_BEA_STARTE_BERECHNUNG -> {
                    int id = model.db_be_erzeugen();
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_ALLE_BERECHNUNGEN_BEENDEN_UND_LOESCHEN -> {
                    if (JOptionPane.showConfirmDialog(this, "Wollen Sie wirklich alle Berechnungen beenden und löschen?", "Alle Berechnungen beenden und löschen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
                        model.db_be_alle_beenden_und_loeschen();
                        gui_select_path(model.tr_get_node_berechnungen(), false, false);
                    }
                }
                case ACTION_BEA_CHECKBOX_LE_FREIE_TAGE -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_freie_tage(bea.id, bea_1.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_ERST_AB_STUNDE -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_erst_ab_stunde(bea.id, bea_2.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_NUR_BIS_STUNDE -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_nur_bis_stunde(bea.id, bea_3.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_SPRINGSTUNDEN_TAG -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_springstunden_tag(bea.id, bea_4.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_SPRINGSTUNDEN_WOCHE -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_springstunden_woche(bea.id, bea_5.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_TAGESSTUNDENPRAESENZ -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_tagesstundenpraesenz(bea.id, bea_6.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_MIN_STUNDEN_PRO_TAG -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_min_stunden_pro_tag(bea.id, bea_7.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_MAX_STUNDEN_IN_FOLGE -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_max_stunden_in_folge(bea.id, bea_8.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_PLAN_SPALTE_MIN -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_plan_spalte_min(bea.id, bea_9.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_PLAN_SPALTE_MAX -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_plan_spalte_max(bea.id, bea_10.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MIN -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_plan_zeile_min(bea.id, bea_11.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MAX -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_plan_zeile_max(bea.id, bea_12.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MIN_AB -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_plan_zeile_min_ab(bea.id, bea_13.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_PLAN_ZEILE_MAX_AB -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_plan_zeile_max_ab(bea.id, bea_14.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
                case ACTION_BEA_CHECKBOX_LE_PLAN_ZELLEN -> {
                    D_Berechnungen bea = (D_Berechnungen) jTree1.getLastSelectedPathComponent();
                    model.db_bea_change_deaktiviere_le_plan_zellen(bea.id, bea_15.isSelected());
                    gui_select_path(model.tr_get_node_berechnungen(), false, false);
                }
            }
        } catch (Exception ex) {
            handle_exception(ex);
        }
    }

}
